/*!
 * tui-image-editor.min.js
 * @version 3.7.3
 * @author NHN FE Development Lab <dl_javascript@nhn.com>
 * @license MIT
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(require("tui-code-snippet"),require("fabric").fabric,require("tui-color-picker")):"function"==typeof define&&define.amd?define(["tui-code-snippet","fabric","tui-color-picker"],t):"object"==typeof exports?exports.ImageEditor=t(require("tui-code-snippet"),require("fabric").fabric,require("tui-color-picker")):(e.tui=e.tui||{},e.tui.ImageEditor=t(e.tui&&e.tui.util,e.fabric,e.tui&&e.tui.colorPicker))}(window,function(n,i,a){return s={},o.m=r=[function(e,t,n){"use strict";var i,a=n(4),o=(i=a)&&i.__esModule?i:{default:i};e.exports={componentNames:o.default.keyMirror("IMAGE_LOADER","CROPPER","FLIP","ROTATION","FREE_DRAWING","LINE","TEXT","ICON","FILTER","SHAPE"),commandNames:{CLEAR_OBJECTS:"clearObjects",LOAD_IMAGE:"loadImage",FLIP_IMAGE:"flip",ROTATE_IMAGE:"rotate",ADD_OBJECT:"addObject",REMOVE_OBJECT:"removeObject",APPLY_FILTER:"applyFilter",REMOVE_FILTER:"removeFilter",ADD_ICON:"addIcon",CHANGE_ICON_COLOR:"changeIconColor",ADD_SHAPE:"addShape",CHANGE_SHAPE:"changeShape",ADD_TEXT:"addText",CHANGE_TEXT:"changeText",CHANGE_TEXT_STYLE:"changeTextStyle",ADD_IMAGE_OBJECT:"addImageObject",RESIZE_CANVAS_DIMENSION:"resizeCanvasDimension",SET_OBJECT_PROPERTIES:"setObjectProperties",SET_OBJECT_POSITION:"setObjectPosition"},eventNames:{OBJECT_ACTIVATED:"objectActivated",OBJECT_MOVED:"objectMoved",OBJECT_SCALED:"objectScaled",OBJECT_CREATED:"objectCreated",TEXT_EDITING:"textEditing",TEXT_CHANGED:"textChanged",ICON_CREATE_RESIZE:"iconCreateResize",ICON_CREATE_END:"iconCreateEnd",ADD_TEXT:"addText",ADD_OBJECT:"addObject",ADD_OBJECT_AFTER:"addObjectAfter",MOUSE_DOWN:"mousedown",MOUSE_UP:"mouseup",MOUSE_MOVE:"mousemove",REDO_STACK_CHANGED:"redoStackChanged",UNDO_STACK_CHANGED:"undoStackChanged",SELECTION_CLEARED:"selectionCleared",SELECTION_CREATED:"selectionCreated"},drawingModes:o.default.keyMirror("NORMAL","CROPPER","FREE_DRAWING","LINE_DRAWING","TEXT","SHAPE"),keyCodes:{Z:90,Y:89,SHIFT:16,BACKSPACE:8,DEL:46},fObjectOptions:{SELECTION_STYLE:{borderColor:"red",cornerColor:"green",cornerSize:10,originX:"center",originY:"center",transparentCorners:!1}},rejectMessages:{addedObject:"The object is already added.",flip:"The flipX and flipY setting values are not changed.",invalidDrawingMode:"This operation is not supported in the drawing mode.",invalidParameters:"Invalid parameters.",isLock:"The executing command state is locked.",loadImage:"The background image is empty.",loadingImageFailed:"Invalid image loaded.",noActiveObject:"There is no active object.",noObject:"The object is not in canvas.",redo:"The promise of redo command is reject.",rotation:"The current angle is same the old angle.",undo:"The promise of undo command is reject.",unsupportedOperation:"Unsupported operation.",unsupportedType:"Unsupported object type."},defaultIconPath:{"icon-arrow":"M40 12V0l24 24-24 24V36H0V12h40z","icon-arrow-2":"M49,32 H3 V22 h46 l-18,-18 h12 l23,23 L43,50 h-12 l18,-18  z ","icon-arrow-3":"M43.349998,27 L17.354,53 H1.949999 l25.996,-26 L1.949999,1 h15.404 L43.349998,27  z ","icon-star":"M35,54.557999 l-19.912001,10.468 l3.804,-22.172001 l-16.108,-15.7 l22.26,-3.236 L35,3.746 l9.956,20.172001 l22.26,3.236 l-16.108,15.7 l3.804,22.172001  z ","icon-star-2":"M17,31.212 l-7.194,4.08 l-4.728,-6.83 l-8.234,0.524 l-1.328,-8.226 l-7.644,-3.14 l2.338,-7.992 l-5.54,-6.18 l5.54,-6.176 l-2.338,-7.994 l7.644,-3.138 l1.328,-8.226 l8.234,0.522 l4.728,-6.83 L17,-24.312 l7.194,-4.08 l4.728,6.83 l8.234,-0.522 l1.328,8.226 l7.644,3.14 l-2.338,7.992 l5.54,6.178 l-5.54,6.178 l2.338,7.992 l-7.644,3.14 l-1.328,8.226 l-8.234,-0.524 l-4.728,6.83  z ","icon-polygon":"M3,31 L19,3 h32 l16,28 l-16,28 H19  z ","icon-location":"M24 62C8 45.503 0 32.837 0 24 0 10.745 10.745 0 24 0s24 10.745 24 24c0 8.837-8 21.503-24 38zm0-28c5.523 0 10-4.477 10-10s-4.477-10-10-10-10 4.477-10 10 4.477 10 10 10z","icon-heart":"M49.994999,91.349998 l-6.96,-6.333 C18.324001,62.606995 2.01,47.829002 2.01,29.690998 C2.01,14.912998 13.619999,3.299999 28.401001,3.299999 c8.349,0 16.362,5.859 21.594,12 c5.229,-6.141 13.242001,-12 21.591,-12 c14.778,0 26.390999,11.61 26.390999,26.390999 c0,18.138 -16.314001,32.916 -41.025002,55.374001 l-6.96,6.285  z ","icon-bubble":"M44 48L34 58V48H12C5.373 48 0 42.627 0 36V12C0 5.373 5.373 0 12 0h40c6.627 0 12 5.373 12 12v24c0 6.627-5.373 12-12 12h-8z"},defaultRotateRangeValus:{realTimeEvent:!0,min:-360,max:360,value:0},defaultDrawRangeValus:{min:5,max:30,value:12},defaultShapeStrokeValus:{realTimeEvent:!1,min:2,max:300,value:3},defaultTextRangeValus:{realTimeEvent:!0,min:10,max:100,value:50},defaultFilterRangeValus:{tintOpacityRange:{min:0,max:1,value:.7},removewhiteDistanceRange:{min:0,max:1,value:.2},brightnessRange:{min:-1,max:1,value:0},noiseRange:{min:0,max:1e3,value:100},pixelateRange:{min:2,max:20,value:4},colorfilterThresholeRange:{min:0,max:1,value:.2}}}},function(e,t){e.exports=n},function(e,t,n){n(46),n(47),n(62),n(66),e.exports=n(12).Promise},function(e,t,n){"use strict";var i,a=n(79),o=(i=a)&&i.__esModule?i:{default:i};var r={};e.exports={create:function(e){var t=r[e];if(t){for(var n=arguments.length,i=Array(1<n?n-1:0),a=1;a<n;a++)i[a-1]=arguments[a];return new o.default(t,i)}return null},register:function(e){r[e.name]=e}}},function(e,t,n){"use strict";var a=n(1),o=Math.min,r=Math.max,i=!1;e.exports={clamp:function(e,t,n){var i=void 0;return n<t&&(i=t,t=n,n=i),r(t,o(e,n))},keyMirror:function(){for(var t={},e=arguments.length,n=Array(e),i=0;i<e;i++)n[i]=arguments[i];return(0,a.forEach)(n,function(e){t[e]=e}),t},makeStyleText:function(e){var n="";return(0,a.forEach)(e,function(e,t){n+=t+": "+e+";"}),n},getProperties:function(e,t){var n={},i=t.length,a=0,o=void 0;for(a=0;a<i;a+=1)n[o=t[a]]=e[o];return n},toInteger:function(e){return parseInt(e,10)},toCamelCase:function(e){return e.replace(/-([a-z])/g,function(e,t){return t.toUpperCase()})},isSupportFileApi:function(){return!!(window.File&&window.FileList&&window.FileReader)},getRgb:function(e,t){return 4===e.length&&(e=""+e+e.slice(1,4)),"rgba("+parseInt(e.slice(1,3),16)+", "+parseInt(e.slice(3,5),16)+", "+parseInt(e.slice(5,7),16)+", "+(t||1)+")"},sendHostName:function(){i||(i=!0,(0,a.sendHostname)("image-editor","UA-129999381-1"))},styleLoad:function(e,t){var n=document.getElementsByTagName("head")[0],i=document.createElement("link"),a=encodeURIComponent(e);t&&(i.id=t),i.setAttribute("rel","stylesheet"),i.setAttribute("type","text/css"),i.setAttribute("href","data:text/css;charset=UTF-8,"+a),n.appendChild(i)},getSelector:function(t){return function(e){return t.querySelector(e)}},base64ToBlob:function(e){var n="",t=void 0,i=void 0,a=void 0;t=e.replace(/data:(image\/.+);base64,/,function(e,t){return n=t,""});var o=(t=atob(t)).length;for(i=new Uint8Array(o),a=0;a<o;a+=1)i[a]=t.charCodeAt(a);return new Blob([i],{type:n})},fixFloatingPoint:function(e){return Number(e.toFixed(2))}}},function(e,t){e.exports=i},function(e,t,n){var i=n(36)("wks"),a=n(37),o=n(7).Symbol,r="function"==typeof o;(e.exports=function(e){return i[e]||(i[e]=r&&o[e]||(r?o:a)("Symbol."+e))}).store=i},function(e,t){var n=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=n)},function(e,t,n){"use strict";function i(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var a=(function(e,t,n){return t&&i(e.prototype,t),n&&i(e,n),e}(o,[{key:"fire",value:function(){for(var e=this.graphics,t=arguments.length,n=Array(t),i=0;i<t;i++)n[i]=arguments[i];return this.graphics.fire.apply(e,n)}},{key:"setCanvasImage",value:function(e,t){this.graphics.setCanvasImage(e,t)}},{key:"getCanvasElement",value:function(){return this.graphics.getCanvasElement()}},{key:"getCanvas",value:function(){return this.graphics.getCanvas()}},{key:"getCanvasImage",value:function(){return this.graphics.getCanvasImage()}},{key:"getImageName",value:function(){return this.graphics.getImageName()}},{key:"getEditor",value:function(){return this.graphics.getEditor()}},{key:"getName",value:function(){return this.name}},{key:"setImageProperties",value:function(e,t){this.graphics.setImageProperties(e,t)}},{key:"setCanvasCssDimension",value:function(e){this.graphics.setCanvasCssDimension(e)}},{key:"setCanvasBackstoreDimension",value:function(e){this.graphics.setCanvasBackstoreDimension(e)}},{key:"adjustCanvasDimension",value:function(){this.graphics.adjustCanvasDimension()}}]),o);function o(e,t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),this.name=e,this.graphics=t}e.exports=a},function(e,t,n){"use strict";function i(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}Object.defineProperty(t,"__esModule",{value:!0});var a=(function(e,t,n){return t&&i(e.prototype,t),n&&i(e,n),e}(l,[{key:"selector",value:function(e){return this.subMenuElement.querySelector(e)}},{key:"colorPickerChangeShow",value:function(t){this.colorPickerControls.forEach(function(e){t!==e&&e.hide()})}},{key:"getButtonType",value:function(e,t){return e.className.match(RegExp("("+t.join("|")+")"))[0]}},{key:"changeClass",value:function(e,t,n){e.classList.remove(t),e.classList.add(n)}},{key:"changeStandbyMode",value:function(){}},{key:"changeStartMode",value:function(){}},{key:"_makeSubMenuElement",value:function(e){var t=e.locale,n=e.name,i=e.iconStyle,a=e.templateHtml,o=document.createElement("div");o.className="tui-image-editor-menu-"+n,o.innerHTML=a({locale:t,iconStyle:i}),this.subMenuElement.appendChild(o)}}]),l);function l(e,t){var n=t.locale,i=t.name,a=t.iconStyle,o=t.menuBarPosition,r=t.templateHtml,s=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,l),this.subMenuElement=e,this.menuBarPosition=o,this.toggleDirection="top"===o?"down":"up",this.colorPickerControls=[],this.usageStatistics=s,this._makeSubMenuElement({locale:n,name:i,iconStyle:a,templateHtml:r})}t.default=a},function(e,t,n){var i=n(19),a=n(34);e.exports=n(13)?function(e,t,n){return i.f(e,t,a(1,n))}:function(e,t,n){return e[t]=n,e}},function(e,t,n){var i=n(20);e.exports=function(e){if(!i(e))throw TypeError(e+" is not an object!");return e}},function(e,t){var n=e.exports={version:"2.4.0"};"number"==typeof __e&&(__e=n)},function(e,t,n){e.exports=!n(33)(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})},function(e,t){e.exports={}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(1)),r=s(n(87));function s(e){return e&&e.__esModule?e:{default:e}}var l=["#000000","#2a2a2a","#545454","#7e7e7e","#a8a8a8","#d2d2d2","#ffffff","","#ff4040","#ff6518","#ffbb3b","#03bd9e","#00a9ff","#515ce6","#9e5fff","#ff5583"],c=(i(u,[{key:"_changeColorElement",value:function(e){e?(this.colorElement.classList.remove("transparent"),this.colorElement.style.backgroundColor=e):(this.colorElement.style.backgroundColor="#fff",this.colorElement.classList.add("transparent"))}},{key:"_makePickerButtonElement",value:function(e,t){e.classList.add("tui-image-editor-button"),this.colorElement=document.createElement("div"),this.colorElement.className="color-picker-value",t?this.colorElement.style.backgroundColor=t:this.colorElement.classList.add("transparent")}},{key:"_makePickerLayerElement",value:function(e,t){var n=document.createElement("label"),i=document.createElement("div");this.pickerControl=document.createElement("div"),this.pickerControl.className="color-picker-control",this.pickerElement=document.createElement("div"),this.pickerElement.className="color-picker",n.innerHTML=t,i.className="triangle",this.pickerControl.appendChild(this.pickerElement),this.pickerControl.appendChild(i),e.appendChild(this.pickerControl),e.appendChild(this.colorElement),e.appendChild(n)}},{key:"_addEvent",value:function(e){var i=this;this.picker.on("selectColor",function(e){i._changeColorElement(e.color),i._color=e.color,i.fire("change",e.color)}),e.addEventListener("click",function(e){var t=e.target,n=t&&i._isElementInColorPickerControl(t);(!n||n&&i._isPaletteButton(t))&&(i._show=!i._show,i.pickerControl.style.display=i._show?"block":"none",i._setPickerControlPosition(),i.fire("changeShow",i)),e.stopPropagation()}),document.body.addEventListener("click",function(){i.hide()})}},{key:"_isPaletteButton",value:function(e){return"tui-colorpicker-palette-button"===e.className}},{key:"_isElementInColorPickerControl",value:function(e){for(var t=e;t!==document.body&&t;){if(t===this.pickerControl)return!0;t=t.parentNode}return!1}},{key:"hide",value:function(){this._show=!1,this.pickerControl.style.display="none"}},{key:"_setPickerControlPosition",value:function(){var e=this.pickerControl.style,t=this._colorpickerElement.clientWidth/2+2,n=this.pickerControl.offsetWidth/2-t,i=-1*(this.pickerControl.offsetHeight+10);"down"===this._toggleDirection&&(i=30),e.top=i+"px",e.left="-"+n+"px"}},{key:"color",get:function(){return this._color},set:function(e){this._color=e,this._changeColorElement(e)}}]),u);function u(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:"#7e7e7e",n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"up",i=arguments[3];!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u);var a=e.getAttribute("title");this.usageStatistics=i,this._show=!1,this._colorpickerElement=e,this._toggleDirection=n,this._makePickerButtonElement(e,t),this._makePickerLayerElement(e,a),this._color=t,this.picker=r.default.create({container:this.pickerElement,preset:l,color:t,usageStatistics:this.usageStatistics}),this._addEvent(e)}o.default.CustomEvents.mixin(c),t.default=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o,r=n(1),s=(o=r)&&o.__esModule?o:{default:o},l=n(4);var c=(i(u,[{key:"trigger",value:function(e){this.fire(e,this._value)}},{key:"_drawRangeElement",value:function(){this.rangeElement.classList.add("tui-image-editor-range"),this.bar=document.createElement("div"),this.bar.className="tui-image-editor-virtual-range-bar",this.subbar=document.createElement("div"),this.subbar.className="tui-image-editor-virtual-range-subbar",this.pointer=document.createElement("div"),this.pointer.className="tui-image-editor-virtual-range-pointer",this.bar.appendChild(this.subbar),this.bar.appendChild(this.pointer),this.rangeElement.appendChild(this.bar)}},{key:"_addClickEvent",value:function(){var i=this;this.rangeElement.addEventListener("click",function(e){if(e.stopPropagation(),"tui-image-editor-range"===e.target.className){var t=e.offsetX/i.rangeWidth,n=i._absMax*t+i._min;i.pointer.style.left=t*i.rangeWidth+"px",i.subbar.style.right=(1-t)*i.rangeWidth+"px",i._value=n,i.fire("change",n,!0)}})}},{key:"_addDragEvent",value:function(){var t=this;this.pointer.addEventListener("mousedown",function(e){t.firstPosition=e.screenX,t.firstLeft=(0,l.toInteger)(t.pointer.style.left)||0,t.dragEventHandler={changeAngle:t._changeAngle.bind(t),stopChangingAngle:t._stopChangingAngle.bind(t)},document.addEventListener("mousemove",t.dragEventHandler.changeAngle),document.addEventListener("mouseup",t.dragEventHandler.stopChangingAngle)})}},{key:"_changeAngle",value:function(e){var t=e.screenX-this.firstPosition,n=this.firstLeft+t;n=(n=n>this.rangeWidth?this.rangeWidth:n)<0?0:n,this.pointer.style.left=n+"px",this.subbar.style.right=this.rangeWidth-n+"px";var i=n/this.rangeWidth,a=this._absMax*i+this._min;this._value=a,this.realTimeEvent&&this.fire("change",a,!1)}},{key:"_stopChangingAngle",value:function(){this.fire("change",this._value,!0),document.removeEventListener("mousemove",this.dragEventHandler.changeAngle),document.removeEventListener("mouseup",this.dragEventHandler.stopChangingAngle)}},{key:"max",set:function(e){this._max=e,this._absMax=-1*this._min+this._max,this.value=this._value},get:function(){return this._max}},{key:"value",get:function(){return this._value},set:function(e){var t=(e-this._min)*this.rangeWidth/this._absMax;this.rangeWidth<t&&(t=this.rangeWidth),this.pointer.style.left=t+"px",this.subbar.style.right=this.rangeWidth-t+"px",this._value=e}}]),u);function u(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u),this._value=t.value||0,this.rangeElement=e,this._drawRangeElement(),this.rangeWidth=(0,l.toInteger)(window.getComputedStyle(e,null).width)-12,this._min=t.min||0,this._max=t.max||100,this._absMax=-1*this._min+this._max,this.realTimeEvent=t.realTimeEvent||!1,this._addClickEvent(),this._addDragEvent(),this.value=t.value,this.trigger("change")}s.default.CustomEvents.mixin(c),t.default=c},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o,r=n(42),s=(o=r)&&o.__esModule?o:{default:o};var l=s.default.create,c=s.default.types,u=(i(d,[{key:"getName",value:function(){return this.name}},{key:"start",value:function(){throw new Error(l(c.UN_IMPLEMENTATION,"start"))}},{key:"stop",value:function(){throw new Error(l(c.UN_IMPLEMENTATION,"stop"))}}]),d);function d(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),this.name=e}e.exports=u},function(e,t,n){var o=n(25);e.exports=function(i,a,e){if(o(i),void 0===a)return i;switch(e){case 1:return function(e){return i.call(a,e)};case 2:return function(e,t){return i.call(a,e,t)};case 3:return function(e,t,n){return i.call(a,e,t,n)}}return function(){return i.apply(a,arguments)}}},function(e,t,n){var i=n(11),a=n(49),o=n(50),r=Object.defineProperty;t.f=n(13)?Object.defineProperty:function(e,t,n){if(i(e),t=o(t,!0),i(n),a)try{return r(e,t,n)}catch(e){}if("get"in n||"set"in n)throw TypeError("Accessors not supported!");return"value"in n&&(e[t]=n.value),e}},function(e,t){e.exports=function(e){return"object"==typeof e?null!==e:"function"==typeof e}},function(e,t){var n={}.hasOwnProperty;e.exports=function(e,t){return n.call(e,t)}},function(e,t){var n={}.toString;e.exports=function(e){return n.call(e).slice(8,-1)}},function(e,t){var n=Math.ceil,i=Math.floor;e.exports=function(e){return isNaN(e=+e)?0:(0<e?i:n)(e)}},function(e,t){e.exports=function(e){if(null==e)throw TypeError("Can't call method on  "+e);return e}},function(e,t){e.exports=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e}},function(e,t,n){var i=n(20),a=n(7).document,o=i(a)&&i(a.createElement);e.exports=function(e){return o?a.createElement(e):{}}},function(e,t,n){var i=n(57),a=n(24);e.exports=function(e){return i(a(e))}},function(e,t,n){var i=n(36)("keys"),a=n(37);e.exports=function(e){return i[e]||(i[e]=a(e))}},function(e,t,n){var i=n(19).f,a=n(21),o=n(6)("toStringTag");e.exports=function(e,t,n){e&&!a(e=n?e:e.prototype,o)&&i(e,o,{configurable:!0,value:t})}},function(e,t,n){"use strict";function y(){return this}var _=n(31),k=n(32),w=n(51),x=n(10),E=n(21),C=n(14),O=n(52),S=n(29),j=n(60),M=n(6)("iterator"),T=!([].keys&&"next"in[].keys()),P="values";e.exports=function(e,t,n,i,a,o,r){O(n,t,i);function s(e){if(!T&&e in p)return p[e];switch(e){case"keys":case P:return function(){return new n(this,e)}}return function(){return new n(this,e)}}var l,c,u,d=t+" Iterator",h=a==P,f=!1,p=e.prototype,g=p[M]||p["@@iterator"]||a&&p[a],v=g||s(a),m=a?h?s("entries"):v:void 0,b="Array"==t&&p.entries||g;if(b&&(u=j(b.call(new e)))!==Object.prototype&&(S(u,d,!0),_||E(u,M)||x(u,M,y)),h&&g&&g.name!==P&&(f=!0,v=function(){return g.call(this)}),_&&!r||!T&&!f&&p[M]||x(p,M,v),C[t]=v,C[d]=y,a)if(l={values:h?v:s(P),keys:o?v:s("keys"),entries:m},r)for(c in l)c in p||w(p,c,l[c]);else k(k.P+k.F*(T||f),t,l);return l}},function(e,t){e.exports=!0},function(e,t,n){var g=n(7),v=n(12),m=n(18),b=n(10),y="prototype",_=function(e,t,n){var i,a,o,r=e&_.F,s=e&_.G,l=e&_.S,c=e&_.P,u=e&_.B,d=e&_.W,h=s?v:v[t]||(v[t]={}),f=h[y],p=s?g:l?g[t]:(g[t]||{})[y];for(i in s&&(n=t),n)(a=!r&&p&&void 0!==p[i])&&i in h||(o=a?p[i]:n[i],h[i]=s&&"function"!=typeof p[i]?n[i]:u&&a?m(o,g):d&&p[i]==o?function(i){function e(e,t,n){if(this instanceof i){switch(arguments.length){case 0:return new i;case 1:return new i(e);case 2:return new i(e,t)}return new i(e,t,n)}return i.apply(this,arguments)}return e[y]=i[y],e}(o):c&&"function"==typeof o?m(Function.call,o):o,c&&((h.virtual||(h.virtual={}))[i]=o,e&_.R&&f&&!f[i]&&b(f,i,o)))};_.F=1,_.G=2,_.S=4,_.P=8,_.B=16,_.W=32,_.U=64,_.R=128,e.exports=_},function(e,t){e.exports=function(e){try{return!!e()}catch(e){return!0}}},function(e,t){e.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},function(e,t,n){var i=n(23),a=Math.min;e.exports=function(e){return 0<e?a(i(e),9007199254740991):0}},function(e,t,n){var i=n(7),a="__core-js_shared__",o=i[a]||(i[a]={});e.exports=function(e){return o[e]||(o[e]={})}},function(e,t){var n=0,i=Math.random();e.exports=function(e){return"Symbol(".concat(void 0===e?"":e,")_",(++n+i).toString(36))}},function(e,t){e.exports="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",")},function(e,t,n){e.exports=n(7).document&&document.documentElement},function(e,t,n){var a=n(22),o=n(6)("toStringTag"),r="Arguments"==a(function(){return arguments}());e.exports=function(e){var t,n,i;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(n=function(e,t){try{return e[t]}catch(e){}}(t=Object(e),o))?n:r?a(t):"Object"==(i=a(t))&&"function"==typeof t.callee?"Arguments":i}},function(e,t,n){function i(){var e=+this;if(b.hasOwnProperty(e)){var t=b[e];delete b[e],t()}}function a(e){i.call(e.data)}var o,r,s,l=n(18),c=n(73),u=n(39),d=n(26),h=n(7),f=h.process,p=h.setImmediate,g=h.clearImmediate,v=h.MessageChannel,m=0,b={},y="onreadystatechange";p&&g||(p=function(e){for(var t=[],n=1;n<arguments.length;)t.push(arguments[n++]);return b[++m]=function(){c("function"==typeof e?e:Function(e),t)},o(m),m},g=function(e){delete b[e]},"process"==n(22)(f)?o=function(e){f.nextTick(l(i,e,1))}:v?(s=(r=new v).port2,r.port1.onmessage=a,o=l(s.postMessage,s,1)):h.addEventListener&&"function"==typeof postMessage&&!h.importScripts?(o=function(e){h.postMessage(e+"","*")},h.addEventListener("message",a,!1)):o=y in d("script")?function(e){u.appendChild(d("script"))[y]=function(){u.removeChild(this),i.call(e)}}:function(e){setTimeout(l(i,e,1),0)}),e.exports={set:p,clear:g}},function(e,t,n){"use strict";var i,a=n(1),o=(i=a)&&i.__esModule?i:{default:i};var r=(0,n(4).keyMirror)("UN_IMPLEMENTATION","NO_COMPONENT_NAME"),s="Should implement a method: ",l="Should set a component name",c={UN_IMPLEMENTATION:function(e){return s+e},NO_COMPONENT_NAME:function(){return l}};e.exports={types:o.default.extend({},r),create:function(e){e=e.toLowerCase();for(var t=c[e],n=arguments.length,i=Array(1<n?n-1:0),a=1;a<n;a++)i[a-1]=arguments[a];return t.apply(void 0,i)}}},function(e,t,n){"use strict";n(44);var i,a=n(45),o=(i=a)&&i.__esModule?i:{default:i};n(131),n(132),n(133),n(134),n(135),n(136),n(137),n(138),n(139),n(140),n(141),n(142),n(143),n(144),n(145),n(146),n(147),n(148),n(149),n(150),e.exports=o.default},function(e,t,n){"use strict";Element.prototype.matches=Element.prototype.msMatchesSelector||Element.prototype.webkitMatchesSelector,Element.prototype.closest||(Element.prototype.closest=function(e){var t=this;if(!document.documentElement.contains(t))return null;do{if(t.matches(e))return t;t=t.parentElement||t.parentNode}while(null!==t&&1===t.nodeType);return null})
/*! @source http://purl.eligrey.com/github/classList.js/blob/master/classList.js */,"document"in window.self&&("classList"in document.createElement("_")&&(!document.createElementNS||"classList"in document.createElementNS("http://www.w3.org/2000/svg","g"))||function(e){if("Element"in e){var t="classList",n="prototype",i=e.Element[n],a=Object,o=String[n].trim||function(){return this.replace(/^\s+|\s+$/g,"")},r=Array[n].indexOf||function(e){for(var t=0,n=this.length;t<n;t++)if(t in this&&this[t]===e)return t;return-1},s=function(e,t){this.name=e,this.code=DOMException[e],this.message=t},l=function(e,t){if(""===t)throw new s("SYNTAX_ERR","An invalid or illegal string was specified");if(/\s/.test(t))throw new s("INVALID_CHARACTER_ERR","String contains an invalid character");return r.call(e,t)},c=function(e){for(var t=o.call(e.getAttribute("class")||""),n=t?t.split(/\s+/):[],i=0,a=n.length;i<a;i++)this.push(n[i]);this._updateClassName=function(){e.setAttribute("class",this.toString())}},u=c[n]=[],d=function(){return new c(this)};if(s[n]=Error[n],u.item=function(e){return this[e]||null},u.contains=function(e){return-1!==l(this,e+="")},u.add=function(){for(var e,t=arguments,n=0,i=t.length,a=!1;-1===l(this,e=t[n]+"")&&(this.push(e),a=!0),++n<i;);a&&this._updateClassName()},u.remove=function(){var e,t,n=arguments,i=0,a=n.length,o=!1;do{for(t=l(this,e=n[i]+"");-1!==t;)this.splice(t,1),o=!0,t=l(this,e)}while(++i<a);o&&this._updateClassName()},u.toggle=function(e,t){e+="";var n=this.contains(e),i=n?!0!==t&&"remove":!1!==t&&"add";return i&&this[i](e),!0===t||!1===t?t:!n},u.toString=function(){return this.join(" ")},a.defineProperty){var h={get:d,enumerable:!0,configurable:!0};try{a.defineProperty(i,t,h)}catch(e){void 0!==e.number&&-2146823252!==e.number||(h.enumerable=!1,a.defineProperty(i,t,h))}}else a[n].__defineGetter__&&i.__defineGetter__(t,d)}}(window.self),function(){var e=document.createElement("_");if(e.classList.add("c1","c2"),!e.classList.contains("c2")){var t=function(e){var i=DOMTokenList.prototype[e];DOMTokenList.prototype[e]=function(e){var t,n=arguments.length;for(t=0;t<n;t++)e=arguments[t],i.call(this,e)}};t("add"),t("remove")}if(e.classList.toggle("c3",!1),e.classList.contains("c3")){var n=DOMTokenList.prototype.toggle;DOMTokenList.prototype.toggle=function(e,t){return 1 in arguments&&!this.contains(e)==!t?t:n.call(this,e)}}e=null}()),
/*!
 * @copyright Copyright (c) 2017 IcoMoon.io
 * @license   Licensed under MIT license
 *            See https://github.com/Keyamoon/svgxuse
 * @version   1.2.6
 */
function(){if("undefined"!=typeof window&&window.addEventListener){var e,t,n,y=Object.create(null),_=function(){clearTimeout(t),t=setTimeout(e,100)},k=function(){},w="http://www.w3.org/1999/xlink";e=function(){var e,t,n,i,a,o,r,s,l,c,u,d,h,f=0;function p(){var e;0===--f&&(k(),window.addEventListener("resize",_,!1),window.addEventListener("orientationchange",_,!1),k=window.MutationObserver?((e=new MutationObserver(_)).observe(document.documentElement,{childList:!0,subtree:!0,attributes:!0}),function(){try{e.disconnect(),window.removeEventListener("resize",_,!1),window.removeEventListener("orientationchange",_,!1)}catch(e){}}):(document.documentElement.addEventListener("DOMSubtreeModified",_,!1),function(){document.documentElement.removeEventListener("DOMSubtreeModified",_,!1),window.removeEventListener("resize",_,!1),window.removeEventListener("orientationchange",_,!1)}))}function g(e){return function(){!0!==y[e.base]&&(e.useEl.setAttributeNS(w,"xlink:href","#"+e.hash),e.useEl.hasAttribute("href")&&e.useEl.setAttribute("href","#"+e.hash))}}function v(i){return function(){var e,t=document.body,n=document.createElement("x");i.onload=null,n.innerHTML=i.responseText,(e=n.getElementsByTagName("svg")[0])&&(e.setAttribute("aria-hidden","true"),e.style.position="absolute",e.style.width=0,e.style.height=0,e.style.overflow="hidden",t.insertBefore(e,t.firstChild)),p()}}function m(e){return function(){e.onerror=null,e.ontimeout=null,p()}}for(k(),s=document.getElementsByTagName("use"),a=0;a<s.length;a+=1){try{t=s[a].getBoundingClientRect()}catch(e){t=!1}e=(r=(i=s[a].getAttribute("href")||s[a].getAttributeNS(w,"href")||s[a].getAttribute("xlink:href"))&&i.split?i.split("#"):["",""])[0],n=r[1],o=t&&0===t.left&&0===t.right&&0===t.top&&0===t.bottom,t&&0===t.width&&0===t.height&&!o?(s[a].hasAttribute("href")&&s[a].setAttributeNS(w,"xlink:href",i),e.length&&(!0!==(l=y[e])&&setTimeout(g({useEl:s[a],base:e,hash:n}),0),void 0===l&&(c=e,h=d=u=void 0,window.XMLHttpRequest&&(u=new XMLHttpRequest,d=b(location),h=b(c),u=void 0===u.withCredentials&&""!==h&&h!==d?XDomainRequest||void 0:XMLHttpRequest),void 0!==u&&(l=new u,(y[e]=l).onload=v(l),l.onerror=m(l),l.ontimeout=m(l),l.open("GET",e),l.send(),f+=1)))):o?e.length&&y[e]&&setTimeout(g({useEl:s[a],base:e,hash:n}),0):void 0===y[e]?y[e]=!0:y[e].onload&&(y[e].abort(),delete y[e].onload,y[e]=!0)}function b(e){var t;return void 0!==e.protocol?t=e:(t=document.createElement("a")).href=e,t.protocol.replace(/:/g,"")+t.host}s="",f+=1,p()},n=function(){window.removeEventListener("load",n,!1),t=setTimeout(e,0)},"complete"!==document.readyState?window.addEventListener("load",n,!1):n()}}()},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=p(n(1)),r=p(n(2)),s=p(n(78)),l=p(n(80)),c=p(n(106)),u=p(n(3)),d=p(n(108)),h=p(n(0)),f=n(4);function p(e){return e&&e.__esModule?e:{default:e}}var g=h.default.eventNames,v=h.default.commandNames,m=h.default.keyCodes,b=h.default.rejectMessages,y=o.default.isUndefined,_=o.default.forEach,k=o.default.CustomEvents,w=(i(x,[{key:"_setSelectionStyle",value:function(t,e){var n=e.applyCropSelectionStyle,i=e.applyGroupSelectionStyle;t&&this._graphics.setSelectionStyle(t),n&&this._graphics.setCropSelectionStyle(t),i&&this.on("selectionCreated",function(e){"activeSelection"===e.type&&e.set(t)})}},{key:"_attachInvokerEvents",value:function(){var e=g.UNDO_STACK_CHANGED,t=g.REDO_STACK_CHANGED;this._invoker.on(e,this.fire.bind(this,e)),this._invoker.on(t,this.fire.bind(this,t))}},{key:"_attachGraphicsEvents",value:function(){this._graphics.on({mousedown:this._handlers.mousedown,objectMoved:this._handlers.objectMoved,objectScaled:this._handlers.objectScaled,objectActivated:this._handlers.objectActivated,addText:this._handlers.addText,addObject:this._handlers.addObject,textEditing:this._handlers.textEditing,textChanged:this._handlers.textChanged,iconCreateResize:this._handlers.iconCreateResize,iconCreateEnd:this._handlers.iconCreateEnd,selectionCleared:this._handlers.selectionCleared,selectionCreated:this._handlers.selectionCreated,addObjectAfter:this._handlers.addObjectAfter})}},{key:"_attachDomEvents",value:function(){document.addEventListener("keydown",this._handlers.keydown)}},{key:"_detachDomEvents",value:function(){document.removeEventListener("keydown",this._handlers.keydown)}},{key:"_onKeyDown",value:function(e){var t=e.ctrlKey,n=e.keyCode,i=e.metaKey,a=this._graphics.getActiveObject(),o=this._graphics.getActiveObjects(),r=a||o&&o.size();(t||i)&&(n===m.Z?this.undo().catch(function(){}):n===m.Y&&this.redo().catch(function(){}));var s=n===m.BACKSPACE||n===m.DEL;a&&a.isEditing||!s||!r||(e.preventDefault(),this.removeActiveObject())}},{key:"removeActiveObject",value:function(){var e=this._graphics.getActiveObject(),t=this._graphics.getActiveObjects();if(t&&t.size())this.discardSelection(),this._removeObjectStream(t.getObjects());else if(e){var n=this._graphics.getObjectId(e);this.removeObject(n)}}},{key:"_removeObjectStream",value:function(e){var t=this;if(!e.length)return!0;var n=e.pop();return this.removeObject(this._graphics.getObjectId(n)).then(function(){return t._removeObjectStream(e)})}},{key:"_onMouseDown",value:function(e,t){this.fire(g.MOUSE_DOWN,e,t)}},{key:"_pushAddObjectCommand",value:function(e){var t=u.default.create(v.ADD_OBJECT,this._graphics,e);this._invoker.pushUndoStack(t)}},{key:"_onObjectActivated",value:function(e){this.fire(g.OBJECT_ACTIVATED,e)}},{key:"_onObjectMoved",value:function(e){this.fire(g.OBJECT_MOVED,e)}},{key:"_onObjectScaled",value:function(e){this.fire(g.OBJECT_SCALED,e)}},{key:"getDrawingMode",value:function(){return this._graphics.getDrawingMode()}},{key:"clearObjects",value:function(){return this.execute(v.CLEAR_OBJECTS)}},{key:"deactivateAll",value:function(){this._graphics.deactivateAll(),this._graphics.renderAll()}},{key:"discardSelection",value:function(){this._graphics.discardSelection()}},{key:"changeSelectableAll",value:function(e){this._graphics.changeSelectableAll(e)}},{key:"execute",value:function(e){for(var t,n=arguments.length,i=Array(1<n?n-1:0),a=1;a<n;a++)i[a-1]=arguments[a];var o=[this._graphics].concat(i);return(t=this._invoker).execute.apply(t,[e].concat(o))}},{key:"executeSilent",value:function(e){for(var t,n=arguments.length,i=Array(1<n?n-1:0),a=1;a<n;a++)i[a-1]=arguments[a];var o=[this._graphics].concat(i);return(t=this._invoker).executeSilent.apply(t,[e].concat(o))}},{key:"undo",value:function(){return this._invoker.undo()}},{key:"redo",value:function(){return this._invoker.redo()}},{key:"loadImageFromFile",value:function(t,e){if(!t)return r.default.reject(b.invalidParameters);var n=URL.createObjectURL(t);return e=e||t.name,this.loadImageFromURL(n,e).then(function(e){return URL.revokeObjectURL(t),e})}},{key:"loadImageFromURL",value:function(e,t){return t&&e?this.execute(v.LOAD_IMAGE,t,e):r.default.reject(b.invalidParameters)}},{key:"addImageObject",value:function(e){return e?this.execute(v.ADD_IMAGE_OBJECT,e):r.default.reject(b.invalidParameters)}},{key:"startDrawingMode",value:function(e,t){return this._graphics.startDrawingMode(e,t)}},{key:"stopDrawingMode",value:function(){this._graphics.stopDrawingMode()}},{key:"crop",value:function(e){var t=this._graphics.getCroppedImageData(e);return t?this.loadImageFromURL(t.url,t.imageName):r.default.reject(b.invalidParameters)}},{key:"getCropzoneRect",value:function(){return this._graphics.getCropzoneRect()}},{key:"setCropzoneRect",value:function(e){this._graphics.setCropzoneRect(e)}},{key:"_flip",value:function(e){return this.execute(v.FLIP_IMAGE,e)}},{key:"flipX",value:function(){return this._flip("flipX")}},{key:"flipY",value:function(){return this._flip("flipY")}},{key:"resetFlip",value:function(){return this._flip("reset")}},{key:"_rotate",value:function(e,t,n){return n?this.executeSilent(v.ROTATE_IMAGE,e,t):this.execute(v.ROTATE_IMAGE,e,t)}},{key:"rotate",value:function(e,t){return this._rotate("rotate",e,t)}},{key:"setAngle",value:function(e,t){return this._rotate("setAngle",e,t)}},{key:"setBrush",value:function(e){this._graphics.setBrush(e)}},{key:"setDrawingShape",value:function(e,t){this._graphics.setDrawingShape(e,t)}},{key:"addShape",value:function(e,t){return t=t||{},this._setPositions(t),this.execute(v.ADD_SHAPE,e,t)}},{key:"changeShape",value:function(e,t){return this.execute(v.CHANGE_SHAPE,e,t)}},{key:"addText",value:function(e,t){return e=e||"",t=t||{},this.execute(v.ADD_TEXT,e,t)}},{key:"changeText",value:function(e,t){return t=t||"",this.execute(v.CHANGE_TEXT,e,t)}},{key:"changeTextStyle",value:function(e,t){return this.execute(v.CHANGE_TEXT_STYLE,e,t)}},{key:"_changeActivateMode",value:function(e){"ICON"!==e&&this.getDrawingMode()!==e&&this.startDrawingMode(e)}},{key:"_onTextChanged",value:function(e){this.changeText(e.id,e.text)}},{key:"_onIconCreateResize",value:function(e){this.fire(g.ICON_CREATE_RESIZE,e)}},{key:"_onIconCreateEnd",value:function(e){this.fire(g.ICON_CREATE_END,e)}},{key:"_onTextEditing",value:function(){this.fire(g.TEXT_EDITING)}},{key:"_onAddText",value:function(e){this.fire(g.ADD_TEXT,{originPosition:e.originPosition,clientPosition:e.clientPosition})}},{key:"_onAddObject",value:function(e){var t=this._graphics.getObject(e.id);this._pushAddObjectCommand(t)}},{key:"_onAddObjectAfter",value:function(e){this.fire(g.ADD_OBJECT_AFTER,e)}},{key:"_selectionCleared",value:function(){this.fire(g.SELECTION_CLEARED)}},{key:"_selectionCreated",value:function(e){this.fire(g.SELECTION_CREATED,e)}},{key:"registerIcons",value:function(e){this._graphics.registerPaths(e)}},{key:"changeCursor",value:function(e){this._graphics.changeCursor(e)}},{key:"addIcon",value:function(e,t){return t=t||{},this._setPositions(t),this.execute(v.ADD_ICON,e,t)}},{key:"changeIconColor",value:function(e,t){return this.execute(v.CHANGE_ICON_COLOR,e,t)}},{key:"removeObject",value:function(e){return this.execute(v.REMOVE_OBJECT,e)}},{key:"hasFilter",value:function(e){return this._graphics.hasFilter(e)}},{key:"removeFilter",value:function(e){return this.execute(v.REMOVE_FILTER,e)}},{key:"applyFilter",value:function(e,t){return this.execute(v.APPLY_FILTER,e,t)}},{key:"toDataURL",value:function(e){return this._graphics.toDataURL(e)}},{key:"getImageName",value:function(){return this._graphics.getImageName()}},{key:"clearUndoStack",value:function(){this._invoker.clearUndoStack()}},{key:"clearRedoStack",value:function(){this._invoker.clearRedoStack()}},{key:"isEmptyUndoStack",value:function(){return this._invoker.isEmptyUndoStack()}},{key:"isEmptyRedoStack",value:function(){return this._invoker.isEmptyRedoStack()}},{key:"resizeCanvasDimension",value:function(e){return e?this.execute(v.RESIZE_CANVAS_DIMENSION,e):r.default.reject(b.invalidParameters)}},{key:"destroy",value:function(){var n=this;this.stopDrawingMode(),this._detachDomEvents(),this._graphics.destroy(),this._graphics=null,_(this,function(e,t){n[t]=null},this)}},{key:"_setPositions",value:function(e){var t=this._graphics.getCenter();y(e.left)&&(e.left=t.left),y(e.top)&&(e.top=t.top)}},{key:"setObjectProperties",value:function(e,t){return this.execute(v.SET_OBJECT_PROPERTIES,e,t)}},{key:"setObjectPropertiesQuietly",value:function(e,t){this._graphics.setObjectProperties(e,t)}},{key:"getObjectProperties",value:function(e,t){return this._graphics.getObject(e)?this._graphics.getObjectProperties(e,t):null}},{key:"getCanvasSize",value:function(){return this._graphics.getCanvasSize()}},{key:"getObjectPosition",value:function(e,t,n){return this._graphics.getObjectPosition(e,t,n)}},{key:"setObjectPosition",value:function(e,t){return this.execute(v.SET_OBJECT_POSITION,e,t)}}]),x);function x(e,t){if(!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,x),t=o.default.extend({includeUI:!1,usageStatistics:!0},t),this.mode=null,this.activeObjectId=null,t.includeUI){var n=t.includeUI;n.usageStatistics=t.usageStatistics,this.ui=new l.default(e,n,this.getActions()),t=this.ui.setUiDefaultSelectionStyle(t)}this._invoker=new s.default,this._graphics=new d.default(this.ui?this.ui.getEditorArea():e,{cssMaxWidth:t.cssMaxWidth,cssMaxHeight:t.cssMaxHeight,useItext:!!this.ui,useDragAddIcon:!!this.ui}),this._handlers={keydown:this._onKeyDown.bind(this),mousedown:this._onMouseDown.bind(this),objectActivated:this._onObjectActivated.bind(this),objectMoved:this._onObjectMoved.bind(this),objectScaled:this._onObjectScaled.bind(this),createdPath:this._onCreatedPath,addText:this._onAddText.bind(this),addObject:this._onAddObject.bind(this),addObjectAfter:this._onAddObjectAfter.bind(this),textEditing:this._onTextEditing.bind(this),textChanged:this._onTextChanged.bind(this),iconCreateResize:this._onIconCreateResize.bind(this),iconCreateEnd:this._onIconCreateEnd.bind(this),selectionCleared:this._selectionCleared.bind(this),selectionCreated:this._selectionCreated.bind(this)},this._attachInvokerEvents(),this._attachGraphicsEvents(),this._attachDomEvents(),this._setSelectionStyle(t.selectionStyle,{applyCropSelectionStyle:t.applyCropSelectionStyle,applyGroupSelectionStyle:t.applyGroupSelectionStyle}),t.usageStatistics&&(0,f.sendHostName)(),this.ui&&(this.ui.initCanvas(),this.setReAction()),fabric.enableGLFiltering=!1}c.default.mixin(w),k.mixin(w),e.exports=w},function(e,t){},function(e,t,n){"use strict";var i=n(48)(!0);n(30)(String,"String",function(e){this._t=String(e),this._i=0},function(){var e,t=this._t,n=this._i;return n>=t.length?{value:void 0,done:!0}:(e=i(t,n),this._i+=e.length,{value:e,done:!1})})},function(e,t,n){var l=n(23),c=n(24);e.exports=function(s){return function(e,t){var n,i,a=String(c(e)),o=l(t),r=a.length;return o<0||r<=o?s?"":void 0:(n=a.charCodeAt(o))<55296||56319<n||o+1===r||(i=a.charCodeAt(o+1))<56320||57343<i?s?a.charAt(o):n:s?a.slice(o,o+2):i-56320+(n-55296<<10)+65536}}},function(e,t,n){e.exports=!n(13)&&!n(33)(function(){return 7!=Object.defineProperty(n(26)("div"),"a",{get:function(){return 7}}).a})},function(e,t,n){var a=n(20);e.exports=function(e,t){if(!a(e))return e;var n,i;if(t&&"function"==typeof(n=e.toString)&&!a(i=n.call(e)))return i;if("function"==typeof(n=e.valueOf)&&!a(i=n.call(e)))return i;if(!t&&"function"==typeof(n=e.toString)&&!a(i=n.call(e)))return i;throw TypeError("Can't convert object to primitive value")}},function(e,t,n){e.exports=n(10)},function(e,t,n){"use strict";var i=n(53),a=n(34),o=n(29),r={};n(10)(r,n(6)("iterator"),function(){return this}),e.exports=function(e,t,n){e.prototype=i(r,{next:a(1,n)}),o(e,t+" Iterator")}},function(e,t,i){function a(){}var o=i(11),r=i(54),s=i(38),l=i(28)("IE_PROTO"),c="prototype",u=function(){var e,t=i(26)("iframe"),n=s.length;for(t.style.display="none",i(39).appendChild(t),t.src="javascript:",(e=t.contentWindow.document).open(),e.write("<script>document.F=Object<\/script>"),e.close(),u=e.F;n--;)delete u[c][s[n]];return u()};e.exports=Object.create||function(e,t){var n;return null!==e?(a[c]=o(e),n=new a,a[c]=null,n[l]=e):n=u(),void 0===t?n:r(n,t)}},function(e,t,n){var r=n(19),s=n(11),l=n(55);e.exports=n(13)?Object.defineProperties:function(e,t){s(e);for(var n,i=l(t),a=i.length,o=0;o<a;)r.f(e,n=i[o++],t[n]);return e}},function(e,t,n){var i=n(56),a=n(38);e.exports=Object.keys||function(e){return i(e,a)}},function(e,t,n){var r=n(21),s=n(27),l=n(58)(!1),c=n(28)("IE_PROTO");e.exports=function(e,t){var n,i=s(e),a=0,o=[];for(n in i)n!=c&&r(i,n)&&o.push(n);for(;t.length>a;)r(i,n=t[a++])&&(~l(o,n)||o.push(n));return o}},function(e,t,n){var i=n(22);e.exports=Object("z").propertyIsEnumerable(0)?Object:function(e){return"String"==i(e)?e.split(""):Object(e)}},function(e,t,n){var l=n(27),c=n(35),u=n(59);e.exports=function(s){return function(e,t,n){var i,a=l(e),o=c(a.length),r=u(n,o);if(s&&t!=t){for(;r<o;)if((i=a[r++])!=i)return!0}else for(;r<o;r++)if((s||r in a)&&a[r]===t)return s||r||0;return!s&&-1}}},function(e,t,n){var i=n(23),a=Math.max,o=Math.min;e.exports=function(e,t){return(e=i(e))<0?a(e+t,0):o(e,t)}},function(e,t,n){var i=n(21),a=n(61),o=n(28)("IE_PROTO"),r=Object.prototype;e.exports=Object.getPrototypeOf||function(e){return e=a(e),i(e,o)?e[o]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?r:null}},function(e,t,n){var i=n(24);e.exports=function(e){return Object(i(e))}},function(e,t,n){n(63);for(var i=n(7),a=n(10),o=n(14),r=n(6)("toStringTag"),s=["NodeList","DOMTokenList","MediaList","StyleSheetList","CSSRuleList"],l=0;l<5;l++){var c=s[l],u=i[c],d=u&&u.prototype;d&&!d[r]&&a(d,r,c),o[c]=o.Array}},function(e,t,n){"use strict";var i=n(64),a=n(65),o=n(14),r=n(27);e.exports=n(30)(Array,"Array",function(e,t){this._t=r(e),this._i=0,this._k=t},function(){var e=this._t,t=this._k,n=this._i++;return!e||n>=e.length?(this._t=void 0,a(1)):a(0,"keys"==t?n:"values"==t?e[n]:[n,e[n]])},"values"),o.Arguments=o.Array,i("keys"),i("values"),i("entries")},function(e,t){e.exports=function(){}},function(e,t){e.exports=function(e,t){return{value:t,done:!!e}}},function(e,t,n){"use strict";function i(){}function a(e,t){return e===t||e===j&&t===h}function u(e){var t;return!(!b(e)||"function"!=typeof(t=e.then))&&t}function o(e){return new(a(j,e)?P:d)(e)}function c(e){try{e()}catch(e){return{error:e}}}function r(c,n){if(!c._n){c._n=!0;var i=c._c;E(function(){for(var s=c._v,l=1==c._s,e=0,t=function(e){var t,n,i=l?e.ok:e.fail,a=e.resolve,o=e.reject,r=e.domain;try{i?(l||(2==c._h&&R(c),c._h=1),!0===i?t=s:(r&&r.enter(),t=i(s),r&&r.exit()),t===e.promise?o(O("Promise-chain cycle")):(n=u(t))?n.call(t,a,o):a(t)):o(s)}catch(e){o(e)}};i.length>e;)t(i[e++]);c._c=[],c._n=!1,n&&!c._h&&A(c)})}}function s(e){var t=this;t._d||(t._d=!0,(t=t._w||t)._v=e,t._s=2,t._a||(t._a=t._c.slice()),r(t,!0))}var l,d,h,f=n(31),p=n(7),g=n(18),v=n(40),m=n(32),b=n(20),y=n(25),_=n(67),k=n(68),w=n(72),x=n(41).set,E=n(74)(),C="Promise",O=p.TypeError,S=p.process,j=p[C],M="process"==v(S=p.process),T=!!function(){try{var e=j.resolve(1),t=(e.constructor={})[n(6)("species")]=function(e){e(i,i)};return(M||"function"==typeof PromiseRejectionEvent)&&e.then(i)instanceof t}catch(e){}}(),P=d=function(e){var n,i;this.promise=new e(function(e,t){if(void 0!==n||void 0!==i)throw O("Bad Promise constructor");n=e,i=t}),this.resolve=y(n),this.reject=y(i)},A=function(a){x.call(p,function(){var e,t,n,i=a._v;if(I(a)&&(e=c(function(){M?S.emit("unhandledRejection",i,a):(t=p.onunhandledrejection)?t({promise:a,reason:i}):(n=p.console)&&n.error&&n.error("Unhandled promise rejection",i)}),a._h=M||I(a)?2:1),a._a=void 0,e)throw e.error})},I=function(e){if(1==e._h)return!1;for(var t,n=e._a||e._c,i=0;n.length>i;)if((t=n[i++]).fail||!I(t.promise))return!1;return!0},R=function(t){x.call(p,function(){var e;M?S.emit("rejectionHandled",t):(e=p.onrejectionhandled)&&e({promise:t,reason:t._v})})},D=function(e){var n,i=this;if(!i._d){i._d=!0,i=i._w||i;try{if(i===e)throw O("Promise can't be resolved itself");(n=u(e))?E(function(){var t={_w:i,_d:!1};try{n.call(e,g(D,t,1),g(s,t,1))}catch(e){s.call(t,e)}}):(i._v=e,i._s=1,r(i,!1))}catch(e){s.call({_w:i,_d:!1},e)}}};T||(j=function(e){_(this,j,C,"_h"),y(e),l.call(this);try{e(g(D,this,1),g(s,this,1))}catch(e){s.call(this,e)}},(l=function(){this._c=[],this._a=void 0,this._s=0,this._d=!1,this._v=void 0,this._h=0,this._n=!1}).prototype=n(75)(j.prototype,{then:function(e,t){var n=o(w(this,j));return n.ok="function"!=typeof e||e,n.fail="function"==typeof t&&t,n.domain=M?S.domain:void 0,this._c.push(n),this._a&&this._a.push(n),this._s&&r(this,!1),n.promise},catch:function(e){return this.then(void 0,e)}}),P=function(){var e=new l;this.promise=e,this.resolve=g(D,e,1),this.reject=g(s,e,1)}),m(m.G+m.W+m.F*!T,{Promise:j}),n(29)(j,C),n(76)(C),h=n(12)[C],m(m.S+m.F*!T,C,{reject:function(e){var t=o(this);return(0,t.reject)(e),t.promise}}),m(m.S+m.F*(f||!T),C,{resolve:function(e){if(e instanceof j&&a(e.constructor,this))return e;var t=o(this);return(0,t.resolve)(e),t.promise}}),m(m.S+m.F*!(T&&n(77)(function(e){j.all(e).catch(i)})),C,{all:function(e){var r=this,t=o(r),s=t.resolve,l=t.reject,n=c(function(){var i=[],a=0,o=1;k(e,!1,function(e){var t=a++,n=!1;i.push(void 0),o++,r.resolve(e).then(function(e){n||(n=!0,i[t]=e,--o||s(i))},l)}),--o||s(i)});return n&&l(n.error),t.promise},race:function(e){var t=this,n=o(t),i=n.reject,a=c(function(){k(e,!1,function(e){t.resolve(e).then(n.resolve,i)})});return a&&i(a.error),n.promise}})},function(e,t){e.exports=function(e,t,n,i){if(!(e instanceof t)||void 0!==i&&i in e)throw TypeError(n+": incorrect invocation!");return e}},function(e,t,n){var h=n(18),f=n(69),p=n(70),g=n(11),v=n(35),m=n(71),b={},y={};(t=e.exports=function(e,t,n,i,a){var o,r,s,l,c=a?function(){return e}:m(e),u=h(n,i,t?2:1),d=0;if("function"!=typeof c)throw TypeError(e+" is not iterable!");if(p(c)){for(o=v(e.length);d<o;d++)if((l=t?u(g(r=e[d])[0],r[1]):u(e[d]))===b||l===y)return l}else for(s=c.call(e);!(r=s.next()).done;)if((l=f(s,u,r.value,t))===b||l===y)return l}).BREAK=b,t.RETURN=y},function(e,t,n){var o=n(11);e.exports=function(t,e,n,i){try{return i?e(o(n)[0],n[1]):e(n)}catch(e){var a=t.return;throw void 0!==a&&o(a.call(t)),e}}},function(e,t,n){var i=n(14),a=n(6)("iterator"),o=Array.prototype;e.exports=function(e){return void 0!==e&&(i.Array===e||o[a]===e)}},function(e,t,n){var i=n(40),a=n(6)("iterator"),o=n(14);e.exports=n(12).getIteratorMethod=function(e){if(null!=e)return e[a]||e["@@iterator"]||o[i(e)]}},function(e,t,n){var a=n(11),o=n(25),r=n(6)("species");e.exports=function(e,t){var n,i=a(e).constructor;return void 0===i||null==(n=a(i)[r])?t:o(n)}},function(e,t){e.exports=function(e,t,n){var i=void 0===n;switch(t.length){case 0:return i?e():e.call(n);case 1:return i?e(t[0]):e.call(n,t[0]);case 2:return i?e(t[0],t[1]):e.call(n,t[0],t[1]);case 3:return i?e(t[0],t[1],t[2]):e.call(n,t[0],t[1],t[2]);case 4:return i?e(t[0],t[1],t[2],t[3]):e.call(n,t[0],t[1],t[2],t[3])}return e.apply(n,t)}},function(e,t,n){var s=n(7),l=n(41).set,c=s.MutationObserver||s.WebKitMutationObserver,u=s.process,d=s.Promise,h="process"==n(22)(u);e.exports=function(){function e(){var e,t;for(h&&(e=u.domain)&&e.exit();n;){t=n.fn,n=n.next;try{t()}catch(e){throw n?a():i=void 0,e}}i=void 0,e&&e.enter()}var n,i,a;if(h)a=function(){u.nextTick(e)};else if(c){var t=!0,o=document.createTextNode("");new c(e).observe(o,{characterData:!0}),a=function(){o.data=t=!t}}else if(d&&d.resolve){var r=d.resolve();a=function(){r.then(e)}}else a=function(){l.call(s,e)};return function(e){var t={fn:e,next:void 0};i&&(i.next=t),n||(n=t,a()),i=t}}},function(e,t,n){var a=n(10);e.exports=function(e,t,n){for(var i in t)n&&e[i]?e[i]=t[i]:a(e,i,t[i]);return e}},function(e,t,n){"use strict";var i=n(7),a=n(12),o=n(19),r=n(13),s=n(6)("species");e.exports=function(e){var t="function"==typeof a[e]?a[e]:i[e];r&&t&&!t[s]&&o.f(t,s,{configurable:!0,get:function(){return this}})}},function(e,t,n){var o=n(6)("iterator"),r=!1;try{var i=[7][o]();i.return=function(){r=!0},Array.from(i,function(){throw 2})}catch(e){}e.exports=function(e,t){if(!t&&!r)return!1;var n=!1;try{var i=[7],a=i[o]();a.next=function(){return{done:n=!0}},i[o]=function(){return a},e(i)}catch(e){}return n}},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=c(n(1)),r=c(n(2)),s=c(n(3)),l=c(n(0));function c(e){return e&&e.__esModule?e:{default:e}}var u=l.default.eventNames,d=l.default.rejectMessages,h=o.default.isFunction,f=o.default.isString,p=o.default.CustomEvents,g=(i(v,[{key:"_invokeExecution",value:function(t){var n=this;this.lock();var e=t.args;return e=e||[],t.execute.apply(t,e).then(function(e){return n._isSilent||n.pushUndoStack(t),n.unlock(),h(t.executeCallback)&&t.executeCallback(e),e}).catch(function(e){return n.unlock(),r.default.reject(e)})}},{key:"_invokeUndo",value:function(t){var n=this;this.lock();var e=t.args;return e=e||[],t.undo.apply(t,e).then(function(e){return n.pushRedoStack(t),n.unlock(),h(t.undoCallback)&&t.undoCallback(e),e}).catch(function(e){return n.unlock(),r.default.reject(e)})}},{key:"_fireRedoStackChanged",value:function(){this.fire(u.REDO_STACK_CHANGED,this._redoStack.length)}},{key:"_fireUndoStackChanged",value:function(){this.fire(u.UNDO_STACK_CHANGED,this._undoStack.length)}},{key:"lock",value:function(){this._isLocked=!0}},{key:"unlock",value:function(){this._isLocked=!1}},{key:"executeSilent",value:function(){var e=this;this._isSilent=!0;for(var t=arguments.length,n=Array(t),i=0;i<t;i++)n[i]=arguments[i];return this.execute.apply(this,n.concat([this._isSilent])).then(function(){e._isSilent=!1})}},{key:"execute",value:function(){var t=this;if(this._isLocked)return r.default.reject(d.isLock);for(var e=arguments.length,n=Array(e),i=0;i<e;i++)n[i]=arguments[i];var a=n[0];return f(a)&&(a=s.default.create.apply(s.default,n)),this._invokeExecution(a).then(function(e){return t.clearRedoStack(),e})}},{key:"undo",value:function(){var e=this._undoStack.pop(),t="";return e&&this._isLocked&&(this.pushUndoStack(e,!0),e=null),e?(this.isEmptyUndoStack()&&this._fireUndoStackChanged(),this._invokeUndo(e)):(t=d.undo,this._isLocked&&(t=t+" Because "+d.isLock),r.default.reject(t))}},{key:"redo",value:function(){var e=this._redoStack.pop(),t="";return e&&this._isLocked&&(this.pushRedoStack(e,!0),e=null),e?(this.isEmptyRedoStack()&&this._fireRedoStackChanged(),this._invokeExecution(e)):(t=d.redo,this._isLocked&&(t=t+" Because "+d.isLock),r.default.reject(t))}},{key:"pushUndoStack",value:function(e,t){this._undoStack.push(e),t||this._fireUndoStackChanged()}},{key:"pushRedoStack",value:function(e,t){this._redoStack.push(e),t||this._fireRedoStackChanged()}},{key:"isEmptyRedoStack",value:function(){return 0===this._redoStack.length}},{key:"isEmptyUndoStack",value:function(){return 0===this._undoStack.length}},{key:"clearUndoStack",value:function(){this.isEmptyUndoStack()||(this._undoStack=[],this._fireUndoStackChanged())}},{key:"clearRedoStack",value:function(){this.isEmptyRedoStack()||(this._redoStack=[],this._fireRedoStackChanged())}}]),v);function v(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,v),this._undoStack=[],this._redoStack=[],this._isLocked=!1,this._isSilent=!1}p.mixin(g),e.exports=g},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o,r=n(42),s=(o=r)&&o.__esModule?o:{default:o};var l=s.default.create,c=s.default.types,u=(i(d,[{key:"execute",value:function(){throw new Error(l(c.UN_IMPLEMENTATION,"execute"))}},{key:"undo",value:function(){throw new Error(l(c.UN_IMPLEMENTATION,"undo"))}},{key:"setExecuteCallback",value:function(e){return this.executeCallback=e,this}},{key:"setUndoCallback",value:function(e){return this.undoCallback=e,this}}]),d);function d(e,t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),this.name=e.name,this.args=t,this.execute=e.execute,this.undo=e.undo,this.executeCallback=e.executeCallback||null,this.undoCallback=e.undoCallback||null,this.undoData={}}e.exports=u},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=_(n(1)),r=_(n(4)),s=_(n(81)),l=_(n(82)),c=_(n(83)),u=_(n(86)),d=_(n(89)),h=_(n(91)),f=_(n(93)),p=_(n(95)),g=_(n(97)),v=_(n(99)),m=_(n(101)),b=_(n(103)),y=_(n(105));function _(e){return e&&e.__esModule?e:{default:e}}var k={Shape:u.default,Crop:d.default,Flip:h.default,Rotate:f.default,Text:p.default,Mask:g.default,Icon:v.default,Draw:m.default,Filter:b.default},w=(i(x,[{key:"setUiDefaultSelectionStyle",value:function(e){return o.default.extend({applyCropSelectionStyle:!0,applyGroupSelectionStyle:!0,selectionStyle:{cornerStyle:"circle",cornerSize:16,cornerColor:"#fff",cornerStrokeColor:"#fff",transparentCorners:!1,lineWidth:2,borderColor:"#fff"}},e)}},{key:"resizeEditor",value:function(e){var t=0<arguments.length&&void 0!==e?e:{},n=t.uiSize,i=t.imageSize,a=void 0===i?this.imageSize:i;a!==this.imageSize&&(this.imageSize=a),n&&this._setUiSize(n);var o=this._getEditorDimension(),r=o.width,s=o.height,l=this._editorElement.style,c=this.options.menuBarPosition;l.height=s+"px",l.width=r+"px",this._setEditorPosition(c),this._editorElementWrap.style.bottom="0px",this._editorElementWrap.style.top="0px",this._editorElementWrap.style.left="0px",this._editorElementWrap.style.width="100%";var u=this._selectedElement.classList;"top"===c&&this._selectedElement.offsetWidth<"1300"?u.add("tui-image-editor-top-optimization"):u.remove("tui-image-editor-top-optimization")}},{key:"changeUndoButtonStatus",value:function(e){e?this._els.undo.classList.add("enabled"):this._els.undo.classList.remove("enabled")}},{key:"changeRedoButtonStatus",value:function(e){e?this._els.redo.classList.add("enabled"):this._els.redo.classList.remove("enabled")}},{key:"changeResetButtonStatus",value:function(e){e?this._els.reset.classList.add("enabled"):this._els.reset.classList.remove("enabled")}},{key:"changeDeleteAllButtonEnabled",value:function(e){e?this._els.deleteAll.classList.add("enabled"):this._els.deleteAll.classList.remove("enabled")}},{key:"changeDeleteButtonEnabled",value:function(e){e?this._els.delete.classList.add("enabled"):this._els.delete.classList.remove("enabled")}},{key:"_initializeOption",value:function(e){return o.default.extend({loadImage:{path:"",name:""},locale:{},menuIconPath:"",menu:["crop","flip","rotate","draw","shape","icon","text","mask","filter"],initMenu:"",uiSize:{width:"100%",height:"100%"},menuBarPosition:"bottom"},e)}},{key:"_setUiSize",value:function(e){var t=0<arguments.length&&void 0!==e?e:this.options.uiSize,n=this._selectedElement.style;n.width=t.width,n.height=t.height}},{key:"_makeSubMenu",value:function(){var n=this;o.default.forEach(this.options.menu,function(e){var t=k[e.replace(/^[a-z]/,function(e){return e.toUpperCase()})];n._makeMenuElement(e),n._els[e]=n._menuElement.querySelector("#tie-btn-"+e),n[e]=new t(n._subMenuElement,{locale:n._locale,iconStyle:n.theme.getStyle("submenu.icon"),menuBarPosition:n.options.menuBarPosition,usageStatistics:n.options.usageStatistics})})}},{key:"_makeUiElement",value:function(e){var t=void 0;window.snippet=o.default,t=e.nodeType?e:document.querySelector(e);var n=r.default.getSelector(t);t.classList.add("tui-image-editor-container"),t.innerHTML=(0,l.default)({locale:this._locale,biImage:this.theme.getStyle("common.bi"),iconStyle:this.theme.getStyle("menu.icon"),loadButtonStyle:this.theme.getStyle("loadButton"),downloadButtonStyle:this.theme.getStyle("downloadButton")})+(0,s.default)({locale:this._locale,biImage:this.theme.getStyle("common.bi"),commonStyle:this.theme.getStyle("common"),headerStyle:this.theme.getStyle("header"),loadButtonStyle:this.theme.getStyle("loadButton"),downloadButtonStyle:this.theme.getStyle("downloadButton"),submenuStyle:this.theme.getStyle("submenu")}),this._selectedElement=t,this._selectedElement.classList.add(this.options.menuBarPosition),this._mainElement=n(".tui-image-editor-main"),this._editorElementWrap=n(".tui-image-editor-wrap"),this._editorElement=n(".tui-image-editor"),this._menuElement=n(".tui-image-editor-menu"),this._subMenuElement=n(".tui-image-editor-submenu")}},{key:"_makeMenuElement",value:function(e){var t=document.createElement("li"),n=this.theme.getStyle("menu.icon"),i=n.normal,a=n.active,o=n.hover,r='\n            <svg class="svg_ic-menu">\n                <use xlink:href="'+i.path+"#"+i.name+"-ic-"+e+'" class="normal"/>\n                <use xlink:href="'+a.path+"#"+a.name+"-ic-"+e+'" class="active"/>\n                <use xlink:href="'+o.path+"#"+o.name+"-ic-"+e+'" class="hover"/>\n            </svg>\n        ';t.id="tie-btn-"+e,t.className="tui-image-editor-item normal",t.setAttribute("tooltip-content",this._locale.localize(e.replace(/^[a-z]/g,function(e){return e.toUpperCase()}))),t.innerHTML=r,this._menuElement.appendChild(t)}},{key:"_addHelpActionEvent",value:function(e){var t=this;this._els[e].addEventListener("click",function(){t._actions.main[e]()})}},{key:"_addDownloadEvent",value:function(){var t=this;o.default.forEach(this._els.download,function(e){e.addEventListener("click",function(){t._actions.main.download()})})}},{key:"_addLoadEvent",value:function(){var t=this;o.default.forEach(this._els.load,function(e){e.addEventListener("change",function(e){t._actions.main.load(e.target.files[0])})})}},{key:"_addMenuEvent",value:function(e){var t=this;this._els[e].addEventListener("click",function(){t.changeMenu(e)})}},{key:"_addSubMenuEvent",value:function(e){this[e].addEvent(this._actions[e])}},{key:"getEditorArea",value:function(){return this._editorElement}},{key:"activeMenuEvent",value:function(){var t=this;this._initMenuEvent||(this._addHelpActionEvent("undo"),this._addHelpActionEvent("redo"),this._addHelpActionEvent("reset"),this._addHelpActionEvent("delete"),this._addHelpActionEvent("deleteAll"),this._addDownloadEvent(),o.default.forEach(this.options.menu,function(e){t._addMenuEvent(e),t._addSubMenuEvent(e)}),this._initMenu(),this._initMenuEvent=!0)}},{key:"initCanvas",value:function(){var e=this,t=this._getLoadImage();t.path&&this._actions.main.initLoadImage(t.path,t.name).then(function(){e.activeMenuEvent()}),this._addLoadEvent();var n=document.createElement("div");n.className="tui-image-editor-grid-visual",n.innerHTML='<table>\n           <tr><td class="dot left-top"></td><td></td><td class="dot right-top"></td></tr>\n           <tr><td></td><td></td><td></td></tr>\n           <tr><td class="dot left-bottom"></td><td></td><td class="dot right-bottom"></td></tr>\n         </table>',this._editorContainerElement=this._editorElement.querySelector(".tui-image-editor-canvas-container"),this._editorContainerElement.appendChild(n)}},{key:"_getLoadImage",value:function(){return this.options.loadImage}},{key:"changeMenu",value:function(e,t,n){var i=!(1<arguments.length&&void 0!==t)||t,a=!(2<arguments.length&&void 0!==n)||n;this._submenuChangeTransection||(this._submenuChangeTransection=!0,this._changeMenu(e,i,a),this._submenuChangeTransection=!1)}},{key:"_changeMenu",value:function(e,t,n){this.submenu&&(this._els[this.submenu].classList.remove("active"),this._mainElement.classList.remove("tui-image-editor-menu-"+this.submenu),n&&this._actions.main.discardSelection(),this._actions.main.changeSelectableAll(!0),this[this.submenu].changeStandbyMode()),this.submenu===e&&t?this.submenu=null:(this._els[e].classList.add("active"),this._mainElement.classList.add("tui-image-editor-menu-"+e),this.submenu=e,this[this.submenu].changeStartMode()),this.resizeEditor()}},{key:"_initMenu",value:function(){if(this.options.initMenu){var e=document.createEvent("MouseEvents");e.initEvent("click",!0,!1),this._els[this.options.initMenu].dispatchEvent(e)}this.icon&&this.icon.registDefaultIcon()}},{key:"_getEditorDimension",value:function(){var e=parseFloat(this._editorContainerElement.style.maxHeight),t=this.imageSize.newHeight>e?e:this.imageSize.newHeight,n=parseFloat(this._editorContainerElement.style.maxWidth);return{width:this.imageSize.newWidth>n?n:this.imageSize.newWidth,height:t}}},{key:"_setEditorPosition",value:function(e){var t=this._getEditorDimension(),n=t.width,i=t.height,a=this._editorElement.style,o=0,r=0;this.submenu&&("bottom"===e?o=i>this._editorElementWrap.scrollHeight-150?(i-this._editorElementWrap.scrollHeight)/2:-75:"top"===e?o=i>this._editorElementWrap.offsetHeight-150?75-(i-(this._editorElementWrap.offsetHeight-150))/2:75:"left"===e?r=n>this._editorElementWrap.offsetWidth-248?124-(n-(this._editorElementWrap.offsetWidth-248))/2:124:"right"===e&&(r=n>this._editorElementWrap.scrollWidth-248?(n-this._editorElementWrap.scrollWidth)/2:-124)),a.top=o+"px",a.left=r+"px"}}]),x);function x(e,t,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,x),this.options=this._initializeOption(t),this._actions=n,this.submenu=!1,this.imageSize={},this.uiSize={},this._locale=new y.default(this.options.locale),this.theme=new c.default(this.options.theme),this._submenuChangeTransection=!1,this._selectedElement=null,this._mainElement=null,this._editorElementWrap=null,this._editorElement=null,this._menuElement=null,this._subMenuElement=null,this._makeUiElement(e),this._setUiSize(),this._initMenuEvent=!1,this._els={undo:this._menuElement.querySelector(".tie-btn-undo"),redo:this._menuElement.querySelector(".tie-btn-redo"),reset:this._menuElement.querySelector(".tie-btn-reset"),delete:this._menuElement.querySelector(".tie-btn-delete"),deleteAll:this._menuElement.querySelector(".tie-btn-delete-all"),download:this._selectedElement.querySelectorAll(".tui-image-editor-download-btn"),load:this._selectedElement.querySelectorAll(".tui-image-editor-load-btn")},this._makeSubMenu()}t.default=w},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.biImage,i=e.commonStyle,a=e.headerStyle,o=e.loadButtonStyle,r=e.downloadButtonStyle,s=e.submenuStyle;return'\n    <div class="tui-image-editor-main-container" style="'+i+'">\n        <div class="tui-image-editor-header" style="'+a+'">\n            <div class="tui-image-editor-header-logo">\n                <img src="'+n+'" />\n            </div>\n            <div class="tui-image-editor-header-buttons">\n                <div style="'+o+'">\n                    '+t.localize("Load")+'\n                    <input type="file" class="tui-image-editor-load-btn" />\n                </div>\n                <button class="tui-image-editor-download-btn" style="'+r+'">\n                    '+t.localize("Download")+'\n                </button>\n            </div>\n        </div>\n        <div class="tui-image-editor-main">\n            <div class="tui-image-editor-submenu">\n                <div class="tui-image-editor-submenu-style" style="'+s+'"></div>\n            </div>\n            <div class="tui-image-editor-wrap">\n                <div class="tui-image-editor-size-wrap">\n                    <div class="tui-image-editor-align-wrap">\n                        <div class="tui-image-editor"></div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.biImage,i=e.iconStyle,a=i.normal,o=i.hover,r=i.disabled,s=e.loadButtonStyle,l=e.downloadButtonStyle;return'\n    <div class="tui-image-editor-controls">\n        <div class="tui-image-editor-controls-logo">\n            <img src="'+n+'" />\n        </div>\n        <ul class="tui-image-editor-menu">\n            <li class="tie-btn-undo tui-image-editor-item">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-undo" class="enabled"/>\n                    <use xlink:href="'+r.path+"#"+r.name+'-ic-undo" class="normal"/>\n                    <use xlink:href="'+o.path+"#"+o.name+'-ic-undo" class="hover"/>\n                </svg>\n            </li>\n            <li class="tie-btn-redo tui-image-editor-item">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-redo" class="enabled"/>\n                    <use xlink:href="'+r.path+"#"+r.name+'-ic-redo" class="normal"/>\n                    <use xlink:href="'+o.path+"#"+o.name+'-ic-redo" class="hover"/>\n                </svg>\n            </li>\n            <li class="tie-btn-reset tui-image-editor-item">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-reset" class="enabled"/>\n                    <use xlink:href="'+r.path+"#"+r.name+'-ic-reset" class="normal"/>\n                    <use xlink:href="'+o.path+"#"+o.name+'-ic-reset" class="hover"/>\n                </svg>\n            </li>\n            <li class="tui-image-editor-item">\n                <div class="tui-image-editor-icpartition"></div>\n            </li>\n            <li class="tie-btn-delete tui-image-editor-item">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-delete" class="enabled"/>\n                    <use xlink:href="'+r.path+"#"+r.name+'-ic-delete" class="normal"/>\n                    <use xlink:href="'+o.path+"#"+o.name+'-ic-delete" class="hover"/>\n                </svg>\n            </li>\n            <li class="tie-btn-delete-all tui-image-editor-item">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-delete-all" class="enabled"/>\n                    <use xlink:href="'+r.path+"#"+r.name+'-ic-delete-all" class="normal"/>\n                    <use xlink:href="'+o.path+"#"+o.name+'-ic-delete-all" class="hover"/>\n                </svg>\n            </li>\n            <li class="tui-image-editor-item">\n                <div class="tui-image-editor-icpartition"></div>\n            </li>\n        </ul>\n\n        <div class="tui-image-editor-controls-buttons">\n            <div style="'+s+'">\n                '+t.localize("Load")+'\n                <input type="file" class="tui-image-editor-load-btn" />\n            </div>\n            <button class="tui-image-editor-download-btn" style="'+l+'">\n                '+t.localize("Download")+"\n            </button>\n        </div>\n    </div>\n"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var r=n(1),o=n(4),s=c(n(84)),l=c(n(85));function c(e){return e&&e.__esModule?e:{default:e}}var u=(i(d,[{key:"getStyle",value:function(e){var t=null,n=e.replace(/\..+$/,""),i=this.styles[e];switch(e){case"common.bi":t=this.styles[e].image;break;case"menu.icon":case"submenu.icon":t={active:this.styles[n+".activeIcon"],normal:this.styles[n+".normalIcon"],hover:this.styles[n+".hoverIcon"],disabled:this.styles[n+".disabledIcon"]};break;case"submenu.label":t={active:this._makeCssText(this.styles[n+".activeLabel"]),normal:this._makeCssText(this.styles[n+".normalLabel"])};break;case"submenu.partition":t={vertical:this._makeCssText((0,r.extend)({},i,{borderLeft:"1px solid "+i.color})),horizontal:this._makeCssText((0,r.extend)({},i,{borderBottom:"1px solid "+i.color}))};break;case"range.disabledPointer":case"range.disabledBar":case"range.disabledSubbar":case"range.pointer":case"range.bar":case"range.subbar":i.backgroundColor=i.color,t=this._makeCssText(i);break;default:t=this._makeCssText(i)}return t}},{key:"_styleMaker",value:function(){var e=this.getStyle("submenu.label"),t=this.getStyle("submenu.partition");return(0,s.default)({subMenuLabelActive:e.active,subMenuLabelNormal:e.normal,submenuPartitionVertical:t.vertical,submenuPartitionHorizontal:t.horizontal,biSize:this.getStyle("common.bisize"),subMenuRangeTitle:this.getStyle("range.title"),submenuRangePointer:this.getStyle("range.pointer"),submenuRangeBar:this.getStyle("range.bar"),submenuRangeSubbar:this.getStyle("range.subbar"),submenuDisabledRangePointer:this.getStyle("range.disabledPointer"),submenuDisabledRangeBar:this.getStyle("range.disabledBar"),submenuDisabledRangeSubbar:this.getStyle("range.disabledSubbar"),submenuRangeValue:this.getStyle("range.value"),submenuColorpickerTitle:this.getStyle("colorpicker.title"),submenuColorpickerButton:this.getStyle("colorpicker.button"),submenuCheckbox:this.getStyle("checkbox"),menuIconSize:this.getStyle("menu.iconSize"),submenuIconSize:this.getStyle("submenu.iconSize")})}},{key:"_changeToObject",value:function(e){var o={};return(0,r.forEach)(e,function(e,t){var n=t.match(/^(.+)\.([a-z]+)$/i),i=n[1],a=n[2];o[i]||(o[i]={}),o[i][a]=e}),o}},{key:"_makeCssText",value:function(e){var n=this,i=[];return(0,r.forEach)(e,function(e,t){-1<["backgroundImage"].indexOf(t)&&"none"!==e&&(e="url("+e+")"),i.push(n._toUnderScore(t)+": "+e)}),i.join(";")}},{key:"_toUnderScore",value:function(e){return e.replace(/([A-Z])/g,function(e,t){return"-"+t.toLowerCase()})}}]),d);function d(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),this.styles=this._changeToObject((0,r.extend)(l.default,e)),(0,o.styleLoad)(this._styleMaker())}t.default=u},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.subMenuLabelActive,n=e.subMenuLabelNormal,i=e.subMenuRangeTitle,a=e.submenuPartitionVertical,o=e.submenuPartitionHorizontal,r=e.submenuCheckbox,s=e.submenuRangePointer,l=e.submenuRangeValue,c=e.submenuColorpickerTitle,u=e.submenuColorpickerButton,d=e.submenuRangeBar,h=e.submenuRangeSubbar,f=e.submenuDisabledRangePointer,p=e.submenuDisabledRangeBar,g=e.submenuDisabledRangeSubbar,v=e.submenuIconSize;return'\n    .tie-icon-add-button.icon-bubble .tui-image-editor-button[data-icontype="icon-bubble"] label,\n    .tie-icon-add-button.icon-heart .tui-image-editor-button[data-icontype="icon-heart"] label,\n    .tie-icon-add-button.icon-location .tui-image-editor-button[data-icontype="icon-location"] label,\n    .tie-icon-add-button.icon-polygon .tui-image-editor-button[data-icontype="icon-polygon"] label,\n    .tie-icon-add-button.icon-star .tui-image-editor-button[data-icontype="icon-star"] label,\n    .tie-icon-add-button.icon-star-2 .tui-image-editor-button[data-icontype="icon-star-2"] label,\n    .tie-icon-add-button.icon-arrow-3 .tui-image-editor-button[data-icontype="icon-arrow-3"] label,\n    .tie-icon-add-button.icon-arrow-2 .tui-image-editor-button[data-icontype="icon-arrow-2"] label,\n    .tie-icon-add-button.icon-arrow .tui-image-editor-button[data-icontype="icon-arrow"] label,\n    .tie-icon-add-button.icon-bubble .tui-image-editor-button[data-icontype="icon-bubble"] label,\n    .tie-draw-line-select-button.line .tui-image-editor-button.line label,\n    .tie-draw-line-select-button.free .tui-image-editor-button.free label,\n    .tie-flip-button.flipX .tui-image-editor-button.flipX label,\n    .tie-flip-button.flipY .tui-image-editor-button.flipY label,\n    .tie-flip-button.resetFlip .tui-image-editor-button.resetFlip label,\n    .tie-crop-button .tui-image-editor-button.apply.active label,\n    .tie-crop-preset-button .tui-image-editor-button.preset.active label,\n    .tie-shape-button.rect .tui-image-editor-button.rect label,\n    .tie-shape-button.circle .tui-image-editor-button.circle label,\n    .tie-shape-button.triangle .tui-image-editor-button.triangle label,\n    .tie-text-effect-button .tui-image-editor-button.active label,\n    .tie-text-align-button.left .tui-image-editor-button.left label,\n    .tie-text-align-button.center .tui-image-editor-button.center label,\n    .tie-text-align-button.right .tui-image-editor-button.right label,\n    .tie-mask-apply.apply.active .tui-image-editor-button.apply label,\n    .tui-image-editor-container .tui-image-editor-submenu .tui-image-editor-button:hover > label,\n    .tui-image-editor-container .tui-image-editor-checkbox label > span {\n        '+t+"\n    }\n    .tui-image-editor-container .tui-image-editor-submenu .tui-image-editor-button > label,\n    .tui-image-editor-container .tui-image-editor-range-wrap.tui-image-editor-newline.short label,\n    .tui-image-editor-container .tui-image-editor-range-wrap.tui-image-editor-newline.short label > span {\n        "+n+"\n    }\n    .tui-image-editor-container .tui-image-editor-range-wrap label > span {\n        "+i+"\n    }\n    .tui-image-editor-container .tui-image-editor-partition > div {\n        "+a+"\n    }\n    .tui-image-editor-container.left .tui-image-editor-submenu .tui-image-editor-partition > div,\n    .tui-image-editor-container.right .tui-image-editor-submenu .tui-image-editor-partition > div {\n        "+o+"\n    }\n    .tui-image-editor-container .tui-image-editor-checkbox label > span:before {\n        "+r+"\n    }\n    .tui-image-editor-container .tui-image-editor-checkbox label > input:checked + span:before {\n        border: 0;\n    }\n    .tui-image-editor-container .tui-image-editor-virtual-range-pointer {\n        "+s+"\n    }\n    .tui-image-editor-container .tui-image-editor-virtual-range-bar {\n        "+d+"\n    }\n    .tui-image-editor-container .tui-image-editor-virtual-range-subbar {\n        "+h+"\n    }\n    .tui-image-editor-container .tui-image-editor-disabled .tui-image-editor-virtual-range-pointer {\n        "+f+"\n    }\n    .tui-image-editor-container .tui-image-editor-disabled .tui-image-editor-virtual-range-subbar {\n        "+g+"\n    }\n    .tui-image-editor-container .tui-image-editor-disabled .tui-image-editor-virtual-range-bar {\n        "+p+"\n    }\n    .tui-image-editor-container .tui-image-editor-range-value {\n        "+l+"\n    }\n    .tui-image-editor-container .tui-image-editor-submenu .tui-image-editor-button .color-picker-value + label {\n        "+c+"\n    }\n    .tui-image-editor-container .tui-image-editor-submenu .tui-image-editor-button .color-picker-value {\n        "+u+"\n    }\n    .tui-image-editor-container .svg_ic-menu {\n        "+e.menuIconSize+"\n    }\n    .tui-image-editor-container .svg_ic-submenu {\n        "+v+"\n    }\n    .tui-image-editor-container .tui-image-editor-controls-logo > img,\n    .tui-image-editor-container .tui-image-editor-header-logo > img {\n        "+e.biSize+"\n    }\n\n"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default={"common.bi.image":"https://uicdn.toast.com/toastui/img/tui-image-editor-bi.png","common.bisize.width":"251px","common.bisize.height":"21px","common.backgroundImage":"none","common.backgroundColor":"#1e1e1e","common.border":"0px","header.backgroundImage":"none","header.backgroundColor":"transparent","header.border":"0px","loadButton.backgroundColor":"#fff","loadButton.border":"1px solid #ddd","loadButton.color":"#222","loadButton.fontFamily":"'Noto Sans', sans-serif","loadButton.fontSize":"12px","downloadButton.backgroundColor":"#fdba3b","downloadButton.border":"1px solid #fdba3b","downloadButton.color":"#fff","downloadButton.fontFamily":"'Noto Sans', sans-serif","downloadButton.fontSize":"12px","menu.normalIcon.path":"icon-d.svg","menu.normalIcon.name":"icon-d","menu.activeIcon.path":"icon-b.svg","menu.activeIcon.name":"icon-b","menu.disabledIcon.path":"icon-a.svg","menu.disabledIcon.name":"icon-a","menu.hoverIcon.path":"icon-c.svg","menu.hoverIcon.name":"icon-c","menu.iconSize.width":"24px","menu.iconSize.height":"24px","submenu.backgroundColor":"#1e1e1e","submenu.partition.color":"#3c3c3c","submenu.normalIcon.path":"icon-d.svg","submenu.normalIcon.name":"icon-d","submenu.activeIcon.path":"icon-c.svg","submenu.activeIcon.name":"icon-c","submenu.iconSize.width":"32px","submenu.iconSize.height":"32px","submenu.normalLabel.color":"#8a8a8a","submenu.normalLabel.fontWeight":"lighter","submenu.activeLabel.color":"#fff","submenu.activeLabel.fontWeight":"lighter","checkbox.border":"0px","checkbox.backgroundColor":"#fff","range.pointer.color":"#fff","range.bar.color":"#666","range.subbar.color":"#d1d1d1","range.disabledPointer.color":"#414141","range.disabledBar.color":"#282828","range.disabledSubbar.color":"#414141","range.value.color":"#fff","range.value.fontWeight":"lighter","range.value.fontSize":"11px","range.value.border":"1px solid #353535","range.value.backgroundColor":"#151515","range.title.color":"#fff","range.title.fontWeight":"lighter","colorpicker.button.border":"1px solid #1e1e1e","colorpicker.title.color":"#fff"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var s=d(n(15)),l=d(n(16)),o=d(n(9)),c=d(n(88)),r=n(4),u=n(0);function d(e){return e&&e.__esModule?e:{default:e}}var h={stroke:"#ffbb3b",fill:"",strokeWidth:3},f=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(p,o.default),i(p,[{key:"addEvent",value:function(e){this.actions=e,this._els.shapeSelectButton.addEventListener("click",this._changeShapeHandler.bind(this)),this._els.strokeRange.on("change",this._changeStrokeRangeHandler.bind(this)),this._els.fillColorpicker.on("change",this._changeFillColorHandler.bind(this)),this._els.strokeColorpicker.on("change",this._changeStrokeColorHandler.bind(this)),this._els.fillColorpicker.on("changeShow",this.colorPickerChangeShow.bind(this)),this._els.strokeColorpicker.on("changeShow",this.colorPickerChangeShow.bind(this)),this._els.strokeRangeValue.value=this._els.strokeRange.value,this._els.strokeRangeValue.setAttribute("readonly",!0)}},{key:"setShapeStatus",value:function(e){var t=e.strokeWidth,n=e.strokeColor,i=e.fillColor;this._els.strokeRange.value=t,this._els.strokeRange.trigger("change"),this._els.strokeColorpicker.color=n,this._els.fillColorpicker.color=i,this.options.stroke=n,this.options.fill=i,this.options.strokeWidth=t}},{key:"changeStartMode",value:function(){this.actions.stopDrawingMode()}},{key:"changeStandbyMode",value:function(){this.type=null,this.actions.changeSelectableAll(!0),this._els.shapeSelectButton.classList.remove("circle"),this._els.shapeSelectButton.classList.remove("triangle"),this._els.shapeSelectButton.classList.remove("rect")}},{key:"setMaxStrokeValue",value:function(e){var t=e;t<=0&&(t=u.defaultShapeStrokeValus.max),this._els.strokeRange.max=t}},{key:"setStrokeValue",value:function(e){this._els.strokeRange.value=e,this._els.strokeRange.trigger("change")}},{key:"getStrokeValue",value:function(){return this._els.strokeRange.value}},{key:"_changeShapeHandler",value:function(e){var t=e.target.closest(".tui-image-editor-button");if(t){this.actions.stopDrawingMode(),this.actions.discardSelection();var n=this.getButtonType(t,["circle","triangle","rect"]);if(this.type===n)return void this.changeStandbyMode();this.changeStandbyMode(),this.type=n,e.currentTarget.classList.add(n),this.actions.changeSelectableAll(!1),this.actions.modeChange("shape")}}},{key:"_changeStrokeRangeHandler",value:function(e){this.options.strokeWidth=(0,r.toInteger)(e),this._els.strokeRangeValue.value=(0,r.toInteger)(e),this.actions.changeShape({strokeWidth:e}),this.actions.setDrawingShape(this.type,this.options)}},{key:"_changeFillColorHandler",value:function(e){e=e||"transparent",this.options.fill=e,this.actions.changeShape({fill:e})}},{key:"_changeStrokeColorHandler",value:function(e){e=e||"transparent",this.options.stroke=e,this.actions.changeShape({stroke:e})}}]),p);function p(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,p);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(p.__proto__||Object.getPrototypeOf(p)).call(this,e,{locale:n,name:"shape",iconStyle:i,menuBarPosition:a,templateHtml:c.default,usageStatistics:o}));return r.type=null,r.options=h,r._els={shapeSelectButton:r.selector(".tie-shape-button"),shapeColorButton:r.selector(".tie-shape-color-button"),strokeRange:new l.default(r.selector(".tie-stroke-range"),u.defaultShapeStrokeValus),strokeRangeValue:r.selector(".tie-stroke-range-value"),fillColorpicker:new s.default(r.selector(".tie-color-fill"),"",r.toggleDirection,r.usageStatistics),strokeColorpicker:new s.default(r.selector(".tie-color-stroke"),"#ffbb3b",r.toggleDirection,r.usageStatistics)},r.colorPickerControls.push(r._els.fillColorpicker),r.colorPickerControls.push(r._els.strokeColorpicker),r}t.default=f},function(e,t){e.exports=a},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-shape-button">\n            <div class="tui-image-editor-button rect">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-shape-rectangle"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-shape-rectangle"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Rectangle")+' </label>\n            </div>\n            <div class="tui-image-editor-button circle">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-shape-circle"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-shape-circle"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Circle")+' </label>\n            </div>\n            <div class="tui-image-editor-button triangle">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-shape-triangle"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-shape-triangle"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Triangle")+' </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li class="tie-shape-color-button">\n            <div class="tie-color-fill" title="'+t.localize("Fill")+'"></div>\n            <div class="tie-color-stroke" title="'+t.localize("Stroke")+'"></div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-newline tui-image-editor-range-wrap">\n            <label class="range">'+t.localize("Stroke")+'</label>\n            <div class="tie-stroke-range"></div>\n            <input class="tie-stroke-range-value tui-image-editor-range-value" value="0" />\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(1)),r=l(n(9)),s=l(n(90));function l(e){return e&&e.__esModule?e:{default:e}}var c=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(u,r.default),i(u,[{key:"addEvent",value:function(e){var i=this;this.actions=e,this._els.apply.addEventListener("click",function(){i.actions.crop(),i._els.apply.classList.remove("active")}),this._els.cancel.addEventListener("click",function(){i.actions.cancel(),i._els.apply.classList.remove("active")}),this._els.preset.addEventListener("click",function(e){var t=e.target.closest(".tui-image-editor-button.preset");if(t){var n=t.className.match(/preset-[^\s]+/)[0];i._setPresetButtonActive(t),i.actions.preset(n)}})}},{key:"changeStartMode",value:function(){this.actions.modeChange("crop")}},{key:"changeStandbyMode",value:function(){this.actions.stopDrawingMode(),this._setPresetButtonActive()}},{key:"changeApplyButtonStatus",value:function(e){e?this._els.apply.classList.add("active"):this._els.apply.classList.remove("active")}},{key:"_setPresetButtonActive",value:function(e){var t=0<arguments.length&&void 0!==e?e:this.defaultPresetButton;o.default.forEach([].slice.call(this._els.preset.querySelectorAll(".preset")),function(e){e.classList.remove("active")}),t&&t.classList.add("active")}}]),u);function u(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,e,{locale:n,name:"crop",iconStyle:i,menuBarPosition:a,templateHtml:s.default,usageStatistics:o}));return r.status="active",r._els={apply:r.selector(".tie-crop-button .apply"),cancel:r.selector(".tie-crop-button .cancel"),preset:r.selector(".tie-crop-preset-button")},r.defaultPresetButton=r._els.preset.querySelector(".preset-none"),r}t.default=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-crop-preset-button">\n            <div class="tui-image-editor-button preset preset-none active">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-shape-rectangle"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-shape-rectangle"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Custom")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-square">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Square")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-3-2">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("3:2")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-4-3">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("4:3")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-5-4">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("5:4")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-7-5">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("7:5")+' </label>\n            </div>\n            <div class="tui-image-editor-button preset preset-16-9">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-crop"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-crop"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("16:9")+' </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition tui-image-editor-newline">\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tie-crop-button action">\n            <div class="tui-image-editor-button apply">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+i.path+"#"+i.name+'-ic-apply" class="normal"/>\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-apply" class="active"/>\n                </svg>\n                <label>\n                    '+t.localize("Apply")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button cancel">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+i.path+"#"+i.name+'-ic-cancel" class="normal"/>\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-cancel" class="active"/>\n                </svg>\n                <label>\n                    '+t.localize("Cancel")+"\n                </label>\n            </div>\n        </li>\n    </ul>\n"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(1)),r=l(n(9)),s=l(n(92));function l(e){return e&&e.__esModule?e:{default:e}}var c=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(u,r.default),i(u,[{key:"addEvent",value:function(e){this._actions=e,this._els.flipButton.addEventListener("click",this._changeFlip.bind(this))}},{key:"_changeFlip",value:function(e){var i=this,t=e.target.closest(".tui-image-editor-button");if(t){var n=this.getButtonType(t,["flipX","flipY","resetFlip"]);if(!this.flipStatus&&"resetFlip"===n)return;this._actions.flip(n).then(function(t){var n=i._els.flipButton.classList;i.flipStatus=!1,n.remove("resetFlip"),o.default.forEach(["flipX","flipY"],function(e){n.remove(e),t[e]&&(n.add(e),n.add("resetFlip"),i.flipStatus=!0)})})}}}]),u);function u(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,e,{locale:n,name:"flip",iconStyle:i,menuBarPosition:a,templateHtml:s.default,usageStatistics:o}));return r.flipStatus=!1,r._els={flipButton:r.selector(".tie-flip-button")},r}t.default=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tie-flip-button tui-image-editor-submenu-item">\n        <li>\n            <div class="tui-image-editor-button flipX">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-flip-x" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-flip-x" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Flip X")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button flipY">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-flip-y" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-flip-y" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Flip Y")+'\n                </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li>\n            <div class="tui-image-editor-button resetFlip">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-flip-reset"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-flip-reset"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Reset")+"\n                </label>\n            </div>\n        </li>\n    </ul>\n"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var s=u(n(16)),o=u(n(9)),l=u(n(94)),r=n(4),c=n(0);function u(e){return e&&e.__esModule?e:{default:e}}var d=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(h,o.default),i(h,[{key:"setRangeBarAngle",value:function(e,t){var n=t;"rotate"===e&&(n=parseInt(this._els.rotateRangeValue.value,10)+t),this._els.rotateRangeValue.value=n,this._setRangeBarRatio(n)}},{key:"_setRangeBarRatio",value:function(e){this._els.rotateRange.value=e}},{key:"addEvent",value:function(e){this.actions=e,this._els.rotateButton.addEventListener("click",this._changeRotateForButton.bind(this)),this._els.rotateRange.on("change",this._changeRotateForRange.bind(this)),this._els.rotateRangeValue.setAttribute("readonly",!0)}},{key:"_changeRotateForRange",value:function(e,t){var n=(0,r.toInteger)(e);this._els.rotateRangeValue.value=n,this.actions.setAngle(n,!t),this._value=n}},{key:"_changeRotateForButton",value:function(e){var t=e.target.closest(".tui-image-editor-button"),n=this._els.rotateRangeValue.value;if(t){var i={clockwise:30,counterclockwise:-30}[this.getButtonType(t,["counterclockwise","clockwise"])],a=parseInt(n,10)+i;-360<=a&&a<=360&&this.actions.rotate(i)}}}]),h);function h(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,h);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(h.__proto__||Object.getPrototypeOf(h)).call(this,e,{locale:n,name:"rotate",iconStyle:i,menuBarPosition:a,templateHtml:l.default,usageStatistics:o}));return r._value=0,r._els={rotateButton:r.selector(".tie-retate-button"),rotateRange:new s.default(r.selector(".tie-rotate-range"),c.defaultRotateRangeValus),rotateRangeValue:r.selector(".tie-ratate-range-value")},r}t.default=d},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-retate-button">\n            <div class="tui-image-editor-button clockwise">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-rotate-clockwise"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-rotate-clockwise"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> 30 </label>\n            </div>\n            <div class="tui-image-editor-button counterclockwise">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-rotate-counterclockwise"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-rotate-counterclockwise"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> -30 </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-newline tui-image-editor-range-wrap">\n            <label class="range">'+t.localize("Range")+'</label>\n            <div class="tie-rotate-range"></div>\n            <input class="tie-ratate-range-value tui-image-editor-range-value" value="0" />\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var s=d(n(16)),l=d(n(15)),o=d(n(9)),c=d(n(96)),r=n(4),u=n(0);function d(e){return e&&e.__esModule?e:{default:e}}var h=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(f,o.default),i(f,[{key:"addEvent",value:function(e){this.actions=e,this._els.textEffectButton.addEventListener("click",this._setTextEffectHandler.bind(this)),this._els.textAlignButton.addEventListener("click",this._setTextAlignHandler.bind(this)),this._els.textRange.on("change",this._changeTextRnageHandler.bind(this)),this._els.textRangeValue.value=this._els.textRange.value,this._els.textRangeValue.setAttribute("readonly",!0),this._els.textColorpicker.on("change",this._changeColorHandler.bind(this))}},{key:"changeStandbyMode",value:function(){this.actions.stopDrawingMode()}},{key:"changeStartMode",value:function(){this.actions.modeChange("text")}},{key:"_setTextEffectHandler",value:function(e){var t=e.target.closest(".tui-image-editor-button"),n=t.className.match(/(bold|italic|underline)/)[0],i={bold:{fontWeight:"bold"},italic:{fontStyle:"italic"},underline:{underline:!0,textDecoration:"underline"}}[n];this.effect[n]=!this.effect[n],t.classList.toggle("active"),this.actions.changeTextStyle(i)}},{key:"_setTextAlignHandler",value:function(e){var t=e.target.closest(".tui-image-editor-button");if(t){var n=this.getButtonType(t,["left","center","right"]);e.currentTarget.classList.remove(this.align),this.align!==n&&e.currentTarget.classList.add(n),this.actions.changeTextStyle({textAlign:n}),this.align=n}}},{key:"_changeTextRnageHandler",value:function(e){e=(0,r.toInteger)(e),(0,r.toInteger)(this._els.textRangeValue.value)!==e&&(this.actions.changeTextStyle({fontSize:e}),this._els.textRangeValue.value=e)}},{key:"_changeColorHandler",value:function(e){e=e||"transparent",this.actions.changeTextStyle({fill:e})}},{key:"textColor",get:function(){return this._els.textColorpicker.color}},{key:"fontSize",get:function(){return this._els.textRange.value},set:function(e){this._els.textRange.value=e,this._els.textRangeValue.value=e}}]),f);function f(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,f);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(f.__proto__||Object.getPrototypeOf(f)).call(this,e,{locale:n,name:"text",iconStyle:i,menuBarPosition:a,templateHtml:c.default,usageStatistics:o}));return r.effect={bold:!1,italic:!1,underline:!1},r.align="left",r._els={textEffectButton:r.selector(".tie-text-effect-button"),textAlignButton:r.selector(".tie-text-align-button"),textColorpicker:new l.default(r.selector(".tie-text-color"),"#ffbb3b",r.toggleDirection,r.usageStatistics),textRange:new s.default(r.selector(".tie-text-range"),u.defaultTextRangeValus),textRangeValue:r.selector(".tie-text-range-value")},r}t.default=h},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-text-effect-button">\n            <div class="tui-image-editor-button bold">\n                <div>\n                    <svg class="svg_ic-submenu">\n                    <use xlink:href="'+i.path+"#"+i.name+'-ic-text-bold" class="normal"/>\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-text-bold" class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Bold")+' </label>\n            </div>\n            <div class="tui-image-editor-button italic">\n                <div>\n                    <svg class="svg_ic-submenu">\n                    <use xlink:href="'+i.path+"#"+i.name+'-ic-text-italic" class="normal"/>\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-text-italic" class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Italic")+' </label>\n            </div>\n            <div class="tui-image-editor-button underline">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-text-underline"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-text-underline"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Underline")+' </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li class="tie-text-align-button">\n            <div class="tui-image-editor-button left">\n                <div>\n                    <svg class="svg_ic-submenu">\n                     <use xlink:href="'+i.path+"#"+i.name+'-ic-text-align-left"\n                        class="normal"/>\n                     <use xlink:href="'+a.path+"#"+a.name+'-ic-text-align-left"\n                        class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Left")+' </label>\n            </div>\n            <div class="tui-image-editor-button center">\n                <div>\n                    <svg class="svg_ic-submenu">\n                     <use xlink:href="'+i.path+"#"+i.name+'-ic-text-align-center"\n                        class="normal"/>\n                     <use xlink:href="'+a.path+"#"+a.name+'-ic-text-align-center"\n                        class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Center")+' </label>\n            </div>\n            <div class="tui-image-editor-button right">\n                <div>\n                    <svg class="svg_ic-submenu">\n                     <use xlink:href="'+i.path+"#"+i.name+'-ic-text-align-right"\n                        class="normal"/>\n                     <use xlink:href="'+a.path+"#"+a.name+'-ic-text-align-right"\n                        class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Right")+' </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li>\n            <div class="tie-text-color" title="'+t.localize("Color")+'"></div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-newline tui-image-editor-range-wrap">\n            <label class="range">'+t.localize("Text size")+'</label>\n            <div class="tie-text-range"></div>\n            <input class="tie-text-range-value tui-image-editor-range-value" value="0" />\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(9)),r=l(n(4)),s=l(n(98));function l(e){return e&&e.__esModule?e:{default:e}}var c=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(u,o.default),i(u,[{key:"addEvent",value:function(e){this.actions=e,this._els.maskImageButton.addEventListener("change",this._loadMaskFile.bind(this)),this._els.applyButton.addEventListener("click",this._applyMask.bind(this))}},{key:"_applyMask",value:function(){this.actions.applyFilter(),this._els.applyButton.classList.remove("active")}},{key:"_loadMaskFile",value:function(e){var t=void 0;r.default.isSupportFileApi()||alert("This browser does not support file-api");var n=e.target.files[0];n&&(t=URL.createObjectURL(n),this.actions.loadImageFromURL(t,n),this._els.applyButton.classList.add("active"))}}]),u);function u(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,e,{locale:n,name:"mask",iconStyle:i,menuBarPosition:a,templateHtml:s.default,usageStatistics:o}));return r._els={applyButton:r.selector(".tie-mask-apply"),maskImageButton:r.selector(".tie-mask-image-file")},r}t.default=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li>\n            <div class="tui-image-editor-button">\n                <div>\n                    <input type="file" accept="image/*" class="tie-mask-image-file">\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-mask-load" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-mask-load" class="active"/>\n                    </svg>\n                </div>\n                <label> '+t.localize("Load Mask Image")+' </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tie-mask-apply tui-image-editor-newline apply" style="margin-top: 22px;margin-bottom: 5px">\n            <div class="tui-image-editor-button apply">\n                <svg class="svg_ic-menu">\n                    <use xlink:href="'+i.path+"#"+i.name+'-ic-apply" class="normal"/>\n                    <use xlink:href="'+a.path+"#"+a.name+'-ic-apply" class="active"/>\n                </svg>\n                <label>\n                    '+t.localize("Apply")+"\n                </label>\n            </div>\n        </li>\n    </ul>\n"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=d(n(1)),s=d(n(15)),r=d(n(9)),l=d(n(100)),c=n(4),u=n(0);function d(e){return e&&e.__esModule?e:{default:e}}var h=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(f,r.default),i(f,[{key:"addEvent",value:function(e){this.actions=e,this._els.iconColorpicker.on("change",this._changeColorHandler.bind(this)),this._els.registIconButton.addEventListener("change",this._registeIconHandler.bind(this)),this._els.addIconButton.addEventListener("click",this._addIconHandler.bind(this))}},{key:"clearIconType",value:function(){this._els.addIconButton.classList.remove(this.iconType),this.iconType=null}},{key:"registDefaultIcon",value:function(){var n=this;o.default.forEach(u.defaultIconPath,function(e,t){n.actions.registDefalutIcons(t,e)})}},{key:"setIconPickerColor",value:function(e){this._els.iconColorpicker.color=e}},{key:"changeStandbyMode",value:function(){this.clearIconType(),this.actions.cancelAddIcon()}},{key:"_changeColorHandler",value:function(e){e=e||"transparent",this.actions.changeColor(e)}},{key:"_addIconHandler",value:function(e){var t=e.target.closest(".tui-image-editor-button");if(t){var n=t.getAttribute("data-icontype"),i=this._els.iconColorpicker.color;this.actions.discardSelection(),this.actions.changeSelectableAll(!1),this._els.addIconButton.classList.remove(this.iconType),this._els.addIconButton.classList.add(n),this.iconType===n?this.changeStandbyMode():(this.actions.addIcon(n,i),this.iconType=n)}}},{key:"_registeIconHandler",value:function(e){var t=void 0;c.isSupportFileApi||alert("This browser does not support file-api");var n=e.target.files[0];n&&(t=URL.createObjectURL(n),this.actions.registCustomIcon(t,n))}}]),f);function f(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,f);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(f.__proto__||Object.getPrototypeOf(f)).call(this,e,{locale:n,name:"icon",iconStyle:i,menuBarPosition:a,templateHtml:l.default,usageStatistics:o}));return r.iconType=null,r._iconMap={},r._els={registIconButton:r.selector(".tie-icon-image-file"),addIconButton:r.selector(".tie-icon-add-button"),iconColorpicker:new s.default(r.selector(".tie-icon-color"),"#ffbb3b",r.toggleDirection,r.usageStatistics)},r}t.default=h},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-icon-add-button">\n            <div class="tui-image-editor-button" data-icontype="icon-arrow">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-arrow"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-arrow"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Arrow")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button" data-icontype="icon-arrow-2">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-arrow-2"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-arrow-2"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Arrow-2")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button" data-icontype="icon-arrow-3">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-arrow-3"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-arrow-3"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Arrow-3")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button" data-icontype="icon-star">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-star" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-star" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Star-1")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button" data-icontype="icon-star-2">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-star-2"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-star-2"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Star-2")+'\n                </label>\n            </div>\n\n            <div class="tui-image-editor-button" data-icontype="icon-polygon">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-polygon"\n                            class="normal"/>\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-polygon"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Polygon")+'\n                </label>\n            </div>\n\n            <div class="tui-image-editor-button" data-icontype="icon-location">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-location"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-location"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Location")+'\n                </label>\n            </div>\n\n            <div class="tui-image-editor-button" data-icontype="icon-heart">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-heart"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-heart"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Heart")+'\n                </label>\n            </div>\n\n            <div class="tui-image-editor-button" data-icontype="icon-bubble">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-bubble"\n                            class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-bubble"\n                            class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Bubble")+'\n                </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li class="tie-icon-add-button">\n            <div class="tui-image-editor-button" style="margin:0">\n                <div>\n                    <input type="file" accept="image/*" class="tie-icon-image-file">\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-icon-load" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-icon-load" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Custom icon")+'\n                </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li>\n            <div class="tie-icon-color" title="'+t.localize("Color")+'"></div>\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=d(n(4)),s=d(n(15)),l=d(n(16)),r=d(n(9)),c=d(n(102)),u=n(0);function d(e){return e&&e.__esModule?e:{default:e}}var h=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(f,r.default),i(f,[{key:"addEvent",value:function(e){this.actions=e,this._els.lineSelectButton.addEventListener("click",this._changeDrawType.bind(this)),this._els.drawColorpicker.on("change",this._changeDrawColor.bind(this)),this._els.drawRange.on("change",this._changeDrawRange.bind(this)),this._els.drawRangeValue.value=this._els.drawRange.value,this._els.drawRangeValue.setAttribute("readonly",!0)}},{key:"setDrawMode",value:function(){this.actions.setDrawMode(this.type,{width:this.width,color:o.default.getRgb(this.color,.7)})}},{key:"changeStandbyMode",value:function(){this.type=null,this.actions.stopDrawingMode(),this.actions.changeSelectableAll(!0),this._els.lineSelectButton.classList.remove("free"),this._els.lineSelectButton.classList.remove("line")}},{key:"changeStartMode",value:function(){this.type="free",this._els.lineSelectButton.classList.add("free"),this.setDrawMode()}},{key:"_changeDrawType",value:function(e){var t=e.target.closest(".tui-image-editor-button");if(t){var n=this.getButtonType(t,["free","line"]);if(this.actions.discardSelection(),this.type===n)return void this.changeStandbyMode();this.changeStandbyMode(),this.type=n,this._els.lineSelectButton.classList.add(n),this.setDrawMode()}}},{key:"_changeDrawColor",value:function(e){this.color=e||"transparent",this.type?this.setDrawMode():this.changeStartMode()}},{key:"_changeDrawRange",value:function(e){e=o.default.toInteger(e),this._els.drawRangeValue.value=e,this.width=e,this.type?this.setDrawMode():this.changeStartMode()}}]),f);function f(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,f);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(f.__proto__||Object.getPrototypeOf(f)).call(this,e,{locale:n,name:"draw",iconStyle:i,menuBarPosition:a,templateHtml:c.default,usageStatistics:o}));return r._els={lineSelectButton:r.selector(".tie-draw-line-select-button"),drawColorpicker:new s.default(r.selector(".tie-draw-color"),"#00a9ff",r.toggleDirection,r.usageStatistics),drawRange:new l.default(r.selector(".tie-draw-range"),u.defaultDrawRangeValus),drawRangeValue:r.selector(".tie-draw-range-value")},r.type=null,r.color=r._els.drawColorpicker.color,r.width=r._els.drawRange.value,r}t.default=h},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale,n=e.iconStyle,i=n.normal,a=n.active;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tie-draw-line-select-button">\n            <div class="tui-image-editor-button free">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-draw-free" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-draw-free" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Free")+'\n                </label>\n            </div>\n            <div class="tui-image-editor-button line">\n                <div>\n                    <svg class="svg_ic-submenu">\n                        <use xlink:href="'+i.path+"#"+i.name+'-ic-draw-line" class="normal"/>\n                        <use xlink:href="'+a.path+"#"+a.name+'-ic-draw-line" class="active"/>\n                    </svg>\n                </div>\n                <label>\n                    '+t.localize("Straight")+'\n                </label>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li>\n            <div class="tie-draw-color" title="'+t.localize("Color")+'"></div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-newline tui-image-editor-range-wrap">\n            <label class="range">'+t.localize("Range")+'</label>\n            <div class="tie-draw-range"></div>\n            <input class="tie-draw-range-value tui-image-editor-range-value" value="0" />\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=h(n(1)),r=h(n(15)),s=h(n(16)),l=h(n(9)),c=h(n(104)),u=n(4),d=n(0);function h(e){return e&&e.__esModule?e:{default:e}}var f=["add","diff","subtract","multiply","screen","lighten","darken"],p=["grayscale","invert","sepia","sepia2","blur","sharpen","emboss","remove-white","brightness","noise","pixelate","color-filter","tint","multiply","blend"],g={grayscale:"grayscale",invert:"invert",sepia:"sepia",sepia2:"vintage",blur:"blur",sharpen:"sharpen",emboss:"emboss",removeWhite:"removeColor",brightness:"brightness",contrast:"contrast",saturation:"saturation",vintage:"vintage",polaroid:"polaroid",noise:"noise",pixelate:"pixelate",colorFilter:"removeColor",tint:"blendColor",multiply:"blendColor",blend:"blendColor",hue:"hue",gamma:"gamma"},v=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(m,l.default),i(m,[{key:"addEvent",value:function(e){var i=this,t=e.applyFilter,a=this._changeRangeValue.bind(this,t);o.default.forEach(p,function(e){var t=i.selector(".tie-"+e),n=(0,u.toCamelCase)(e);(i.checkedMap[n]=t).addEventListener("change",function(){return a(n)})}),this._els.removewhiteDistanceRange.on("change",function(){return a("removeWhite")}),this._els.colorfilterThresholeRange.on("change",function(){return a("colorFilter")}),this._els.pixelateRange.on("change",function(){return a("pixelate")}),this._els.noiseRange.on("change",function(){return a("noise")}),this._els.brightnessRange.on("change",function(){return a("brightness")}),this._els.blendType.addEventListener("change",function(){return a("blend")}),this._els.filterBlendColor.on("change",function(){return a("blend")}),this._els.filterMultiplyColor.on("change",function(){return a("multiply")}),this._els.tintOpacity.on("change",function(){return a("tint")}),this._els.filterTintColor.on("change",function(){return a("tint")}),this._els.blendType.addEventListener("click",function(e){return e.stopPropagation()}),this._els.filterMultiplyColor.on("changeShow",this.colorPickerChangeShow.bind(this)),this._els.filterTintColor.on("changeShow",this.colorPickerChangeShow.bind(this)),this._els.filterBlendColor.on("changeShow",this.colorPickerChangeShow.bind(this))}},{key:"_changeRangeValue",value:function(e,t){var n=this.checkedMap[t].checked,i=g[t],a=this.checkedMap[t].closest(".tui-image-editor-checkbox-group");a&&(n?a.classList.remove("tui-image-editor-disabled"):a.classList.add("tui-image-editor-disabled")),e(n,i,this._getFilterOption(t))}},{key:"_getFilterOption",value:function(e){var t={};switch(e){case"removeWhite":t.color="#FFFFFF",t.useAlpha=!1,t.distance=parseFloat(this._els.removewhiteDistanceRange.value);break;case"colorFilter":t.color="#FFFFFF",t.distance=parseFloat(this._els.colorfilterThresholeRange.value);break;case"pixelate":t.blocksize=(0,u.toInteger)(this._els.pixelateRange.value);break;case"noise":t.noise=(0,u.toInteger)(this._els.noiseRange.value);break;case"brightness":t.brightness=parseFloat(this._els.brightnessRange.value);break;case"blend":t.mode="add",t.color=this._els.filterBlendColor.color,t.mode=this._els.blendType.value;break;case"multiply":t.mode="multiply",t.color=this._els.filterMultiplyColor.color;break;case"tint":t.mode="tint",t.color=this._els.filterTintColor.color,t.alpha=this._els.tintOpacity.value}return t}},{key:"_makeControlElement",value:function(){this._els={removewhiteDistanceRange:new s.default(this.selector(".tie-removewhite-distance-range"),d.defaultFilterRangeValus.removewhiteDistanceRange),brightnessRange:new s.default(this.selector(".tie-brightness-range"),d.defaultFilterRangeValus.brightnessRange),noiseRange:new s.default(this.selector(".tie-noise-range"),d.defaultFilterRangeValus.noiseRange),pixelateRange:new s.default(this.selector(".tie-pixelate-range"),d.defaultFilterRangeValus.pixelateRange),colorfilterThresholeRange:new s.default(this.selector(".tie-colorfilter-threshole-range"),d.defaultFilterRangeValus.colorfilterThresholeRange),filterTintColor:new r.default(this.selector(".tie-filter-tint-color"),"#03bd9e",this.toggleDirection,this.usageStatistics),filterMultiplyColor:new r.default(this.selector(".tie-filter-multiply-color"),"#515ce6",this.toggleDirection,this.usageStatistics),filterBlendColor:new r.default(this.selector(".tie-filter-blend-color"),"#ffbb3b",this.toggleDirection,this.usageStatistics)},this._els.tintOpacity=this._pickerWithRange(this._els.filterTintColor.pickerControl),this._els.blendType=this._pickerWithSelectbox(this._els.filterBlendColor.pickerControl),this.colorPickerControls.push(this._els.filterTintColor),this.colorPickerControls.push(this._els.filterMultiplyColor),this.colorPickerControls.push(this._els.filterBlendColor)}},{key:"_pickerWithRange",value:function(e){var t=document.createElement("div"),n=document.createElement("label"),i=document.createElement("div");return i.id="tie-filter-tint-opacity",n.innerHTML="Opacity",t.appendChild(n),t.appendChild(i),e.appendChild(t),e.style.height="130px",new s.default(i,d.defaultFilterRangeValus.tintOpacityRange)}},{key:"_pickerWithSelectbox",value:function(e){var t=document.createElement("div"),n=document.createElement("select"),i=document.createElement("ul");return t.className="tui-image-editor-selectlist-wrap",i.className="tui-image-editor-selectlist",t.appendChild(n),t.appendChild(i),this._makeSelectOptionList(n),e.appendChild(t),e.style.height="130px",this._drawSelectOptionList(n,i),this._pickerWithSelectboxForAddEvent(n,i),n}},{key:"_drawSelectOptionList",value:function(e,n){var t=e.querySelectorAll("option");o.default.forEach(t,function(e){var t=document.createElement("li");t.innerHTML=e.innerHTML,t.setAttribute("data-item",e.value),n.appendChild(t)})}},{key:"_pickerWithSelectboxForAddEvent",value:function(i,a){var o=this;a.addEventListener("click",function(e){var t=e.target.getAttribute("data-item"),n=document.createEvent("HTMLEvents");i.querySelector('[value="'+t+'"]').selected=!0,n.initEvent("change",!0,!0),i.dispatchEvent(n),o.selectBoxShow=!1,a.style.display="none"}),i.addEventListener("mousedown",function(e){e.preventDefault(),o.selectBoxShow=!o.selectBoxShow,a.style.display=o.selectBoxShow?"block":"none",a.setAttribute("data-selectitem",i.value),a.querySelector("[data-item='"+i.value+"']").classList.add("active")})}},{key:"_makeSelectOptionList",value:function(n){o.default.forEach(f,function(e){var t=document.createElement("option");t.setAttribute("value",e),t.innerHTML=e.replace(/^[a-z]/,function(e){return e.toUpperCase()}),n.appendChild(t)})}}]),m);function m(e,t){var n=t.locale,i=t.iconStyle,a=t.menuBarPosition,o=t.usageStatistics;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,m);var r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(m.__proto__||Object.getPrototypeOf(m)).call(this,e,{locale:n,name:"filter",iconStyle:i,menuBarPosition:a,templateHtml:c.default,usageStatistics:o}));return r.selectBoxShow=!1,r.checkedMap={},r._makeControlElement(),r}t.default=v},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.locale;return'\n    <ul class="tui-image-editor-submenu-item">\n        <li class="tui-image-editor-submenu-align">\n            <div class="tui-image-editor-checkbox-wrap fixed-width">\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-grayscale">\n                        <span>'+t.localize("Grayscale")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-invert">\n                        <span>'+t.localize("Invert")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-sepia">\n                        <span>'+t.localize("Sepia")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-sepia2">\n                        <span>'+t.localize("Sepia2")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-blur">\n                        <span>'+t.localize("Blur")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-sharpen">\n                        <span>'+t.localize("Sharpen")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-emboss">\n                        <span>'+t.localize("Emboss")+'</span>\n                    </label>\n                </div>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-submenu-align">\n            <div class="tui-image-editor-checkbox-group tui-image-editor-disabled" style="margin-bottom: 7px;">\n                <div class="tui-image-editor-checkbox-wrap">\n                    <div class="tui-image-editor-checkbox">\n                        <label>\n                            <input type="checkbox" class="tie-remove-white">\n                            <span>'+t.localize("Remove White")+'</span>\n                        </label>\n                    </div>\n                </div>\n                <div class="tui-image-editor-newline tui-image-editor-range-wrap short">\n                    <label>'+t.localize("Distance")+'</label>\n                    <div class="tie-removewhite-distance-range"></div>\n                </div>\n            </div>\n            <div class="tui-image-editor-checkbox-group tui-image-editor-disabled">\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-brightness">\n                        <span>'+t.localize("Brightness")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-range-wrap short">\n                    <div class="tie-brightness-range"></div>\n                </div>\n            </div>\n            <div class="tui-image-editor-checkbox-group tui-image-editor-disabled">\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-noise">\n                        <span>'+t.localize("Noise")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-range-wrap short">\n                    <div class="tie-noise-range"></div>\n                </div>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition only-left-right">\n            <div></div>\n        </li>\n        <li class="tui-image-editor-submenu-align">\n            <div class="tui-image-editor-checkbox-group tui-image-editor-disabled">\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-pixelate">\n                        <span>'+t.localize("Pixelate")+'</span>\n                    </label>\n                </div>\n                <div class="tui-image-editor-range-wrap short">\n                    <div class="tie-pixelate-range"></div>\n                </div>\n            </div>\n            <div class="tui-image-editor-checkbox-group tui-image-editor-disabled">\n                <div class="tui-image-editor-newline tui-image-editor-checkbox-wrap">\n                    <div class="tui-image-editor-checkbox">\n                        <label>\n                            <input type="checkbox" class="tie-color-filter">\n                            <span>'+t.localize("Color Filter")+'</span>\n                        </label>\n                    </div>\n                </div>\n                <div class="tui-image-editor-newline tui-image-editor-range-wrap short">\n                    <label>'+t.localize("Threshold")+'</label>\n                    <div class="tie-colorfilter-threshole-range"></div>\n                </div>\n            </div>\n        </li>\n        <li class="tui-image-editor-partition">\n            <div></div>\n        </li>\n        <li>\n            <div class="filter-color-item">\n                <div class="tie-filter-tint-color" title="'+t.localize("Tint")+'"></div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-tint">\n                        <span></span>\n                    </label>\n                </div>\n            </div>\n            <div class="filter-color-item">\n                <div class="tie-filter-multiply-color" title="'+t.localize("Multiply")+'"></div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-multiply">\n                        <span></span>\n                    </label>\n                </div>\n            </div>\n            <div class="filter-color-item">\n                <div class="tie-filter-blend-color" title="'+t.localize("Blend")+'"></div>\n                <div class="tui-image-editor-checkbox">\n                    <label>\n                        <input type="checkbox" class="tie-blend">\n                        <span></span>\n                    </label>\n                </div>\n            </div>\n        </li>\n    </ul>\n'}},function(e,t,n){"use strict";function i(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}Object.defineProperty(t,"__esModule",{value:!0});var a=(function(e,t,n){return t&&i(e.prototype,t),n&&i(e,n),e}(o,[{key:"localize",value:function(e){return this._locale[e]||e}}]),o);function o(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),this._locale=e}t.default=a},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=n(1),o=i(n(4)),d=i(n(107));function i(e){return e&&e.__esModule?e:{default:e}}t.default={getActions:function(){return{main:this._mainAction(),shape:this._shapeAction(),crop:this._cropAction(),flip:this._flipAction(),rotate:this._rotateAction(),text:this._textAction(),mask:this._maskAction(),draw:this._drawAction(),icon:this._iconAction(),filter:this._filterAction()}},_mainAction:function(){function n(){"crop"===a.ui.submenu&&(a.stopDrawingMode(),a.ui.changeMenu("crop"))}function e(e){var t;return t=e,"rotate"===a.ui.submenu&&a.ui.rotate.setRangeBarAngle("setAngle",t),e}var a=this;return(0,u.extend)({initLoadImage:function(t,e){return a.loadImageFromURL(t,e).then(function(e){n(),a.ui.initializeImgUrl=t,a.ui.resizeEditor({imageSize:e}),a.clearUndoStack()})},undo:function(){a.isEmptyUndoStack()||(n(),a.undo().then(e))},redo:function(){a.isEmptyRedoStack()||(n(),a.redo().then(e))},reset:function(){n(),a.loadImageFromURL(a.ui.initializeImgUrl,"resetImage").then(function(e){n(),a.ui.resizeEditor({imageSize:e}),a.clearUndoStack()})},delete:function(){a.ui.changeDeleteButtonEnabled(!1),n(),a.removeActiveObject(),a.activeObjectId=null},deleteAll:function(){n(),a.clearObjects(),a.ui.changeDeleteButtonEnabled(!1),a.ui.changeDeleteAllButtonEnabled(!1)},load:function(e){o.default.isSupportFileApi()||alert("This browser does not support file-api"),a.ui.initializeImgUrl=URL.createObjectURL(e),a.loadImageFromFile(e).then(function(e){n(),a.clearUndoStack(),a.ui.activeMenuEvent(),a.ui.resizeEditor({imageSize:e})}).catch(function(e){return Promise.reject(e)})},download:function(){var e=a.toDataURL(),t=a.getImageName(),n=void 0,i=void 0;o.default.isSupportFileApi()&&window.saveAs?(i=(n=o.default.base64ToBlob(e)).type.split("/")[1],t.split(".").pop()!==i&&(t+="."+i),saveAs(n,t)):window.open().document.body.innerHTML="<img src='"+e+"'>"}},this._commonAction())},_iconAction:function(){var a=this,n=void 0,i=void 0,o=void 0,r=void 0,s=void 0,l=void 0,c=void 0;this.on({iconCreateResize:function(e){var t=e.moveOriginPointer,n=(t.x-o)/s,i=(t.y-r)/l;a.setObjectPropertiesQuietly(c,{scaleX:Math.abs(2*n),scaleY:Math.abs(2*i)})},iconCreateEnd:function(){a.ui.icon.clearIconType(),a.changeSelectableAll(!0)}});return(0,u.extend)({changeColor:function(e){a.activeObjectId&&a.changeIconColor(a.activeObjectId,e)},addIcon:function(e,t){n=e,i=t,a.changeCursor("crosshair"),a.off("mousedown"),a.once("mousedown",function(e,t){o=t.x,r=t.y,a.addIcon(n,{left:t.x,top:t.y,fill:i}).then(function(e){c=e.id,s=e.width,l=e.height})}.bind(a))},cancelAddIcon:function(){a.off("mousedown"),a.ui.icon.clearIconType(),a.changeSelectableAll(!0),a.changeCursor("default")},registDefalutIcons:function(e,t){var n={};n[e]=t,a.registerIcons(n)},registCustomIcon:function(e,i){(new d.default).imageToSVG(e,function(e){var t=e.match(/path[^>]*d="([^"]*)"/)[1],n={};n[i.name]=t,a.registerIcons(n),a.addIcon(i.name,{left:100,top:100})},d.default.tracerDefaultOption())}},this._commonAction())},_drawAction:function(){var n=this;return(0,u.extend)({setDrawMode:function(e,t){n.stopDrawingMode(),"free"===e?n.startDrawingMode("FREE_DRAWING",t):n.startDrawingMode("LINE_DRAWING",t)},setColor:function(e){n.setBrush({color:e})}},this._commonAction())},_maskAction:function(){var n=this;return(0,u.extend)({loadImageFromURL:function(e,t){return n.loadImageFromURL(n.toDataURL(),"FilterImage").then(function(){n.addImageObject(e).then(function(){URL.revokeObjectURL(t)})})},applyFilter:function(){n.applyFilter("mask",{maskObjId:n.activeObjectId})}},this._commonAction())},_textAction:function(){var t=this;return(0,u.extend)({changeTextStyle:function(e){t.activeObjectId&&t.changeTextStyle(t.activeObjectId,e)}},this._commonAction())},_rotateAction:function(){var n=this;return(0,u.extend)({rotate:function(e,t){n.rotate(e,t),n.ui.resizeEditor(),n.ui.rotate.setRangeBarAngle("rotate",e)},setAngle:function(e,t){n.setAngle(e,t),n.ui.resizeEditor(),n.ui.rotate.setRangeBarAngle("setAngle",e)}},this._commonAction())},_shapeAction:function(){var t=this;return(0,u.extend)({changeShape:function(e){t.activeObjectId&&t.changeShape(t.activeObjectId,e)},setDrawingShape:function(e){t.setDrawingShape(e)}},this._commonAction())},_cropAction:function(){var t=this;return(0,u.extend)({crop:function(){var e=t.getCropzoneRect();e&&t.crop(e).then(function(){t.stopDrawingMode(),t.ui.resizeEditor(),t.ui.changeMenu("crop")}).catch(function(e){return Promise.reject(e)})},cancel:function(){t.stopDrawingMode(),t.ui.changeMenu("crop")},preset:function(e){switch(e){case"preset-square":t.setCropzoneRect(1);break;case"preset-3-2":t.setCropzoneRect(1.5);break;case"preset-4-3":t.setCropzoneRect(4/3);break;case"preset-5-4":t.setCropzoneRect(5/4);break;case"preset-7-5":t.setCropzoneRect(1.4);break;case"preset-16-9":t.setCropzoneRect(16/9);break;default:t.setCropzoneRect(),t.ui.crop.changeApplyButtonStatus(!1)}}},this._commonAction())},_flipAction:function(){var t=this;return(0,u.extend)({flip:function(e){return t[e]()}},this._commonAction())},_filterAction:function(){var i=this;return(0,u.extend)({applyFilter:function(e,t,n){e?i.applyFilter(t,n):i.hasFilter(t)&&i.removeFilter(t)}},this._commonAction())},setReAction:function(){var a=this;this.on({undoStackChanged:function(e){e?(a.ui.changeUndoButtonStatus(!0),a.ui.changeResetButtonStatus(!0)):(a.ui.changeUndoButtonStatus(!1),a.ui.changeResetButtonStatus(!1)),a.ui.resizeEditor()},redoStackChanged:function(e){e?a.ui.changeRedoButtonStatus(!0):a.ui.changeRedoButtonStatus(!1),a.ui.resizeEditor()},objectActivated:function(e){a.activeObjectId=e.id,a.ui.changeDeleteButtonEnabled(!0),a.ui.changeDeleteAllButtonEnabled(!0),"cropzone"===e.type?a.ui.crop.changeApplyButtonStatus(!0):-1<["rect","circle","triangle"].indexOf(e.type)?(a.stopDrawingMode(),"shape"!==a.ui.submenu&&a.ui.changeMenu("shape",!1,!1),a.ui.shape.setShapeStatus({strokeColor:e.stroke,strokeWidth:e.strokeWidth,fillColor:e.fill}),a.ui.shape.setMaxStrokeValue(Math.min(e.width,e.height))):"path"===e.type||"line"===e.type?"draw"!==a.ui.submenu&&(a.ui.changeMenu("draw",!1,!1),a.ui.draw.changeStandbyMode()):-1<["i-text","text"].indexOf(e.type)?"text"!==a.ui.submenu&&a.ui.changeMenu("text",!1,!1):"icon"===e.type&&(a.stopDrawingMode(),"icon"!==a.ui.submenu&&a.ui.changeMenu("icon",!1,!1),a.ui.icon.setIconPickerColor(e.fill))},addText:function(e){a.addText("Double Click",{position:e.originPosition,styles:{fill:a.ui.text.textColor,fontSize:o.default.toInteger(a.ui.text.fontSize),fontFamily:"Noto Sans"}}).then(function(){a.changeCursor("default")})},addObjectAfter:function(e){-1<["rect","circle","triangle"].indexOf(e.type)&&(a.ui.shape.setMaxStrokeValue(Math.min(e.width,e.height)),a.ui.shape.changeStandbyMode())},objectScaled:function(e){if(-1<["i-text","text"].indexOf(e.type))a.ui.text.fontSize=o.default.toInteger(e.fontSize);else if(0<=["rect","circle","triangle"].indexOf(e.type)){var t=e.width,n=e.height,i=a.ui.shape.getStrokeValue();t<i&&a.ui.shape.setStrokeValue(t),n<i&&a.ui.shape.setStrokeValue(n)}},selectionCleared:function(){a.activeObjectId=null,"text"===a.ui.submenu?a.changeCursor("text"):"draw"!==a.ui.submenu&&"crop"!==a.ui.submenu&&a.stopDrawingMode()}})},_commonAction:function(){var t=this;return{modeChange:function(e){switch(e){case"text":t._changeActivateMode("TEXT");break;case"crop":t.startDrawingMode("CROPPER");break;case"shape":t._changeActivateMode("SHAPE"),t.setDrawingShape(t.ui.shape.type,t.ui.shape.options)}},deactivateAll:this.deactivateAll.bind(this),changeSelectableAll:this.changeSelectableAll.bind(this),discardSelection:this.discardSelection.bind(this),stopDrawingMode:this.stopDrawingMode.bind(this)}},mixin:function(e){(0,u.extend)(e.prototype,this)}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=(i(r,null,[{key:"tracerDefaultOption",value:function(){return{pathomit:100,ltres:.1,qtres:1,scale:1,strokewidth:5,viewbox:!1,linefilter:!0,desc:!1,rightangleenhance:!1,pal:[{r:0,g:0,b:0,a:255},{r:255,g:255,b:255,a:255}]}}}]),i(r,[{key:"imageToSVG",value:function(e,t,n){var i=this;n=this.checkoptions(n),this.loadImage(e,function(e){t(i.imagedataToSVG(i.getImgdata(e),n))},n)}},{key:"imagedataToSVG",value:function(e,t){t=this.checkoptions(t);var n=this.imagedataToTracedata(e,t);return this.getsvgstring(n,t)}},{key:"imageToTracedata",value:function(e,t,n){var i=this;n=this.checkoptions(n),this.loadImage(e,function(e){t(i.imagedataToTracedata(i.getImgdata(e),n))},n)}},{key:"imagedataToTracedata",value:function(e,t){t=this.checkoptions(t);var n=this.colorquantization(e,t),i=void 0;if(0===t.layering){i={layers:[],palette:n.palette,width:n.array[0].length-2,height:n.array.length-2};for(var a=0;a<n.palette.length;a+=1){var o=this.batchtracepaths(this.internodes(this.pathscan(this.layeringstep(n,a),t.pathomit),t),t.ltres,t.qtres);i.layers.push(o)}}else{var r=this.layering(n);t.layercontainerid&&this.drawLayers(r,this.specpalette,t.scale,t.layercontainerid);var s=this.batchpathscan(r,t.pathomit),l=this.batchinternodes(s,t);i={layers:this.batchtracelayers(l,t.ltres,t.qtres),palette:n.palette,width:e.width,height:e.height}}return i}},{key:"checkoptions",value:function(e){"string"==typeof(e=e||{})&&(e=e.toLowerCase(),e=this.optionpresets[e]?this.optionpresets[e]:{});for(var t=Object.keys(this.optionpresets.default),n=0;n<t.length;n+=1)e.hasOwnProperty(t[n])||(e[t[n]]=this.optionpresets.default[t[n]]);return e}},{key:"colorquantization",value:function(e,t){var n=[],i=0,a=void 0,o=void 0,r=void 0,s=[],l=e.width*e.height,c=void 0,u=void 0,d=void 0,h=void 0,f=void 0;for(u=0;u<e.height+2;u+=1)for(n[u]=[],c=0;c<e.width+2;c+=1)n[u][c]=-1;for(f=t.pal?t.pal:0===t.colorsampling?this.generatepalette(t.numberofcolors):1===t.colorsampling?this.samplepalette(t.numberofcolors,e):this.samplepalette2(t.numberofcolors,e),0<t.blurradius&&(e=this.blur(e,t.blurradius,t.blurdelta)),h=0;h<t.colorquantcycles;h+=1){if(0<h)for(d=0;d<f.length;d+=1)0<s[d].n&&(f[d]={r:Math.floor(s[d].r/s[d].n),g:Math.floor(s[d].g/s[d].n),b:Math.floor(s[d].b/s[d].n),a:Math.floor(s[d].a/s[d].n)}),s[d].n/l<t.mincolorratio&&h<t.colorquantcycles-1&&(f[d]={r:Math.floor(255*Math.random()),g:Math.floor(255*Math.random()),b:Math.floor(255*Math.random()),a:Math.floor(255*Math.random())});for(c=0;c<f.length;c+=1)s[c]={r:0,g:0,b:0,a:0,n:0};for(u=0;u<e.height;u+=1)for(c=0;c<e.width;c+=1){for(i=4*(u*e.width+c),o=1024,d=r=0;d<f.length;d+=1)(a=Math.abs(f[d].r-e.data[i])+Math.abs(f[d].g-e.data[i+1])+Math.abs(f[d].b-e.data[i+2])+Math.abs(f[d].a-e.data[i+3]))<o&&(o=a,r=d);s[r].r+=e.data[i],s[r].g+=e.data[i+1],s[r].b+=e.data[i+2],s[r].a+=e.data[i+3],s[r].n+=1,n[u+1][c+1]=r}}return{array:n,palette:f}}},{key:"samplepalette",value:function(e,t){for(var n=void 0,i=[],a=0;a<e;a+=1)n=4*Math.floor(Math.random()*t.data.length/4),i.push({r:t.data[n],g:t.data[n+1],b:t.data[n+2],a:t.data[n+3]});return i}},{key:"samplepalette2",value:function(e,t){for(var n=void 0,i=[],a=Math.ceil(Math.sqrt(e)),o=Math.ceil(e/a),r=t.width/(a+1),s=t.height/(o+1),l=0;l<o;l+=1)for(var c=0;c<a&&i.length!==e;c+=1)n=4*Math.floor((l+1)*s*t.width+(c+1)*r),i.push({r:t.data[n],g:t.data[n+1],b:t.data[n+2],a:t.data[n+3]});return i}},{key:"generatepalette",value:function(e){var t=[],n=void 0,i=void 0,a=void 0;if(e<8)for(var o=Math.floor(255/(e-1)),r=0;r<e;r+=1)t.push({r:r*o,g:r*o,b:r*o,a:255});else{var s=Math.floor(Math.pow(e,1/3)),l=Math.floor(255/(s-1)),c=e-s*s*s;for(n=0;n<s;n+=1)for(i=0;i<s;i+=1)for(a=0;a<s;a+=1)t.push({r:n*l,g:i*l,b:a*l,a:255});for(n=0;n<c;n+=1)t.push({r:Math.floor(255*Math.random()),g:Math.floor(255*Math.random()),b:Math.floor(255*Math.random()),a:Math.floor(255*Math.random())})}return t}},{key:"layering",value:function(e){var t=[],n=0,i=e.array.length,a=e.array[0].length,o=void 0,r=void 0,s=void 0,l=void 0,c=void 0,u=void 0,d=void 0,h=void 0,f=void 0,p=void 0,g=void 0;for(g=0;g<e.palette.length;g+=1)for(t[g]=[],p=0;p<i;p+=1)for(t[g][p]=[],f=0;f<a;f+=1)t[g][p][f]=0;for(p=1;p<i-1;p+=1)for(f=1;f<a-1;f+=1)n=e.array[p][f],o=e.array[p-1][f-1]===n?1:0,r=e.array[p-1][f]===n?1:0,s=e.array[p-1][f+1]===n?1:0,l=e.array[p][f-1]===n?1:0,c=e.array[p][f+1]===n?1:0,u=e.array[p+1][f-1]===n?1:0,d=e.array[p+1][f]===n?1:0,h=e.array[p+1][f+1]===n?1:0,t[n][p+1][f+1]=1+2*c+4*h+8*d,l||(t[n][p+1][f]=2+4*d+8*u),r||(t[n][p][f+1]=0+2*s+4*c+8),o||(t[n][p][f]=0+2*r+4+8*l);return t}},{key:"layeringstep",value:function(e,t){var n=[],i=e.array.length,a=e.array[0].length,o=void 0,r=void 0;for(r=0;r<i;r+=1)for(n[r]=[],o=0;o<a;o+=1)n[r][o]=0;for(r=1;r<i;r+=1)for(o=1;o<a;o+=1)n[r][o]=(e.array[r-1][o-1]===t?1:0)+(e.array[r-1][o]===t?2:0)+(e.array[r][o-1]===t?8:0)+(e.array[r][o]===t?4:0);return n}},{key:"pathscan",value:function(e,t){for(var n=[],i=0,a=0,o=0,r=0,s=e[0].length,l=e.length,c=0,u=!0,d=!1,h=void 0,f=0;f<l;f+=1)for(var p=0;p<s;p+=1)if(4===e[f][p]||11===e[f][p])for(o=p,r=f,n[i]={},n[i].points=[],n[i].boundingbox=[o,r,o,r],n[i].holechildren=[],u=!1,a=0,d=11===e[f][p],c=1;!u;){if(n[i].points[a]={},n[i].points[a].x=o-1,n[i].points[a].y=r-1,n[i].points[a].t=e[r][o],o-1<n[i].boundingbox[0]&&(n[i].boundingbox[0]=o-1),o-1>n[i].boundingbox[2]&&(n[i].boundingbox[2]=o-1),r-1<n[i].boundingbox[1]&&(n[i].boundingbox[1]=r-1),r-1>n[i].boundingbox[3]&&(n[i].boundingbox[3]=r-1),h=this.pathscan_combined_lookup[e[r][o]][c],e[r][o]=h[0],c=h[1],o+=h[2],r+=h[3],o-1===n[i].points[0].x&&r-1===n[i].points[0].y)if(u=!0,n[i].points.length<t)n.pop();else{if(n[i].isholepath=!!d,d){for(var g=0,v=[-1,-1,s+1,l+1],m=0;m<i;m++)!n[m].isholepath&&this.boundingboxincludes(n[m].boundingbox,n[i].boundingbox)&&this.boundingboxincludes(v,n[m].boundingbox)&&(v=n[g=m].boundingbox);n[g].holechildren.push(i)}i+=1}a+=1}return n}},{key:"boundingboxincludes",value:function(e,t){return e[0]<t[0]&&e[1]<t[1]&&e[2]>t[2]&&e[3]>t[3]}},{key:"batchpathscan",value:function(e,t){var n=[];for(var i in e)e.hasOwnProperty(i)&&(n[i]=this.pathscan(e[i],t));return n}},{key:"internodes",value:function(e,t){var n=[],i=0,a=0,o=0,r=0,s=0,l=void 0,c=void 0;for(l=0;l<e.length;l+=1)for(n[l]={},n[l].points=[],n[l].boundingbox=e[l].boundingbox,n[l].holechildren=e[l].holechildren,n[l].isholepath=e[l].isholepath,i=e[l].points.length,c=0;c<i;c+=1)a=(c+1)%i,o=(c+2)%i,r=(c-1+i)%i,s=(c-2+i)%i,t.rightangleenhance&&this.testrightangle(e[l],s,r,c,a,o)&&(0<n[l].points.length&&(n[l].points[n[l].points.length-1].linesegment=this.getdirection(n[l].points[n[l].points.length-1].x,n[l].points[n[l].points.length-1].y,e[l].points[c].x,e[l].points[c].y)),n[l].points.push({x:e[l].points[c].x,y:e[l].points[c].y,linesegment:this.getdirection(e[l].points[c].x,e[l].points[c].y,(e[l].points[c].x+e[l].points[a].x)/2,(e[l].points[c].y+e[l].points[a].y)/2)})),n[l].points.push({x:(e[l].points[c].x+e[l].points[a].x)/2,y:(e[l].points[c].y+e[l].points[a].y)/2,linesegment:this.getdirection((e[l].points[c].x+e[l].points[a].x)/2,(e[l].points[c].y+e[l].points[a].y)/2,(e[l].points[a].x+e[l].points[o].x)/2,(e[l].points[a].y+e[l].points[o].y)/2)});return n}},{key:"testrightangle",value:function(e,t,n,i,a,o){return e.points[i].x===e.points[t].x&&e.points[i].x===e.points[n].x&&e.points[i].y===e.points[a].y&&e.points[i].y===e.points[o].y||e.points[i].y===e.points[t].y&&e.points[i].y===e.points[n].y&&e.points[i].x===e.points[a].x&&e.points[i].x===e.points[o].x}},{key:"getdirection",value:function(e,t,n,i){return e<n?t<i?1:i<t?7:0:n<e?t<i?3:i<t?5:4:t<i?2:i<t?6:8}},{key:"batchinternodes",value:function(e,t){var n=[];for(var i in e)e.hasOwnProperty(i)&&(n[i]=this.internodes(e[i],t));return n}},{key:"tracepath",value:function(e,t,n){var i=0,a=void 0,o=void 0,r=void 0,s={segments:[]};for(s.boundingbox=e.boundingbox,s.holechildren=e.holechildren,s.isholepath=e.isholepath;i<e.points.length;){for(a=e.points[i].linesegment,o=-1,r=i+1;(e.points[r].linesegment===a||e.points[r].linesegment===o||-1===o)&&r<e.points.length-1;)e.points[r].linesegment!==a&&-1===o&&(o=e.points[r].linesegment),r+=1;r===e.points.length-1&&(r=0),s.segments=s.segments.concat(this.fitseq(e,t,n,i,r)),i=0<r?r:e.points.length}return s}},{key:"fitseq",value:function(e,t,n,i,a){if(a>e.points.length||a<0)return[];var o=i,r=0,s=!0,l=void 0,c=void 0,u=void 0,d=a-i;d<0&&(d+=e.points.length);for(var h=(e.points[a].x-e.points[i].x)/d,f=(e.points[a].y-e.points[i].y)/d,p=(i+1)%e.points.length,g=void 0;p!=a;)(g=p-i)<0&&(g+=e.points.length),l=e.points[i].x+h*g,c=e.points[i].y+f*g,t<(u=(e.points[p].x-l)*(e.points[p].x-l)+(e.points[p].y-c)*(e.points[p].y-c))&&(s=!1),r<u&&(o=p,r=u),p=(p+1)%e.points.length;if(s)return[{type:"L",x1:e.points[i].x,y1:e.points[i].y,x2:e.points[a].x,y2:e.points[a].y}];var v=o;s=!0,r=0;var m=(v-i)/d,b=(1-m)*(1-m),y=2*(1-m)*m,_=m*m,k=(b*e.points[i].x+_*e.points[a].x-e.points[v].x)/-y,w=(b*e.points[i].y+_*e.points[a].y-e.points[v].y)/-y;for(p=i+1;p!=a;)y=2*(1-(m=(p-i)/d))*m,_=m*m,l=(b=(1-m)*(1-m))*e.points[i].x+y*k+_*e.points[a].x,c=b*e.points[i].y+y*w+_*e.points[a].y,n<(u=(e.points[p].x-l)*(e.points[p].x-l)+(e.points[p].y-c)*(e.points[p].y-c))&&(s=!1),r<u&&(o=p,r=u),p=(p+1)%e.points.length;if(s)return[{type:"Q",x1:e.points[i].x,y1:e.points[i].y,x2:k,y2:w,x3:e.points[a].x,y3:e.points[a].y}];var x=v;return this.fitseq(e,t,n,i,x).concat(this.fitseq(e,t,n,x,a))}},{key:"batchtracepaths",value:function(e,t,n){var i=[];for(var a in e)e.hasOwnProperty(a)&&i.push(this.tracepath(e[a],t,n));return i}},{key:"batchtracelayers",value:function(e,t,n){var i=[];for(var a in e)e.hasOwnProperty(a)&&(i[a]=this.batchtracepaths(e[a],t,n));return i}},{key:"roundtodec",value:function(e,t){return Number(e.toFixed(t))}},{key:"svgpathstring",value:function(e,t,n,i){var a=e.layers[t],o=a[n],r="",s=void 0;if(i.linefilter&&o.segments.length<3)return r;if(r="<path "+(i.desc?'desc="l '+t+" p "+n+'" ':"")+this.tosvgcolorstr(e.palette[t],i)+'d="',-1===i.roundcoords){for(r+="M "+o.segments[0].x1*i.scale+" "+o.segments[0].y1*i.scale+" ",s=0;s<o.segments.length;s++)r+=o.segments[s].type+" "+o.segments[s].x2*i.scale+" "+o.segments[s].y2*i.scale+" ",o.segments[s].hasOwnProperty("x3")&&(r+=o.segments[s].x3*i.scale+" "+o.segments[s].y3*i.scale+" ");r+="Z "}else{for(r+="M "+this.roundtodec(o.segments[0].x1*i.scale,i.roundcoords)+" "+this.roundtodec(o.segments[0].y1*i.scale,i.roundcoords)+" ",s=0;s<o.segments.length;s++)r+=o.segments[s].type+" "+this.roundtodec(o.segments[s].x2*i.scale,i.roundcoords)+" "+this.roundtodec(o.segments[s].y2*i.scale,i.roundcoords)+" ",o.segments[s].hasOwnProperty("x3")&&(r+=this.roundtodec(o.segments[s].x3*i.scale,i.roundcoords)+" "+this.roundtodec(o.segments[s].y3*i.scale,i.roundcoords)+" ");r+="Z "}for(var l=0;l<o.holechildren.length;l++){var c=a[o.holechildren[l]];if(-1===i.roundcoords)for(c.segments[c.segments.length-1].hasOwnProperty("x3")?r+="M "+c.segments[c.segments.length-1].x3*i.scale+" "+c.segments[c.segments.length-1].y3*i.scale+" ":r+="M "+c.segments[c.segments.length-1].x2*i.scale+" "+c.segments[c.segments.length-1].y2*i.scale+" ",s=c.segments.length-1;0<=s;s--)r+=c.segments[s].type+" ",c.segments[s].hasOwnProperty("x3")&&(r+=c.segments[s].x2*i.scale+" "+c.segments[s].y2*i.scale+" "),r+=c.segments[s].x1*i.scale+" "+c.segments[s].y1*i.scale+" ";else for(c.segments[c.segments.length-1].hasOwnProperty("x3")?r+="M "+this.roundtodec(c.segments[c.segments.length-1].x3*i.scale)+" "+this.roundtodec(c.segments[c.segments.length-1].y3*i.scale)+" ":r+="M "+this.roundtodec(c.segments[c.segments.length-1].x2*i.scale)+" "+this.roundtodec(c.segments[c.segments.length-1].y2*i.scale)+" ",s=c.segments.length-1;0<=s;s--)r+=c.segments[s].type+" ",c.segments[s].hasOwnProperty("x3")&&(r+=this.roundtodec(c.segments[s].x2*i.scale)+" "+this.roundtodec(c.segments[s].y2*i.scale)+" "),r+=this.roundtodec(c.segments[s].x1*i.scale)+" "+this.roundtodec(c.segments[s].y1*i.scale)+" ";r+="Z "}if(r+='" />',i.lcpr||i.qcpr){for(s=0;s<o.segments.length;s++)o.segments[s].hasOwnProperty("x3")&&i.qcpr&&(r+='<circle cx="'+o.segments[s].x2*i.scale+'" cy="'+o.segments[s].y2*i.scale+'" r="'+i.qcpr+'" fill="cyan" stroke-width="'+.2*i.qcpr+'" stroke="black" />',r+='<circle cx="'+o.segments[s].x3*i.scale+'" cy="'+o.segments[s].y3*i.scale+'" r="'+i.qcpr+'" fill="white" stroke-width="'+.2*i.qcpr+'" stroke="black" />',r+='<line x1="'+o.segments[s].x1*i.scale+'" y1="'+o.segments[s].y1*i.scale+'" x2="'+o.segments[s].x2*i.scale+'" y2="'+o.segments[s].y2*i.scale+'" stroke-width="'+.2*i.qcpr+'" stroke="cyan" />',r+='<line x1="'+o.segments[s].x2*i.scale+'" y1="'+o.segments[s].y2*i.scale+'" x2="'+o.segments[s].x3*i.scale+'" y2="'+o.segments[s].y3*i.scale+'" stroke-width="'+.2*i.qcpr+'" stroke="cyan" />'),!o.segments[s].hasOwnProperty("x3")&&i.lcpr&&(r+='<circle cx="'+o.segments[s].x2*i.scale+'" cy="'+o.segments[s].y2*i.scale+'" r="'+i.lcpr+'" fill="white" stroke-width="'+.2*i.lcpr+'" stroke="black" />');for(l=0;l<o.holechildren.length;l++)for(c=a[o.holechildren[l]],s=0;s<c.segments.length;s++)c.segments[s].hasOwnProperty("x3")&&i.qcpr&&(r+='<circle cx="'+c.segments[s].x2*i.scale+'" cy="'+c.segments[s].y2*i.scale+'" r="'+i.qcpr+'" fill="cyan" stroke-width="'+.2*i.qcpr+'" stroke="black" />',r+='<circle cx="'+c.segments[s].x3*i.scale+'" cy="'+c.segments[s].y3*i.scale+'" r="'+i.qcpr+'" fill="white" stroke-width="'+.2*i.qcpr+'" stroke="black" />',r+='<line x1="'+c.segments[s].x1*i.scale+'" y1="'+c.segments[s].y1*i.scale+'" x2="'+c.segments[s].x2*i.scale+'" y2="'+c.segments[s].y2*i.scale+'" stroke-width="'+.2*i.qcpr+'" stroke="cyan" />',r+='<line x1="'+c.segments[s].x2*i.scale+'" y1="'+c.segments[s].y2*i.scale+'" x2="'+c.segments[s].x3*i.scale+'" y2="'+c.segments[s].y3*i.scale+'" stroke-width="'+.2*i.qcpr+'" stroke="cyan" />'),!c.segments[s].hasOwnProperty("x3")&&i.lcpr&&(r+='<circle cx="'+c.segments[s].x2*i.scale+'" cy="'+c.segments[s].y2*i.scale+'" r="'+i.lcpr+'" fill="white" stroke-width="'+.2*i.lcpr+'" stroke="black" />')}return r}},{key:"getsvgstring",value:function(e,t){t=this.checkoptions(t);for(var n=e.width*t.scale,i=e.height*t.scale,a="<svg "+(t.viewbox?'viewBox="0 0 '+n+" "+i+'" ':'width="'+n+'" height="'+i+'" ')+'version="1.1" xmlns="http://www.w3.org/2000/svg" desc="Created with imagetracer.js version '+this.versionnumber+'" >',o=0;o<e.layers.length;o+=1)for(var r=0;r<e.layers[o].length;r+=1)e.layers[o][r].isholepath||(a+=this.svgpathstring(e,o,r,t));return a+="</svg>"}},{key:"compareNumbers",value:function(e,t){return e-t}},{key:"torgbastr",value:function(e){return"rgba("+e.r+","+e.g+","+e.b+","+e.a+")"}},{key:"tosvgcolorstr",value:function(e,t){return'fill="rgb('+e.r+","+e.g+","+e.b+')" stroke="rgb('+e.r+","+e.g+","+e.b+')" stroke-width="'+t.strokewidth+'" opacity="'+e.a/255+'" '}},{key:"appendSVGString",value:function(e,t){var n=void 0;t?(n=document.getElementById(t))||((n=document.createElement("div")).id=t,document.body.appendChild(n)):(n=document.createElement("div"),document.body.appendChild(n)),n.innerHTML+=e}},{key:"blur",value:function(e,t,n){var i=void 0,a=void 0,o=void 0,r=void 0,s=void 0,l=void 0,c=void 0,u=void 0,d=void 0,h={width:e.width,height:e.height,data:[]};if((t=Math.floor(t))<1)return e;5<t&&(t=5),1024<(n=Math.abs(n))&&(n=1024);var f=this.gks[t-1];for(a=0;a<e.height;a++)for(i=0;i<e.width;i++){for(d=u=c=l=s=0,o=-t;o<t+1;o++)0<i+o&&i+o<e.width&&(r=4*(a*e.width+i+o),s+=e.data[r]*f[o+t],l+=e.data[r+1]*f[o+t],c+=e.data[r+2]*f[o+t],u+=e.data[r+3]*f[o+t],d+=f[o+t]);r=4*(a*e.width+i),h.data[r]=Math.floor(s/d),h.data[r+1]=Math.floor(l/d),h.data[r+2]=Math.floor(c/d),h.data[r+3]=Math.floor(u/d)}var p=new Uint8ClampedArray(h.data);for(a=0;a<e.height;a++)for(i=0;i<e.width;i++){for(d=u=c=l=s=0,o=-t;o<t+1;o++)0<a+o&&a+o<e.height&&(s+=p[r=4*((a+o)*e.width+i)]*f[o+t],l+=p[r+1]*f[o+t],c+=p[r+2]*f[o+t],u+=p[r+3]*f[o+t],d+=f[o+t]);r=4*(a*e.width+i),h.data[r]=Math.floor(s/d),h.data[r+1]=Math.floor(l/d),h.data[r+2]=Math.floor(c/d),h.data[r+3]=Math.floor(u/d)}for(a=0;a<e.height;a++)for(i=0;i<e.width;i++)r=4*(a*e.width+i),n<Math.abs(h.data[r]-e.data[r])+Math.abs(h.data[r+1]-e.data[r+1])+Math.abs(h.data[r+2]-e.data[r+2])+Math.abs(h.data[r+3]-e.data[r+3])&&(h.data[r]=e.data[r],h.data[r+1]=e.data[r+1],h.data[r+2]=e.data[r+2],h.data[r+3]=e.data[r+3]);return h}},{key:"loadImage",value:function(e,t,n){var i=new Image;n&&n.corsenabled&&(i.crossOrigin="Anonymous"),i.src=e,i.onload=function(){var e=document.createElement("canvas");e.width=i.width,e.height=i.height,e.getContext("2d").drawImage(i,0,0),t(e)}}},{key:"getImgdata",value:function(e){return e.getContext("2d").getImageData(0,0,e.width,e.height)}},{key:"drawLayers",value:function(e,t,n,i){n=n||1;var a=void 0,o=void 0,r=void 0,s=void 0,l=void 0,c=void 0;for(l in i?(c=document.getElementById(i))||((c=document.createElement("div")).id=i,document.body.appendChild(c)):(c=document.createElement("div"),document.body.appendChild(c)),e)if(e.hasOwnProperty(l)){a=e[l][0].length,o=e[l].length;var u=document.createElement("canvas");u.width=a*n,u.height=o*n;var d=u.getContext("2d");for(s=0;s<o;s+=1)for(r=0;r<a;r+=1)d.fillStyle=this.torgbastr(t[e[l][s][r]%t.length]),d.fillRect(r*n,s*n,n,n);c.appendChild(u)}}}]),r);function r(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,r),this.versionnumber="1.2.4",this.optionpresets={default:{corsenabled:!1,ltres:1,qtres:1,pathomit:8,rightangleenhance:!0,colorsampling:2,numberofcolors:16,mincolorratio:0,colorquantcycles:3,layering:0,strokewidth:1,linefilter:!1,scale:1,roundcoords:1,viewbox:!1,desc:!1,lcpr:0,qcpr:0,blurradius:0,blurdelta:20},posterized1:{colorsampling:0,numberofcolors:2},posterized2:{numberofcolors:4,blurradius:5},curvy:{ltres:.01,linefilter:!0,rightangleenhance:!1},sharp:{qtres:.01,linefilter:!1},detailed:{pathomit:0,roundcoords:2,ltres:.5,qtres:.5,numberofcolors:64},smoothed:{blurradius:5,blurdelta:64},grayscale:{colorsampling:0,colorquantcycles:1,numberofcolors:7},fixedpalette:{colorsampling:0,colorquantcycles:1,numberofcolors:27},randomsampling1:{colorsampling:1,numberofcolors:8},randomsampling2:{colorsampling:1,numberofcolors:64},artistic1:{colorsampling:0,colorquantcycles:1,pathomit:0,blurradius:5,blurdelta:64,ltres:.01,linefilter:!0,numberofcolors:16,strokewidth:2},artistic2:{qtres:.01,colorsampling:0,colorquantcycles:1,numberofcolors:4,strokewidth:0},artistic3:{qtres:10,ltres:10,numberofcolors:8},artistic4:{qtres:10,ltres:10,numberofcolors:64,blurradius:5,blurdelta:256,strokewidth:2},posterized3:{ltres:1,qtres:1,pathomit:20,rightangleenhance:!0,colorsampling:0,numberofcolors:3,mincolorratio:0,colorquantcycles:3,blurradius:3,blurdelta:20,strokewidth:0,linefilter:!1,roundcoords:1,pal:[{r:0,g:0,b:100,a:255},{r:255,g:255,b:255,a:255}]}},this.pathscan_combined_lookup=[[[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1]],[[0,1,0,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[0,2,-1,0]],[[-1,-1,-1,-1],[-1,-1,-1,-1],[0,1,0,-1],[0,0,1,0]],[[0,0,1,0],[-1,-1,-1,-1],[0,2,-1,0],[-1,-1,-1,-1]],[[-1,-1,-1,-1],[0,0,1,0],[0,3,0,1],[-1,-1,-1,-1]],[[13,3,0,1],[13,2,-1,0],[7,1,0,-1],[7,0,1,0]],[[-1,-1,-1,-1],[0,1,0,-1],[-1,-1,-1,-1],[0,3,0,1]],[[0,3,0,1],[0,2,-1,0],[-1,-1,-1,-1],[-1,-1,-1,-1]],[[0,3,0,1],[0,2,-1,0],[-1,-1,-1,-1],[-1,-1,-1,-1]],[[-1,-1,-1,-1],[0,1,0,-1],[-1,-1,-1,-1],[0,3,0,1]],[[11,1,0,-1],[14,0,1,0],[14,3,0,1],[11,2,-1,0]],[[-1,-1,-1,-1],[0,0,1,0],[0,3,0,1],[-1,-1,-1,-1]],[[0,0,1,0],[-1,-1,-1,-1],[0,2,-1,0],[-1,-1,-1,-1]],[[-1,-1,-1,-1],[-1,-1,-1,-1],[0,1,0,-1],[0,0,1,0]],[[0,1,0,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[0,2,-1,0]],[[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1]]],this.gks=[[.27901,.44198,.27901],[.135336,.228569,.272192,.228569,.135336],[.086776,.136394,.178908,.195843,.178908,.136394,.086776],[.063327,.093095,.122589,.144599,.152781,.144599,.122589,.093095,.063327],[.049692,.069304,.089767,.107988,.120651,.125194,.120651,.107988,.089767,.069304,.049692]],this.specpalette=[{r:0,g:0,b:0,a:255},{r:128,g:128,b:128,a:255},{r:0,g:0,b:128,a:255},{r:64,g:64,b:128,a:255},{r:192,g:192,b:192,a:255},{r:255,g:255,b:255,a:255},{r:128,g:128,b:192,a:255},{r:0,g:0,b:192,a:255},{r:128,g:0,b:0,a:255},{r:128,g:64,b:64,a:255},{r:128,g:0,b:128,a:255},{r:168,g:168,b:168,a:255},{r:192,g:128,b:128,a:255},{r:192,g:0,b:0,a:255},{r:255,g:255,b:255,a:255},{r:0,g:128,b:0,a:255}]}t.default=o},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=C(n(1)),r=C(n(2)),s=C(n(5)),l=C(n(109)),c=C(n(110)),u=C(n(112)),d=C(n(113)),h=C(n(114)),f=C(n(115)),p=C(n(116)),g=C(n(117)),v=C(n(118)),m=C(n(124)),b=C(n(126)),y=C(n(127)),_=C(n(128)),k=C(n(129)),w=C(n(130)),x=C(n(0)),E=C(n(4));function C(e){return e&&e.__esModule?e:{default:e}}var O=x.default.componentNames,S=x.default.eventNames,j=x.default.drawingModes,M=x.default.fObjectOptions,T=o.default.extend,P=o.default.stamp,A=o.default.isArray,I=o.default.isString,R=o.default.forEachArray,D=o.default.forEachOwnProperties,L=o.default.CustomEvents,N={cssOnly:!0},B={backstoreOnly:!0},z=(i(F,[{key:"destroy",value:function(){var e=this._canvas.wrapperEl;this._canvas.clear(),e.parentNode.removeChild(e)}},{key:"deactivateAll",value:function(){return this._canvas.discardActiveObject(),this}},{key:"renderAll",value:function(){return this._canvas.renderAll(),this}},{key:"add",value:function(e){var t,n=[];A(e)?n=e:n.push(e),(t=this._canvas).add.apply(t,n)}},{key:"contains",value:function(e){return this._canvas.contains(e)}},{key:"getObjects",value:function(){return this._canvas.getObjects().slice()}},{key:"getObject",value:function(e){return this._objects[e]}},{key:"remove",value:function(e){this._canvas.remove(e)}},{key:"removeAll",value:function(e){var t=this._canvas,n=t.getObjects().slice();return t.remove.apply(t,this._canvas.getObjects()),e&&t.clear(),n}},{key:"removeObjectById",value:function(e){var t=[],n=this._canvas,i=this.getObject(e);return i&&i.isType("group")&&!i.isEmpty()?(n.discardActiveObject(),i.forEachObject(function(e){t.push(e),n.remove(e)})):n.contains(i)&&(t.push(i),n.remove(i)),t}},{key:"getObjectId",value:function(e){var t=null;for(t in this._objects)if(this._objects.hasOwnProperty(t)&&e===this._objects[t])return t;return null}},{key:"getActiveObject",value:function(){return this._canvas._activeObject}},{key:"getActiveObjects",value:function(){var e=this._canvas._activeObject;return e&&"activeSelection"===e.type?e:null}},{key:"setActiveObject",value:function(e){this._canvas.setActiveObject(e)}},{key:"setCropSelectionStyle",value:function(e){this.cropSelectionStyle=e}},{key:"getComponent",value:function(e){return this._componentMap[e]}},{key:"getDrawingMode",value:function(){return this._drawingMode}},{key:"startDrawingMode",value:function(e,t){if(this._isSameDrawingMode(e))return!0;this.stopDrawingMode();var n=this._getDrawingModeInstance(e);return n&&n.start&&(n.start(this,t),this._drawingMode=e),!!n}},{key:"stopDrawingMode",value:function(){if(!this._isSameDrawingMode(j.NORMAL)){var e=this._getDrawingModeInstance(this.getDrawingMode());e&&e.end&&e.end(this),this._drawingMode=j.NORMAL}}},{key:"toDataURL",value:function(e){var t=this.getComponent(O.CROPPER);t.changeVisibility(!1);var n=this._canvas&&this._canvas.toDataURL(e);return t.changeVisibility(!0),n}},{key:"setCanvasImage",value:function(e,t){t&&P(t),this.imageName=e,this.canvasImage=t}},{key:"setCssMaxDimension",value:function(e){this.cssMaxWidth=e.width||this.cssMaxWidth,this.cssMaxHeight=e.height||this.cssMaxHeight}},{key:"adjustCanvasDimension",value:function(){var e=this.canvasImage.scale(1),t=e.getBoundingRect(),n=t.width,i=t.height,a=this._calcMaxDimension(n,i);this.setCanvasCssDimension({width:"100%",height:"100%","max-width":a.width+"px","max-height":a.height+"px"}),this.setCanvasBackstoreDimension({width:n,height:i}),this._canvas.centerObject(e)}},{key:"setCanvasCssDimension",value:function(e){this._canvas.setDimensions(e,N)}},{key:"setCanvasBackstoreDimension",value:function(e){this._canvas.setDimensions(e,B)}},{key:"setImageProperties",value:function(e,t){var n=this.canvasImage;n&&(n.set(e).setCoords(),t&&this._canvas.renderAll())}},{key:"getCanvasElement",value:function(){return this._canvas.getElement()}},{key:"getCanvas",value:function(){return this._canvas}},{key:"getCanvasImage",value:function(){return this.canvasImage}},{key:"getImageName",value:function(){return this.imageName}},{key:"addImageObject",value:function(e){var n=this,i=this._callbackAfterLoadingImageObject.bind(this);return new r.default(function(t){s.default.Image.fromURL(e,function(e){i(e),t(n.createObjectProperties(e))},{crossOrigin:"Anonymous"})})}},{key:"getCenter",value:function(){return this._canvas.getCenter()}},{key:"getCropzoneRect",value:function(){return this.getComponent(O.CROPPER).getCropzoneRect()}},{key:"setCropzoneRect",value:function(e){this.getComponent(O.CROPPER).setCropzoneRect(e)}},{key:"getCroppedImageData",value:function(e){return this.getComponent(O.CROPPER).getCroppedImageData(e)}},{key:"setBrush",value:function(e){var t=this._drawingMode,n=O.FREE_DRAWING;t===j.LINE&&(n=j.LINE),this.getComponent(n).setBrush(e)}},{key:"setDrawingShape",value:function(e,t){this.getComponent(O.SHAPE).setStates(e,t)}},{key:"registerPaths",value:function(e){this.getComponent(O.ICON).registerPaths(e)}},{key:"changeCursor",value:function(e){var t=this.getCanvas();t.defaultCursor=e,t.renderAll()}},{key:"hasFilter",value:function(e){return this.getComponent(O.FILTER).hasFilter(e)}},{key:"setSelectionStyle",value:function(e){T(M.SELECTION_STYLE,e)}},{key:"setObjectProperties",value:function(e,t){var n=this.getObject(e),i=T({},t);return n.set(i),n.setCoords(),this.getCanvas().renderAll(),i}},{key:"getObjectProperties",value:function(e,t){var n=this.getObject(e),i={};return I(t)?i[t]=n[t]:A(t)?R(t,function(e){i[e]=n[e]}):D(t,function(e,t){i[t]=n[t]}),i}},{key:"getObjectPosition",value:function(e,t,n){var i=this.getObject(e);return i?i.getPointByOrigin(t,n):null}},{key:"setObjectPosition",value:function(e,t){var n=this.getObject(e),i=t.x,a=t.y,o=t.originX,r=t.originY;if(!n)return!1;var s=n.getPointByOrigin(o,r),l=n.getPointByOrigin("center","center"),c=l.x-s.x,u=l.y-s.y;return n.set({left:i+c,top:a+u}),n.setCoords(),!0}},{key:"getCanvasSize",value:function(){var e=this.getCanvasImage();return{width:e?e.width:0,height:e?e.height:0}}},{key:"_getDrawingModeInstance",value:function(e){return this._drawingModeMap[e]}},{key:"_setObjectCachingToFalse",value:function(){s.default.Object.prototype.objectCaching=!1}},{key:"_setCanvasElement",value:function(e){var t=void 0,n=void 0;"CANVAS"!==(t=e.nodeType?e:document.querySelector(e)).nodeName.toUpperCase()&&(n=document.createElement("canvas"),t.appendChild(n)),this._canvas=new s.default.Canvas(n,{containerClass:"tui-image-editor-canvas-container",enableRetinaScaling:!1})}},{key:"_createDrawingModeInstances",value:function(){this._register(this._drawingModeMap,new b.default),this._register(this._drawingModeMap,new y.default),this._register(this._drawingModeMap,new _.default),this._register(this._drawingModeMap,new k.default),this._register(this._drawingModeMap,new w.default)}},{key:"_createComponents",value:function(){this._register(this._componentMap,new l.default(this)),this._register(this._componentMap,new c.default(this)),this._register(this._componentMap,new u.default(this)),this._register(this._componentMap,new d.default(this)),this._register(this._componentMap,new h.default(this)),this._register(this._componentMap,new f.default(this)),this._register(this._componentMap,new p.default(this)),this._register(this._componentMap,new g.default(this)),this._register(this._componentMap,new v.default(this)),this._register(this._componentMap,new m.default(this))}},{key:"_register",value:function(e,t){e[t.getName()]=t}},{key:"_isSameDrawingMode",value:function(e){return this.getDrawingMode()===e}},{key:"_calcMaxDimension",value:function(e,t){var n=this.cssMaxWidth/e,i=this.cssMaxHeight/t,a=Math.min(e,this.cssMaxWidth),o=Math.min(t,this.cssMaxHeight);return n<1&&n<i?(a=e*n,o=t*n):i<1&&i<n&&(a=e*i,o=t*i),{width:Math.floor(a),height:Math.floor(o)}}},{key:"_callbackAfterLoadingImageObject",value:function(e){var t=this.getCanvasImage().getCenterPoint();e.set(x.default.fObjectOptions.SELECTION_STYLE),e.set({left:t.x,top:t.y,crossOrigin:"Anonymous"}),this.getCanvas().add(e).setActiveObject(e)}},{key:"_attachCanvasEvents",value:function(){var e=this._canvas,t=this._handler;e.on({"mouse:down":t.onMouseDown,"object:added":t.onObjectAdded,"object:removed":t.onObjectRemoved,"object:moving":t.onObjectMoved,"object:scaling":t.onObjectScaled,"object:selected":t.onObjectSelected,"path:created":t.onPathCreated,"selection:cleared":t.onSelectionCleared,"selection:created":t.onSelectionCreated,"selection:updated":t.onObjectSelected})}},{key:"_onMouseDown",value:function(e){var t=this._canvas.getPointer(e.e);this.fire(S.MOUSE_DOWN,e.e,t)}},{key:"_onObjectAdded",value:function(e){var t=e.target;t.isType("cropzone")||this._addFabricObject(t)}},{key:"_onObjectRemoved",value:function(e){var t=e.target;this._removeFabricObject(P(t))}},{key:"_onObjectMoved",value:function(e){var t=e.target,n=this.createObjectProperties(t);this.fire(S.OBJECT_MOVED,n)}},{key:"_onObjectScaled",value:function(e){var t=e.target,n=this.createObjectProperties(t);this.fire(S.OBJECT_SCALED,n)}},{key:"_onObjectSelected",value:function(e){var t=e.target,n=this.createObjectProperties(t);this.fire(S.OBJECT_ACTIVATED,n)}},{key:"_onPathCreated",value:function(e){var t=e.path.getCenterPoint(),n=t.x,i=t.y;e.path.set(T({left:n,top:i},x.default.fObjectOptions.SELECTION_STYLE));var a=this.createObjectProperties(e.path);this.fire(S.ADD_OBJECT,a)}},{key:"_onSelectionCleared",value:function(){this.fire(S.SELECTION_CLEARED)}},{key:"_onSelectionCreated",value:function(e){this.fire(S.SELECTION_CREATED,e.target)}},{key:"discardSelection",value:function(){this._canvas.discardActiveObject(),this._canvas.renderAll()}},{key:"changeSelectableAll",value:function(t){this._canvas.forEachObject(function(e){e.selectable=t,e.hoverCursor=t?"move":"crosshair"})}},{key:"createObjectProperties",value:function(e){var t={id:P(e),type:e.type};return T(t,E.default.getProperties(e,["left","top","width","height","fill","stroke","strokeWidth","opacity"])),-1<["i-text","text"].indexOf(e.type)&&T(t,this._createTextProperties(e,t)),t}},{key:"_createTextProperties",value:function(e){var t={};return T(t,E.default.getProperties(e,["text","fontFamily","fontSize","fontStyle","textAlign","textDecoration"])),t}},{key:"_addFabricObject",value:function(e){var t=P(e);return this._objects[t]=e,t}},{key:"_removeFabricObject",value:function(e){delete this._objects[e]}}]),F);function F(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=t.cssMaxWidth,i=t.cssMaxHeight,a=t.useItext,o=void 0!==a&&a,r=t.useDragAddIcon,s=void 0!==r&&r;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,F),this.canvasImage=null,this.cssMaxWidth=n||1e3,this.cssMaxHeight=i||800,this.useItext=o,this.useDragAddIcon=s,this.cropSelectionStyle={},this.imageName="",this._objects={},this._canvas=null,this._drawingMode=j.NORMAL,this._drawingModeMap={},this._componentMap={},this._handler={onMouseDown:this._onMouseDown.bind(this),onObjectAdded:this._onObjectAdded.bind(this),onObjectRemoved:this._onObjectRemoved.bind(this),onObjectMoved:this._onObjectMoved.bind(this),onObjectScaled:this._onObjectScaled.bind(this),onObjectSelected:this._onObjectSelected.bind(this),onPathCreated:this._onPathCreated.bind(this),onSelectionCleared:this._onSelectionCleared.bind(this),onSelectionCreated:this._onSelectionCreated.bind(this)},this._setObjectCachingToFalse(),this._setCanvasElement(e),this._createDrawingModeInstances(),this._createComponents(),this._attachCanvasEvents()}L.mixin(z),e.exports=z},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(2)),r=l(n(8)),s=l(n(0));function l(e){return e&&e.__esModule?e:{default:e}}var c=s.default.componentNames,u=s.default.rejectMessages,d={padding:0,crossOrigin:"Anonymous"},h=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(f,r.default),i(f,[{key:"load",value:function(t,e){var n=this,i=void 0;if(t||e)i=this._setBackgroundImage(e).then(function(e){return n.setCanvasImage(t,e),n.adjustCanvasDimension(),e});else{var a=this.getCanvas();a.backgroundImage=null,a.renderAll(),i=new o.default(function(e){n.setCanvasImage("",null),e()})}return i}},{key:"_setBackgroundImage",value:function(e){var a=this;return e?new o.default(function(t,n){var i=a.getCanvas();i.setBackgroundImage(e,function(){var e=i.backgroundImage;e&&e.getElement()?t(e):n(u.loadingImageFailed)},d)}):o.default.reject(u.loadImage)}}]),f);function f(e){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,f),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(f.__proto__||Object.getPrototypeOf(f)).call(this,c.IMAGE_LOADER,e))}e.exports=h},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var h=c(n(1)),o=c(n(5)),r=c(n(8)),s=c(n(111)),l=n(0),f=n(4);function c(e){return e&&e.__esModule?e:{default:e}}var u={top:-10,left:-10,height:1,width:1},d=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(p,r.default),i(p,[{key:"start",value:function(){if(!this._cropzone){var e=this.getCanvas();e.forEachObject(function(e){e.evented=!1}),this._cropzone=new s.default(e,{left:0,top:0,width:.5,height:.5,strokeWidth:0,cornerSize:10,cornerColor:"black",fill:"transparent",hasRotatingPoint:!1,hasBorders:!1,lockScalingFlip:!0,lockRotation:!0},this.graphics.cropSelectionStyle),e.discardActiveObject(),e.add(this._cropzone),e.on("mouse:down",this._listeners.mousedown),e.selection=!1,e.defaultCursor="crosshair",o.default.util.addListener(document,"keydown",this._listeners.keydown),o.default.util.addListener(document,"keyup",this._listeners.keyup)}}},{key:"end",value:function(){var e=this.getCanvas(),t=this._cropzone;t&&(e.remove(t),e.selection=!0,e.defaultCursor="default",e.off("mouse:down",this._listeners.mousedown),e.forEachObject(function(e){e.evented=!0}),this._cropzone=null,o.default.util.removeListener(document,"keydown",this._listeners.keydown),o.default.util.removeListener(document,"keyup",this._listeners.keyup))}},{key:"changeVisibility",value:function(e){this._cropzone&&this._cropzone.set({visible:e})}},{key:"_onFabricMouseDown",value:function(e){var t=this.getCanvas();if(!e.target){t.selection=!1;var n=t.getPointer(e.e);this._startX=n.x,this._startY=n.y,t.on({"mouse:move":this._listeners.mousemove,"mouse:up":this._listeners.mouseup})}}},{key:"_onFabricMouseMove",value:function(e){var t=this.getCanvas(),n=t.getPointer(e.e),i=n.x,a=n.y,o=this._cropzone;10<Math.abs(i-this._startX)+Math.abs(a-this._startY)&&(t.remove(o),o.set(this._calcRectDimensionFromPoint(i,a)),t.add(o),t.setActiveObject(o))}},{key:"_calcRectDimensionFromPoint",value:function(e,t){var n=this.getCanvas(),i=n.getWidth(),a=n.getHeight(),o=this._startX,r=this._startY,s=(0,f.clamp)(e,0,o),l=(0,f.clamp)(t,0,r),c=(0,f.clamp)(e,o,i)-s,u=(0,f.clamp)(t,r,a)-l;return this._withShiftKey&&(u<c?u=c:c<u&&(c=u),e<=o&&(s=o-c),t<=r&&(l=r-u)),{left:s,top:l,width:c,height:u}}},{key:"_onFabricMouseUp",value:function(){var e=this._cropzone,t=this._listeners,n=this.getCanvas();n.setActiveObject(e),n.off({"mouse:move":t.mousemove,"mouse:up":t.mouseup})}},{key:"getCroppedImageData",value:function(e){var t=this.getCanvas(),n=t.contains(this._cropzone);if(!e)return null;n&&t.remove(this._cropzone);var i={imageName:this.getImageName(),url:t.toDataURL(e)};return n&&t.add(this._cropzone),i}},{key:"getCropzoneRect",value:function(){var e=this._cropzone;return e.isValid()?{left:e.left,top:e.top,width:e.width,height:e.height}:null}},{key:"setCropzoneRect",value:function(e){var t=this.getCanvas(),n=this._cropzone;t.discardActiveObject(),t.selection=!1,t.remove(n),n.set(e?this._getPresetCropSizePosition(e):u),t.add(n),t.selection=!0,e&&t.setActiveObject(n)}},{key:"_getPresetCropSizePosition",value:function(e){function t(e,t){return t<e?t/e:1}var n=this.getCanvas(),i=n.getWidth(),a=n.getHeight(),o=a<=i?i:a,r=o*e,s=o,l=t(r,i),c=h.default.map([r,s],function(e){return e*l});r=c[0];var u=t(s=c[1],a),d=h.default.map([r,s],function(e){return(0,f.fixFloatingPoint)(e*u)});return r=d[0],{top:(a-(s=d[1]))/2,left:(i-r)/2,width:r,height:s}}},{key:"_onKeyDown",value:function(e){e.keyCode===l.keyCodes.SHIFT&&(this._withShiftKey=!0)}},{key:"_onKeyUp",value:function(e){e.keyCode===l.keyCodes.SHIFT&&(this._withShiftKey=!1)}}]),p);function p(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,p);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(p.__proto__||Object.getPrototypeOf(p)).call(this,l.componentNames.CROPPER,e));return t._cropzone=null,t._startX=null,t._startY=null,t._withShiftKey=!1,t._listeners={keydown:t._onKeyDown.bind(t),keyup:t._onKeyUp.bind(t),mousedown:t._onFabricMouseDown.bind(t),mousemove:t._onFabricMouseMove.bind(t),mouseup:t._onFabricMouseUp.bind(t)},t}e.exports=d},function(e,t,n){"use strict";var c=a(n(1)),i=a(n(5)),s=n(4);function a(e){return e&&e.__esModule?e:{default:e}}var o=i.default.util.createClass(i.default.Rect,{initialize:function(e,t,n){(t=c.default.extend(t,n)).type="cropzone",this.callSuper("initialize",t),this.canvas=e,this.options=t,this.on({moving:this._onMoving.bind(this),scaling:this._onScaling.bind(this)})},_renderCropzone:function(e){var t=this.flipX?-1:1,n=this.flipY?-1:1,i=t/this.scaleX,a=n/this.scaleY;e.scale(i,a),this._fillOuterRect(e,"rgba(0, 0, 0, 0.5)"),this.options.lineWidth?(this._fillInnerRect(e),this._strokeBorder(e,"rgb(255, 255, 255)",{lineWidth:this.options.lineWidth})):(this._strokeBorder(e,"rgb(0, 0, 0)",{lineDashWidth:7}),this._strokeBorder(e,"rgb(255, 255, 255)",{lineDashWidth:7,lineDashOffset:7})),e.scale(1/i,1/a)},_render:function(e){this.callSuper("_render",e),this._renderCropzone(e)},_fillOuterRect:function(e,t){var n=this._getCoordinates(),i=n.x,a=n.y;e.save(),e.fillStyle=t,e.beginPath(),e.moveTo(i[0]-1,a[0]-1),e.lineTo(i[3]+1,a[0]-1),e.lineTo(i[3]+1,a[3]+1),e.lineTo(i[0]-1,a[3]+1),e.lineTo(i[0]-1,a[0]-1),e.closePath(),e.moveTo(i[1],a[1]),e.lineTo(i[1],a[2]),e.lineTo(i[2],a[2]),e.lineTo(i[2],a[1]),e.lineTo(i[1],a[1]),e.closePath(),e.fill(),e.restore()},_fillInnerRect:function(e){var t=this._getCoordinates(),n=t.x,i=t.y,a=this._caculateInnerPosition(n,(n[2]-n[1])/3),o=this._caculateInnerPosition(i,(i[2]-i[1])/3);e.save(),e.strokeStyle="rgba(255, 255, 255, 0.7)",e.lineWidth=this.options.lineWidth,e.beginPath(),e.moveTo(a[0],o[1]),e.lineTo(a[3],o[1]),e.moveTo(a[0],o[2]),e.lineTo(a[3],o[2]),e.moveTo(a[1],o[0]),e.lineTo(a[1],o[3]),e.moveTo(a[2],o[0]),e.lineTo(a[2],o[3]),e.stroke(),e.closePath(),e.restore()},_caculateInnerPosition:function(e,t){var n=[];return n[0]=e[1],n[1]=e[1]+t,n[2]=e[1]+2*t,n[3]=e[2],n},_getCoordinates:function(){var e=this.canvas,t=this.width,n=this.height,i=this.left,a=this.top,o=t/2,r=n/2,s=e.getHeight(),l=e.getWidth();return{x:c.default.map([-(o+i),-o,o,l-i-t+o],Math.ceil),y:c.default.map([-(r+a),-r,r,s-a-n+r],Math.ceil)}},_strokeBorder:function(e,t,n){var i=n.lineDashWidth,a=n.lineDashOffset,o=n.lineWidth,r=this.width/2,s=this.height/2;e.save(),e.strokeStyle=t,e.setLineDash&&e.setLineDash([i,i]),a&&(e.lineDashOffset=a),o&&(e.lineWidth=o),e.beginPath(),e.moveTo(-r,-s),e.lineTo(r,-s),e.lineTo(r,s),e.lineTo(-r,s),e.lineTo(-r,-s),e.stroke(),e.restore()},_onMoving:function(){var e=this.height,t=this.width,n=this.left,i=this.top,a=this.canvas.getWidth()-t,o=this.canvas.getHeight()-e;this.left=(0,s.clamp)(n,0,a),this.top=(0,s.clamp)(i,0,o)},_onScaling:function(e){var t=e.transform.corner,n=this.canvas.getPointer(e.e),i=this._calcScalingSizeFromPointer(n,t);this.scale(1).set(i)},_calcScalingSizeFromPointer:function(e,t){var n=e.x,i=e.y,a=this._calcTopLeftScalingSizeFromPointer(n,i),o=this._calcBottomRightScalingSizeFromPointer(n,i);return this._makeScalingSettings(a,o,t)},_calcTopLeftScalingSizeFromPointer:function(e,t){var n=this.getBoundingRect(!1,!0),i=n.height+this.top,a=n.width+this.left,o=(0,s.clamp)(t,0,i-1),r=(0,s.clamp)(e,0,a-1);return{top:o,left:r,width:a-r,height:i-o}},_calcBottomRightScalingSizeFromPointer:function(e,t){var n=this.canvas,i=n.width,a=n.height,o=this.left,r=this.top;return{width:(0,s.clamp)(e,o+1,i)-o,height:(0,s.clamp)(t,r+1,a)-r}},_makeScalingSettings:function(e,t,n){var i=e.width,a=e.height,o=t.height,r=t.width,s=e.left,l=e.top,c=void 0;switch(n){case"tl":c=e;break;case"tr":c={width:r,height:a,top:l};break;case"bl":c={width:i,height:o,left:s};break;case"br":c=t;break;case"ml":c={width:i,left:s};break;case"mt":c={height:a,top:l};break;case"mr":c={width:r};break;case"mb":c={height:o}}return c},isValid:function(){return 0<=this.left&&0<=this.top&&0<this.width&&0<this.height}});e.exports=o},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=c(n(1)),r=c(n(2)),s=c(n(8)),l=c(n(0));function c(e){return e&&e.__esModule?e:{default:e}}var u=l.default.componentNames,d=l.default.rejectMessages,h=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(f,s.default),i(f,[{key:"getCurrentSetting",value:function(){var e=this.getCanvasImage();return{flipX:e.flipX,flipY:e.flipY}}},{key:"set",value:function(e){var t=this.getCurrentSetting(),n=t.flipX!==e.flipX,i=t.flipY!==e.flipY;return n||i?(o.default.extend(t,e),this.setImageProperties(t,!0),this._invertAngle(n,i),this._flipObjects(n,i),r.default.resolve({flipX:t.flipX,flipY:t.flipY,angle:this.getCanvasImage().angle})):r.default.reject(d.flip)}},{key:"_invertAngle",value:function(e,t){var n=this.getCanvasImage(),i=n.angle;e&&(i*=-1),t&&(i*=-1),n.rotate(parseFloat(i)).setCoords()}},{key:"_flipObjects",value:function(e,t){var n=this.getCanvas();e&&n.forEachObject(function(e){e.set({angle:parseFloat(-1*e.angle),flipX:!e.flipX,left:n.width-e.left}).setCoords()}),t&&n.forEachObject(function(e){e.set({angle:parseFloat(-1*e.angle),flipY:!e.flipY,top:n.height-e.top}).setCoords()}),n.renderAll()}},{key:"reset",value:function(){return this.set({flipX:!1,flipY:!1})}},{key:"flipX",value:function(){var e=this.getCurrentSetting();return this.set({flipX:!e.flipX,flipY:e.flipY})}},{key:"flipY",value:function(){var e=this.getCurrentSetting();return this.set({flipX:e.flipX,flipY:!e.flipY})}}]),f);function f(e){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,f),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(f.__proto__||Object.getPrototypeOf(f)).call(this,u.FLIP,e))}e.exports=h},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var l=s(n(5)),o=s(n(2)),r=s(n(8));function s(e){return e&&e.__esModule?e:{default:e}}var c=s(n(0)).default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,r.default),i(d,[{key:"getCurrentAngle",value:function(){return this.getCanvasImage().angle}},{key:"setAngle",value:function(e){var t=this.getCurrentAngle()%360;e%=360;var n=this.getCanvasImage(),i=n.getCenterPoint();n.set({angle:e}).setCoords(),this.adjustCanvasDimension();var a=n.getCenterPoint();return this._rotateForEachObject(i,a,e-t),o.default.resolve(e)}},{key:"_rotateForEachObject",value:function(a,e,o){var t=this.getCanvas(),r=a.x-e.x,s=a.y-e.y;t.forEachObject(function(e){var t=e.getCenterPoint(),n=l.default.util.degreesToRadians(o),i=l.default.util.rotatePoint(t,a,n);e.set({left:i.x-r,top:i.y-s,angle:(e.angle+o)%360}),e.setCoords()}),t.renderAll()}},{key:"rotate",value:function(e){var t=this.getCurrentAngle();return this.setAngle(t+e)}}]),d);function d(e){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,c.ROTATION,e))}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(5)),r=l(n(8)),s=l(n(0));function l(e){return e&&e.__esModule?e:{default:e}}var c=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(u,r.default),i(u,[{key:"start",value:function(e){this.getCanvas().isDrawingMode=!0,this.setBrush(e)}},{key:"setBrush",value:function(e){var t=this.getCanvas().freeDrawingBrush;e=e||{},this.width=e.width||this.width,e.color&&(this.oColor=new o.default.Color(e.color)),t.width=this.width,t.color=this.oColor.toRgba()}},{key:"end",value:function(){this.getCanvas().isDrawingMode=!1}}]),u);function u(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,u);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,s.default.componentNames.FREE_DRAWING,e));return t.width=12,t.oColor=new o.default.Color("rgba(0, 0, 0, 0.5)"),t}e.exports=c},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(5)),r=l(n(8)),s=l(n(0));function l(e){return e&&e.__esModule?e:{default:e}}var c=s.default.eventNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,r.default),i(d,[{key:"start",value:function(e){var t=this.getCanvas();t.defaultCursor="crosshair",t.selection=!1,this.setBrush(e),t.forEachObject(function(e){e.set({evented:!1})}),t.on({"mouse:down":this._listeners.mousedown})}},{key:"setBrush",value:function(e){var t=this.getCanvas().freeDrawingBrush;e=e||{},this._width=e.width||this._width,e.color&&(this._oColor=new o.default.Color(e.color)),t.width=this._width,t.color=this._oColor.toRgba()}},{key:"end",value:function(){var e=this.getCanvas();e.defaultCursor="default",e.selection=!0,e.forEachObject(function(e){e.set({evented:!0})}),e.off("mouse:down",this._listeners.mousedown)}},{key:"_onFabricMouseDown",value:function(e){var t=this.getCanvas(),n=t.getPointer(e.e),i=[n.x,n.y,n.x,n.y];this._line=new o.default.Line(i,{stroke:this._oColor.toRgba(),strokeWidth:this._width,evented:!1}),this._line.set(s.default.fObjectOptions.SELECTION_STYLE),t.add(this._line),t.on({"mouse:move":this._listeners.mousemove,"mouse:up":this._listeners.mouseup})}},{key:"_onFabricMouseMove",value:function(e){var t=this.getCanvas(),n=t.getPointer(e.e);this._line.set({x2:n.x,y2:n.y}),this._line.setCoords(),t.renderAll()}},{key:"_onFabricMouseUp",value:function(){var e=this.getCanvas(),t=this.graphics.createObjectProperties(this._line);this.fire(c.ADD_OBJECT,t),this._line=null,e.off({"mouse:move":this._listeners.mousemove,"mouse:up":this._listeners.mouseup})}}]),d);function d(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,s.default.componentNames.LINE,e));return t._width=12,t._oColor=new o.default.Color("rgba(0, 0, 0, 0.5)"),t._listeners={mousedown:t._onFabricMouseDown.bind(t),mousemove:t._onFabricMouseMove.bind(t),mouseup:t._onFabricMouseUp.bind(t)},t}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var l=s(n(5)),c=s(n(1)),u=s(n(2)),o=s(n(8)),d=s(n(0)),r=s(n(4));function s(e){return e&&e.__esModule?e:{default:e}}var h=d.default.eventNames,f={fill:"#000000",left:0,top:0},p={fill:"#000000",fontStyle:"normal",fontWeight:"normal",textAlign:"left",textDecoration:"",underline:!1},g=c.default.browser,v=r.default.makeStyleText({position:"absolute",padding:0,display:"none",border:"1px dotted red",overflow:"hidden",resize:"none",outline:"none","border-radius":0,"background-color":"transparent","-webkit-appearance":"none","z-index":9999,"white-space":"pre"}),m=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(b,o.default),i(b,[{key:"start",value:function(){var e=this.getCanvas();e.selection=!1,e.defaultCursor="text",e.on({"mouse:down":this._listeners.mousedown,"object:selected":this._listeners.select,"before:selection:cleared":this._listeners.selectClear,"object:scaling":this._listeners.scaling,"text:editing":this._listeners.modify}),this.useItext?e.forEachObject(function(e){"i-text"===e.type&&e.set({left:e.left-e.width/2,top:e.top-e.height/2,originX:"left",originY:"top"})}):this._createTextarea(),this.setCanvasRatio()}},{key:"end",value:function(){var t=this.getCanvas();t.selection=!0,t.defaultCursor="default",this.useItext?t.forEachObject(function(e){"i-text"===e.type&&(""===e.text?t.remove(e):e.set({left:e.left+e.width/2,top:e.top+e.height/2,originX:"center",originY:"center"}))}):(t.discardActiveObject(),this._removeTextarea()),t.off({"mouse:down":this._listeners.mousedown,"object:selected":this._listeners.select,"before:selection:cleared":this._listeners.selectClear,"object:scaling":this._listeners.scaling,"text:editing":this._listeners.modify})}},{key:"add",value:function(o,r){var s=this;return new u.default(function(e){var t=s.getCanvas(),n=null,i=d.default.fObjectOptions.SELECTION_STYLE,a=s._defaultStyles;s._setInitPos(r.position),r.styles&&(a=c.default.extend(a,r.styles)),s.useItext?(n=new l.default.IText(o,a),i=c.default.extend({},i,{originX:"left",originY:"top"})):n=new l.default.Text(o,a),n.set(i),n.on({mouseup:s._onFabricMouseUp.bind(s)}),t.add(n),t.getActiveObject()||t.setActiveObject(n),s.isPrevEditing=!0,e(s.graphics.createObjectProperties(n))})}},{key:"change",value:function(t,n){var i=this;return new u.default(function(e){t.set("text",n),i.getCanvas().renderAll(),e()})}},{key:"setStyle",value:function(n,i){var t=this;return new u.default(function(e){c.default.forEach(i,function(e,t){n[t]===e&&(i[t]=p[t]||"")},t),n.set(i),t.getCanvas().renderAll(),e()})}},{key:"getText",value:function(e){return e.text}},{key:"setSelectedInfo",value:function(e,t){this._selectedObj=e,this._isSelected=t}},{key:"isSelected",value:function(){return this._isSelected}},{key:"getSelectedObj",value:function(){return this._selectedObj}},{key:"setCanvasRatio",value:function(){var e=this.getCanvasElement(),t=parseInt(e.style.maxWidth,10),n=e.width/t;this._ratio=n}},{key:"getCanvasRatio",value:function(){return this._ratio}},{key:"_setInitPos",value:function(e){e=e||this.getCanvasImage().getCenterPoint(),this._defaultStyles.left=e.x,this._defaultStyles.top=e.y}},{key:"_createTextarea",value:function(){var e=this.getCanvasElement().parentNode,t=document.createElement("textarea");t.className="tui-image-eidtor-textarea",t.setAttribute("style",v),t.setAttribute("wrap","off"),e.appendChild(t),this._textarea=t,this._listeners=c.default.extend(this._listeners,{input:this._onInput.bind(this),keydown:this._onKeyDown.bind(this),blur:this._onBlur.bind(this),scroll:this._onScroll.bind(this)}),g.msie&&9===g.version?l.default.util.addListener(t,"keydown",this._listeners.keydown):l.default.util.addListener(t,"input",this._listeners.input),l.default.util.addListener(t,"blur",this._listeners.blur),l.default.util.addListener(t,"scroll",this._listeners.scroll)}},{key:"_removeTextarea",value:function(){var e=this.getCanvasElement().parentNode,t=e.querySelector("textarea");e.removeChild(t),this._textarea=null,g.msie&&g.version<10?l.default.util.removeListener(t,"keydown",this._listeners.keydown):l.default.util.removeListener(t,"input",this._listeners.input),l.default.util.removeListener(t,"blur",this._listeners.blur),l.default.util.removeListener(t,"scroll",this._listeners.scroll)}},{key:"_onInput",value:function(){var e=this.getCanvasRatio(),t=this._editingObj,n=this._textarea.style;n.width=Math.ceil(t.width/e)+"px",n.height=Math.ceil(t.height/e)+"px"}},{key:"_onKeyDown",value:function(){var e=this,t=this.getCanvasRatio(),n=this._editingObj,i=this._textarea.style;setTimeout(function(){n.text(e._textarea.value),i.width=Math.ceil(n.width/t)+"px",i.height=Math.ceil(n.height/t)+"px"},0)}},{key:"_onBlur",value:function(){var e=this.getCanvasRatio(),t=this._editingObj,n=this._editingObjInfos,i=this._textarea.value,a=t.width/e-n.width/e,o=t.height/e-n.height/e;if(1===e&&(a/=2,o/=2),this._textarea.style.display="none",t.set({left:n.left+a,top:n.top+o}),i.length){this.getCanvas().add(t);var r={id:c.default.stamp(t),type:t.type,text:i};this.fire(h.TEXT_CHANGED,r)}}},{key:"_onScroll",value:function(){this._textarea.scrollLeft=0,this._textarea.scrollTop=0}},{key:"_onFabricScaling",value:function(e){var t=e.target,n=t.fontSize*t.scaleY;t.fontSize=n,t.scaleX=1,t.scaleY=1}},{key:"_onFabricSelectClear",value:function(e){var t=this.getSelectedObj();this.isPrevEditing=!0,this.setSelectedInfo(e.target,!1),t&&""===t.text&&this.getCanvas().remove(t)}},{key:"_onFabricSelect",value:function(e){this.isPrevEditing=!0,this.setSelectedInfo(e.target,!0)}},{key:"_onFabricMouseDown",value:function(e){var t=e.target;t&&!t.isType("text")||(this.isPrevEditing?this.isPrevEditing=!1:this._fireAddText(e))}},{key:"_fireAddText",value:function(e){var t=e.target,n=e.e||{},i=this.getCanvas().getPointer(n);t||this.fire(h.ADD_TEXT,{originPosition:{x:i.x,y:i.y},clientPosition:{x:n.clientX||0,y:n.clientY||0}})}},{key:"_onFabricMouseUp",value:function(e){var t=e.target,n=(new Date).getTime();(t.isEditing||this._isDoubleClick(n))&&(this.useItext||this._changeToEditingMode(t),this.fire(h.TEXT_EDITING)),this._lastClickTime=n}},{key:"_isDoubleClick",value:function(e){return e-this._lastClickTime<500}},{key:"_changeToEditingMode",value:function(e){var t=this.getCanvasRatio(),n=this._textarea.style,i=this.getCanvas();this.isPrevEditing=!0,i.remove(e),i.discardActiveObject(),this._editingObj=e,this._textarea.value=e.text,this._editingObjInfos={left:e.left,top:e.top,width:e.width,height:e.height},n.display="block",n.left=e.oCoords.tl.x/t+"px",n.top=e.oCoords.tl.y/t+"px",n.width=Math.ceil(e.width/t)+"px",n.height=Math.ceil(e.height/t)+"px",n.transform="rotate("+e.angle+"deg)",n.color=e.fill,n["font-size"]=e.fontSize/t+"px",n["font-family"]=e.fontFamily,n["font-style"]=e.fontStyle,n["font-weight"]=e.fontWeight,n["text-align"]=e.textAlign,n["line-height"]=e.lineHeight+.1,n["transform-origin"]="left top",this._textarea.focus()}}]),b);function b(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,b);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(b.__proto__||Object.getPrototypeOf(b)).call(this,d.default.componentNames.TEXT,e));return t._defaultStyles=f,t._isSelected=!1,t._selectedObj={},t._editingObj={},t._listeners={mousedown:t._onFabricMouseDown.bind(t),select:t._onFabricSelect.bind(t),selectClear:t._onFabricSelectClear.bind(t),scaling:t._onFabricScaling.bind(t)},t._textarea=null,t._ratio=1,t._lastClickTime=(new Date).getTime(),t._editingObjInfos={},t.isPrevEditing=!1,t.useItext=e.useItext,t}e.exports=m},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=l(n(5)),d=l(n(1)),r=l(n(2)),s=l(n(8)),h=l(n(0));function l(e){return e&&e.__esModule?e:{default:e}}var c=h.default.eventNames,f=h.default.rejectMessages,u={arrow:"M 0 90 H 105 V 120 L 160 60 L 105 0 V 30 H 0 Z",cancel:"M 0 30 L 30 60 L 0 90 L 30 120 L 60 90 L 90 120 L 120 90 L 90 60 L 120 30 L 90 0 L 60 30 L 30 0 Z"},p=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(g,s.default),i(g,[{key:"add",value:function(l,c){var u=this;return new r.default(function(e,t){var n=u.getCanvas(),i=u._pathMap[l],a=h.default.fObjectOptions.SELECTION_STYLE,o=0<=Object.keys(h.default.defaultIconPath).indexOf(l),r=u.useDragAddIcon&&o,s=i?u._createIcon(i):null;s||t(f.invalidParameters),s.set(d.default.extend({type:"icon",fill:u._oColor},a,c,u.graphics.controlStyle)),n.add(s).setActiveObject(s),r&&u._addWithDragEvent(n),e(u.graphics.createObjectProperties(s))})}},{key:"_addWithDragEvent",value:function(t){var n=this;t.on({"mouse:move":function(e){t.selection=!1,n.fire(c.ICON_CREATE_RESIZE,{moveOriginPointer:t.getPointer(e.e)})},"mouse:up":function(e){n.fire(c.ICON_CREATE_END,{moveOriginPointer:t.getPointer(e.e)}),t.defaultCursor="default",t.off("mouse:up"),t.off("mouse:move"),t.selection=!0}})}},{key:"registerPaths",value:function(e){var n=this;d.default.forEach(e,function(e,t){n._pathMap[t]=e},this)}},{key:"setColor",value:function(e,t){this._oColor=e,t&&"icon"===t.get("type")&&(t.set({fill:this._oColor}),this.getCanvas().renderAll())}},{key:"getColor",value:function(e){return e.fill}},{key:"_createIcon",value:function(e){return new o.default.Path(e)}}]),g);function g(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,g);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(g.__proto__||Object.getPrototypeOf(g)).call(this,h.default.componentNames.ICON,e));return t._oColor="#000000",t._pathMap=u,t.useDragAddIcon=e.useDragAddIcon,t}e.exports=p},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=n(1),l=g(n(2)),r=g(n(5)),s=g(n(8)),c=g(n(119)),u=g(n(0)),d=g(n(120)),h=g(n(121)),f=g(n(122)),p=g(n(123));function g(e){return e&&e.__esModule?e:{default:e}}var v=u.default.rejectMessages,m=r.default.Image.filters;m.Mask=c.default,m.Blur=d.default,m.Sharpen=h.default,m.Emboss=f.default,m.ColorFilter=p.default;var b=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(y,s.default),i(y,[{key:"add",value:function(o,r){var s=this;return new l.default(function(e,t){var n=s._getSourceImage(),i=s.getCanvas(),a=s._getFilter(n,o);(a=a||s._createFilter(n,o,r))||t(v.invalidParameters),s._changeFilterValues(a,r),s._apply(n,function(){i.renderAll(),e({type:o,action:"add"})})})}},{key:"remove",value:function(a){var o=this;return new l.default(function(e,t){var n=o._getSourceImage(),i=o.getCanvas();n.filters.length||t(v.unsupportedOperation),o._removeFilter(n,a),o._apply(n,function(){i.renderAll(),e({type:a,action:"remove"})})})}},{key:"hasFilter",value:function(e){return!!this._getFilter(this._getSourceImage(),e)}},{key:"getOptions",value:function(e){var t=this._getSourceImage(),n=this._getFilter(t,e);return n?(0,o.extend)({},n.options):null}},{key:"_changeFilterValues",value:function(n,i){(0,o.forEach)(i,function(e,t){(0,o.isUndefined)(n[t])||(n[t]=e)}),(0,o.forEach)(n.options,function(e,t){(0,o.isUndefined)(i[t])||(n.options[t]=i[t])})}},{key:"_apply",value:function(e,t){e.filters.push(),e.applyFilters()&&t()}},{key:"_getSourceImage",value:function(){return this.getCanvasImage()}},{key:"_createFilter",value:function(e,t,n){var i=void 0,a=this._getFabricFilterType(t),o=r.default.Image.filters[a];return o&&((i=new o(n)).options=n,e.filters.push(i)),i}},{key:"_getFilter",value:function(e,t){var n=null;if(e){var i=this._getFabricFilterType(t),a=e.filters.length,o=void 0,r=void 0;for(r=0;r<a;r+=1)if((o=e.filters[r]).type===i){n=o;break}}return n}},{key:"_removeFilter",value:function(e,t){var n=this._getFabricFilterType(t);e.filters=(0,o.filter)(e.filters,function(e){return e.type!==n})}},{key:"_getFabricFilterType",value:function(e){return e.charAt(0).toUpperCase()+e.slice(1)}}]),y);function y(e){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,y),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(y.__proto__||Object.getPrototypeOf(y)).call(this,u.default.componentNames.FILTER,e))}e.exports=b},function(e,t,n){"use strict";var i,a=n(5),o=(i=a)&&i.__esModule?i:{default:i};var r=o.default.util.createClass(o.default.Image.filters.BlendImage,{applyTo:function(e){if(this.mask){var t=e.canvasEl,n=t.width,i=t.height,a=this._createCanvasOfMask(n,i),o=t.getContext("2d"),r=a.getContext("2d"),s=o.getImageData(0,0,n,i);this._drawMask(r,t,o),this._mapData(r,s,n,i),e.imageData=s}},_createCanvasOfMask:function(e,t){var n=o.default.util.createCanvasElement();return n.width=e,n.height=t,n},_drawMask:function(e){var t=this.mask,n=t.getElement(),i=t.angle,a=t.left,o=t.scaleX,r=t.scaleY,s=t.top;e.save(),e.translate(a,s),e.rotate(i*Math.PI/180),e.scale(o,r),e.drawImage(n,-n.width/2,-n.height/2),e.restore()},_mapData:function(e,t,n,i){for(var a=t.data,o=t.height,r=a,s=t.width*o*4,l=e.getImageData(0,0,n,i).data,c=0;c<s;c+=4)r[c+3]=l[c]}});e.exports=r},function(e,t,n){"use strict";var i,a=n(5),o=(i=a)&&i.__esModule?i:{default:i};var r=o.default.util.createClass(o.default.Image.filters.Convolute,{type:"Blur",initialize:function(){this.matrix=[1/9,1/9,1/9,1/9,1/9,1/9,1/9,1/9,1/9]}});e.exports=r},function(e,t,n){"use strict";var i,a=n(5),o=(i=a)&&i.__esModule?i:{default:i};var r=o.default.util.createClass(o.default.Image.filters.Convolute,{type:"Sharpen",initialize:function(){this.matrix=[0,-1,0,-1,5,-1,0,-1,0]}});e.exports=r},function(e,t,n){"use strict";var i,a=n(5),o=(i=a)&&i.__esModule?i:{default:i};var r=o.default.util.createClass(o.default.Image.filters.Convolute,{type:"Emboss",initialize:function(){this.matrix=[1,1,1,1,.7,-1,-1,-1,-1]}});e.exports=r},function(e,t,n){"use strict";var i,a=n(5),c=(i=a)&&i.__esModule?i:{default:i};var o=c.default.util.createClass(c.default.Image.filters.BaseFilter,{type:"ColorFilter",initialize:function(e){e=e||{},this.color=e.color||"#FFFFFF",this.threshold=e.threshold||45,this.x=e.x||null,this.y=e.y||null},applyTo:function(e){var t,n=e.canvasEl,i=n.getContext("2d"),a=i.getImageData(0,0,n.width,n.height),o=a.data,r=this.threshold,s=c.default.Color.sourceFromHex(this.color),l=void 0;for(this.x&&this.y&&(s=this._getColor(a,this.x,this.y)),l=0,t=o.length;l<t;l+=4)this._isOutsideThreshold(o[l],s[0],r)||this._isOutsideThreshold(o[l+1],s[1],r)||this._isOutsideThreshold(o[l+2],s[2],r)||(o[l]=o[l+1]=o[l+2]=o[l+3]=0);i.putImageData(a,0,0)},_isOutsideThreshold:function(e,t,n){var i=e-t;return Math.abs(i)>n},_getColor:function(e,t,n){var i=[0,0,0,0],a=e.data,o=4*(e.width*n+t);return i[0]=a[o],i[1]=a[1+o],i[2]=a[2+o],i[3]=a[3+o],i}});e.exports=o},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=d(n(5)),r=d(n(2)),s=d(n(8)),l=d(n(0)),c=d(n(125)),u=n(1);function d(e){return e&&e.__esModule?e:{default:e}}var h=l.default.rejectMessages,f=l.default.eventNames,p=l.default.keyCodes,g={strokeWidth:1,stroke:"#000000",fill:"#ffffff",width:1,height:1,rx:0,ry:0,lockSkewingX:!0,lockSkewingY:!0,lockUniScaling:!1,bringForward:!0,isRegular:!1},v=["rect","circle","triangle"],m=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(b,s.default),i(b,[{key:"start",value:function(){var e=this.getCanvas();this._isSelected=!1,e.defaultCursor="crosshair",e.selection=!1,e.uniScaleTransform=!0,e.on({"mouse:down":this._handlers.mousedown}),o.default.util.addListener(document,"keydown",this._handlers.keydown),o.default.util.addListener(document,"keyup",this._handlers.keyup)}},{key:"end",value:function(){var e=this.getCanvas();this._isSelected=!1,e.defaultCursor="default",e.selection=!0,e.uniScaleTransform=!1,e.off({"mouse:down":this._handlers.mousedown}),o.default.util.removeListener(document,"keydown",this._handlers.keydown),o.default.util.removeListener(document,"keyup",this._handlers.keyup)}},{key:"setStates",value:function(e,t){this._type=e,t&&(this._options=(0,u.extend)(this._options,t))}},{key:"add",value:function(i,a){var o=this;return new r.default(function(e){var t=o.getCanvas();a=o._extendOptions(a);var n=o._createInstance(i,a);o._bindEventOnShape(n),t.add(n).setActiveObject(n),e(o.graphics.createObjectProperties(n))})}},{key:"change",value:function(n,i){var a=this;return new r.default(function(e,t){(0,u.inArray)(n.get("type"),v)<0&&t(h.unsupportedType),n.set(i),a.getCanvas().renderAll(),e()})}},{key:"_createInstance",value:function(e,t){var n=void 0;switch(e){case"rect":n=new o.default.Rect(t);break;case"circle":n=new o.default.Ellipse((0,u.extend)({type:"circle"},t));break;case"triangle":n=new o.default.Triangle(t);break;default:n={}}return n}},{key:"_extendOptions",value:function(e){var t=l.default.fObjectOptions.SELECTION_STYLE;return(e=(0,u.extend)({},g,this._options,t,e)).isRegular&&(e.lockUniScaling=!0),e}},{key:"_bindEventOnShape",value:function(e){var i=this,a=this.getCanvas();e.on({added:function(){i._shapeObj=this,c.default.setOrigins(i._shapeObj)},selected:function(){i._isSelected=!0,i._shapeObj=this,a.uniScaleTransform=!0,a.defaultCursor="default",c.default.setOrigins(i._shapeObj)},deselected:function(){i._isSelected=!1,i._shapeObj=null,a.defaultCursor="crosshair",a.uniScaleTransform=!1},modified:function(){var e=i._shapeObj;c.default.adjustOriginToCenter(e),c.default.setOrigins(e)},scaling:function(e){var t=a.getPointer(e.e),n=i._shapeObj;a.setCursor("crosshair"),c.default.resize(n,t,!0)}})}},{key:"_onFabricMouseDown",value:function(e){if(e.target||(this._isSelected=!1,this._shapeObj=!1),!this._isSelected&&!this._shapeObj){var t=this.getCanvas();this._startPoint=t.getPointer(e.e),t.on({"mouse:move":this._handlers.mousemove,"mouse:up":this._handlers.mouseup})}}},{key:"_onFabricMouseMove",value:function(e){var t=this,n=this.getCanvas(),i=n.getPointer(e.e),a=this._startPoint.x,o=this._startPoint.y,r=a-i.x,s=o-i.y,l=this._shapeObj;l?(this._shapeObj.set({isRegular:this._withShiftKey}),c.default.resize(l,i),n.renderAll()):this.add(this._type,{left:a,top:o,width:r,height:s}).then(function(e){t.fire(f.ADD_OBJECT,e)})}},{key:"_onFabricMouseUp",value:function(){var t=this,e=this.getCanvas(),n=this._startPoint.x,i=this._startPoint.y,a=this._shapeObj;a?a&&(c.default.adjustOriginToCenter(a),this.fire(f.ADD_OBJECT_AFTER,this.graphics.createObjectProperties(a))):this.add(this._type,{left:n,top:i,width:20,height:20}).then(function(e){t.fire(f.ADD_OBJECT,e)}),e.off({"mouse:move":this._handlers.mousemove,"mouse:up":this._handlers.mouseup})}},{key:"_onKeyDown",value:function(e){e.keyCode===p.SHIFT&&(this._withShiftKey=!0,this._shapeObj&&(this._shapeObj.isRegular=!0))}},{key:"_onKeyUp",value:function(e){e.keyCode===p.SHIFT&&(this._withShiftKey=!1,this._shapeObj&&(this._shapeObj.isRegular=!1))}}]),b);function b(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,b);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(b.__proto__||Object.getPrototypeOf(b)).call(this,l.default.componentNames.SHAPE,e));return t._shapeObj=null,t._type="rect",t._options=(0,u.extend)({},g),t._isSelected=!1,t._startPoint={},t._withShiftKey=!1,t._handlers={mousedown:t._onFabricMouseDown.bind(t),mousemove:t._onFabricMouseMove.bind(t),mouseup:t._onFabricMouseUp.bind(t),keydown:t._onKeyDown.bind(t),keyup:t._onKeyUp.bind(t)},t}e.exports=m},function(e,t,n){"use strict";var R={rect:1,circle:2,triangle:1},D={rect:{w:"width",h:"height"},circle:{w:"rx",h:"ry"},triangle:{w:"width",h:"height"}};function L(e,t,n){var i=e.x,a=e.y,o=t.x,r=t.y,s=n*Math.PI/180;return{originX:(o-i)*Math.cos(s)-(r-a)*Math.sin(s)+i<i?"right":"left",originY:(o-i)*Math.sin(s)+(r-a)*Math.cos(s)+a<a?"bottom":"top"}}e.exports={setOrigins:function(e){var t=e.getPointByOrigin("left","top"),n=e.getPointByOrigin("right","top"),i=e.getPointByOrigin("right","bottom"),a=e.getPointByOrigin("left","bottom");e.origins={lt:t,rt:n,rb:i,lb:a}},resize:function(e,t,n){var i,a,o,r,s,l,c,u,d,h,f,p,g,v,m,b,y,_,k,w,x,E,C,O,S,j,M,T,P,A,I;"center"===(v=e).originX&&"center"===v.originY&&(s=t,c=(l=e).getPointByOrigin("center","center"),u=L(c,s,-l.angle),d=u.originX,h=u.originY,f=l.getPointByOrigin(d,h),p=l.left-(c.x-f.x),g=l.top-(c.y-f.y),l.set({originX:d,originY:h,left:p,top:g}),l.setCoords(),a=(i=e).originX,o=i.originY,r=a.substring(0,1)+o.substring(0,1),i.startPoint=i.origins[r]),n?function(e){var t=e.type,n=e.scaleX,i=e.scaleY,a=D[t],o=e[a.w]*n,r=e[a.h]*i;if(e.isRegular){var s=Math.max(n,i);o=e[a.w]*s,r=e[a.h]*s}var l={hasControls:!1,hasBorders:!1,scaleX:1,scaleY:1};l[a.w]=o,l[a.h]=r,e.set(l)}(e):(m=t,y=(b=e).type,_=b.strokeWidth,k=b.startPoint,w=R[y],x=D[y],E=!("triangle"!==b.type),C={},O=Math.abs(k.x-m.x)/w,S=Math.abs(k.y-m.y)/w,_<O&&(O-=_/w),_<S&&(S-=_/w),b.isRegular&&(O=S=Math.max(O,S),E&&(S=Math.sqrt(3)/2*O)),C[x.w]=O,C[x.h]=S,b.set(C)),j=t,T=(M=e).startPoint,P=L(T,j,-M.angle),A=P.originX,I=P.originY,M.setPositionByOrigin(T,A,I),M.setCoords()},adjustOriginToCenter:function(e){var t=e.getPointByOrigin("center","center"),n=e.originX,i=e.originY,a=e.getPointByOrigin(n,i),o=e.left+(t.x-a.x),r=e.top+(t.y-a.y);e.set({hasControls:!0,hasBorders:!0,originX:"center",originY:"center",left:o,top:r}),e.setCoords()}}},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(17)),r=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=r.default.drawingModes,c=r.default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,o.default),i(d,[{key:"start",value:function(e){e.getComponent(c.CROPPER).start()}},{key:"end",value:function(e){e.getComponent(c.CROPPER).end()}}]),d);function d(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,l.CROPPER))}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(17)),r=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=r.default.drawingModes,c=r.default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,o.default),i(d,[{key:"start",value:function(e,t){e.getComponent(c.FREE_DRAWING).start(t)}},{key:"end",value:function(e){e.getComponent(c.FREE_DRAWING).end()}}]),d);function d(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,l.FREE_DRAWING))}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(17)),r=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=r.default.drawingModes,c=r.default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,o.default),i(d,[{key:"start",value:function(e,t){e.getComponent(c.LINE).start(t)}},{key:"end",value:function(e){e.getComponent(c.LINE).end()}}]),d);function d(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,l.LINE_DRAWING))}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(17)),r=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=r.default.drawingModes,c=r.default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,o.default),i(d,[{key:"start",value:function(e){e.getComponent(c.SHAPE).start()}},{key:"end",value:function(e){e.getComponent(c.SHAPE).end()}}]),d);function d(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,l.SHAPE))}e.exports=u},function(e,t,n){"use strict";var i=function(e,t,n){return t&&a(e.prototype,t),n&&a(e,n),e};function a(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var o=s(n(17)),r=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=r.default.drawingModes,c=r.default.componentNames,u=(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(d,o.default),i(d,[{key:"start",value:function(e){e.getComponent(c.TEXT).start()}},{key:"end",value:function(e){e.getComponent(c.TEXT).end()}}]),d);function d(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(d.__proto__||Object.getPrototypeOf(d)).call(this,l.TEXT))}e.exports=u},function(e,t,n){},function(e,t,n){"use strict";var i=r(n(3)),a=r(n(2)),o=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=o.default.componentNames,l=o.default.commandNames,c=s.ICON,u={name:l.ADD_ICON,execute:function(t,e,n){var i=this;return t.getComponent(c).add(e,n).then(function(e){return i.undoData.object=t.getObject(e.id),e})},undo:function(e){return e.remove(this.undoData.object),a.default.resolve()}};i.default.register(u),e.exports=u},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(2));function o(e){return e&&e.__esModule?e:{default:e}}var r={name:o(n(0)).default.commandNames.ADD_IMAGE_OBJECT,execute:function(t,e){var n=this;return t.addImageObject(e).then(function(e){return n.undoData.object=t.getObject(e.id),e})},undo:function(e){return e.remove(this.undoData.object),a.default.resolve()}};i.default.register(r),e.exports=r},function(e,t,n){"use strict";var i=r(n(3)),a=r(n(2)),o=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=o.default.commandNames,l=o.default.rejectMessages,c={name:s.ADD_OBJECT,execute:function(n,i){return new a.default(function(e,t){n.contains(i)?t(l.addedObject):(n.add(i),e(i))})},undo:function(n,i){return new a.default(function(e,t){n.contains(i)?(n.remove(i),e(i)):t(l.noObject)})}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var i=r(n(3)),a=r(n(2)),o=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=o.default.componentNames,l=o.default.commandNames,c=s.SHAPE,u={name:l.ADD_SHAPE,execute:function(t,e,n){var i=this;return t.getComponent(c).add(e,n).then(function(e){return i.undoData.object=t.getObject(e.id),e})},undo:function(e){return e.remove(this.undoData.object),a.default.resolve()}};i.default.register(u),e.exports=u},function(e,t,n){"use strict";var i=r(n(3)),a=r(n(2)),o=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=o.default.componentNames,l=o.default.commandNames,c=s.TEXT,u={name:l.ADD_TEXT,execute:function(t,e,n){var i=this;return t.getComponent(c).add(e,n).then(function(e){return i.undoData.object=t.getObject(e.id),e})},undo:function(e){return e.remove(this.undoData.object),a.default.resolve()}};i.default.register(u),e.exports=u},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,s=a.default.rejectMessages,l=a.default.commandNames,c=r.FILTER,u={name:l.APPLY_FILTER,execute:function(e,t,n){var i=e.getComponent(c);if("mask"===t){var a=e.getObject(n.maskObjId);if(!a||!a.isType("image"))return Promise.reject(s.invalidParameters);n={mask:a}}return"mask"===t?(this.undoData.object=n.mask,e.remove(n.mask)):this.undoData.options=i.getOptions(t),i.add(t,n)},undo:function(e,t){var n=e.getComponent(c);if("mask"!==t)return this.undoData.options?n.add(t,this.undoData.options):n.remove(t);var i=this.undoData.object;return e.add(i),e.setActiveObject(i),n.remove(t)}};i.default.register(u),e.exports=u},function(e,t,n){"use strict";var i=o(n(3)),l=o(n(2)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,c=a.default.rejectMessages,s=a.default.commandNames,u=r.ICON,d={name:s.CHANGE_ICON_COLOR,execute:function(a,o,r){var s=this;return new l.default(function(e,t){var n=a.getComponent(u),i=a.getObject(o);i||t(c.noObject),s.undoData.object=i,s.undoData.color=n.getColor(i),n.setColor(r,i),e()})},undo:function(e){var t=e.getComponent(u),n=this.undoData.object,i=n.object,a=n.color;return t.setColor(a,i),l.default.resolve()}};i.default.register(d),e.exports=d},function(e,t,n){"use strict";var r=o(n(1)),i=o(n(3)),s=o(n(2)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var l=a.default.componentNames,c=a.default.rejectMessages,u=a.default.commandNames,d=l.SHAPE,h={name:u.CHANGE_SHAPE,execute:function(e,t,n){var i=this,a=e.getComponent(d),o=e.getObject(t);return o?(this.undoData.object=o,this.undoData.options={},r.default.forEachOwnProperties(n,function(e,t){i.undoData.options[t]=o[t]}),a.change(o,n)):s.default.reject(c.noObject)},undo:function(e){var t=e.getComponent(d),n=this.undoData,i=n.object,a=n.options;return t.change(i,a)}};i.default.register(h),e.exports=h},function(e,t,n){"use strict";var i=r(n(3)),o=r(n(2)),a=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=a.default.componentNames,l=a.default.rejectMessages,c=a.default.commandNames,u=s.TEXT,d={name:c.CHANGE_TEXT,execute:function(e,t,n){var i=e.getComponent(u),a=e.getObject(t);return a?(this.undoData.object=a,this.undoData.text=i.getText(a),i.change(a,n)):o.default.reject(l.noObject)},undo:function(e){var t=e.getComponent(u),n=this.undoData,i=n.object,a=n.text;return t.change(i,a)}};i.default.register(d),e.exports=d},function(e,t,n){"use strict";var r=o(n(1)),i=o(n(3)),s=o(n(2)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var l=a.default.componentNames,c=a.default.rejectMessages,u=a.default.commandNames,d=l.TEXT,h={name:u.CHANGE_TEXT_STYLE,execute:function(e,t,n){var i=this,a=e.getComponent(d),o=e.getObject(t);return o?(this.undoData.object=o,this.undoData.styles={},r.default.forEachOwnProperties(n,function(e,t){i.undoData.styles[t]=o[t]}),a.setStyle(o,n)):s.default.reject(c.noObject)},undo:function(e){var t=e.getComponent(d),n=this.undoData,i=n.object,a=n.styles;return t.setStyle(i,a)}};i.default.register(h),e.exports=h},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(2));function o(e){return e&&e.__esModule?e:{default:e}}var r={name:o(n(0)).default.commandNames.CLEAR_OBJECTS,execute:function(t){var n=this;return new a.default(function(e){n.undoData.objects=t.removeAll(),e()})},undo:function(e){return e.add(this.undoData.objects),a.default.resolve()}};i.default.register(r),e.exports=r},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,s=a.default.commandNames,l=r.FLIP,c={name:s.FLIP_IMAGE,execute:function(e,t){var n=e.getComponent(l);return this.undoData.setting=n.getCurrentSetting(),n[t]()},undo:function(e){return e.getComponent(l).set(this.undoData.setting)}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,s=a.default.commandNames,l=r.IMAGE_LOADER,c={name:s.LOAD_IMAGE,execute:function(e,t,n){var i=e.getComponent(l),a=i.getCanvasImage(),o=a?a.width:0,r=a?a.height:0,s=e.removeAll(!0).filter(function(e){return"cropzone"!==e.type});return s.forEach(function(e){e.evented=!0}),this.undoData={name:i.getImageName(),image:a,objects:s},i.load(t,n).then(function(e){return{oldWidth:o,oldHeight:r,newWidth:e.width,newHeight:e.height}})},undo:function(e){var t=e.getComponent(l),n=this.undoData,i=n.objects,a=n.name,o=n.image;return e.removeAll(!0),e.add(i),t.load(a,o)}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,s=a.default.commandNames,l=r.FILTER,c={name:s.REMOVE_FILTER,execute:function(e,t){var n=e.getComponent(l);return this.undoData.options=n.getOptions(t),n.remove(t)},undo:function(e,t){var n=e.getComponent(l),i=this.undoData.options;return n.add(t,i)}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var i=r(n(3)),o=r(n(2)),a=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=a.default.commandNames,l=a.default.rejectMessages,c={name:s.REMOVE_OBJECT,execute:function(n,i){var a=this;return new o.default(function(e,t){a.undoData.objects=n.removeObjectById(i),a.undoData.objects.length?e():t(l.noObject)})},undo:function(e){return e.add(this.undoData.objects),o.default.resolve()}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(2));function o(e){return e&&e.__esModule?e:{default:e}}var r={name:o(n(0)).default.commandNames.RESIZE_CANVAS_DIMENSION,execute:function(t,n){var i=this;return new a.default(function(e){i.undoData.size={width:t.cssMaxWidth,height:t.cssMaxHeight},t.setCssMaxDimension(n),t.adjustCanvasDimension(),e()})},undo:function(e){return e.setCssMaxDimension(this.undoData.size),e.adjustCanvasDimension(),a.default.resolve()}};i.default.register(r),e.exports=r},function(e,t,n){"use strict";var i=o(n(3)),a=o(n(0));function o(e){return e&&e.__esModule?e:{default:e}}var r=a.default.componentNames,s=a.default.commandNames,l=r.ROTATION,c={name:s.ROTATE_IMAGE,execute:function(e,t,n,i){var a=e.getComponent(l);return i||(this.undoData.angle=a.getCurrentAngle()),a[t](n)},undo:function(e){var t=e.getComponent(l),n=this.args,i=n[1],a=n[2];return"setAngle"===i?t[i](this.undoData.angle):t.rotate(-a)}};i.default.register(c),e.exports=c},function(e,t,n){"use strict";var o=s(n(1)),i=s(n(3)),r=s(n(2)),a=s(n(0));function s(e){return e&&e.__esModule?e:{default:e}}var l=a.default.commandNames,c=a.default.rejectMessages,u={name:l.SET_OBJECT_PROPERTIES,execute:function(e,t,n){var i=this,a=e.getObject(t);return a?(this.undoData.props={},o.default.forEachOwnProperties(n,function(e,t){i.undoData.props[t]=a[t]}),e.setObjectProperties(t,n),r.default.resolve()):r.default.reject(c.noObject)},undo:function(e,t){var n=this.undoData.props;return e.setObjectProperties(t,n),r.default.resolve()}};i.default.register(u),e.exports=u},function(e,t,n){"use strict";var i=r(n(3)),a=r(n(2)),o=r(n(0));function r(e){return e&&e.__esModule?e:{default:e}}var s=o.default.commandNames,l=o.default.rejectMessages,c={name:s.SET_OBJECT_POSITION,execute:function(e,t,n){return e.getObject(t)?(this.undoData.objectId=t,this.undoData.props=e.getObjectProperties(t,["left","top"]),e.setObjectPosition(t,n),e.renderAll(),a.default.resolve()):a.default.reject(l.noObject)},undo:function(e){var t=this.undoData,n=t.objectId,i=t.props;return e.setObjectProperties(n,i),e.renderAll(),a.default.resolve()}};i.default.register(c),e.exports=c}],o.c=s,o.d=function(e,t,n){o.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:n})},o.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},o.t=function(t,e){if(1&e&&(t=o(t)),8&e)return t;if(4&e&&"object"==typeof t&&t&&t.__esModule)return t;var n=Object.create(null);if(o.r(n),Object.defineProperty(n,"default",{enumerable:!0,value:t}),2&e&&"string"!=typeof t)for(var i in t)o.d(n,i,function(e){return t[e]}.bind(null,i));return n},o.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return o.d(t,"a",t),t},o.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},o.p="/dist",o(o.s=43);function o(e){if(s[e])return s[e].exports;var t=s[e]={i:e,l:!1,exports:{}};return r[e].call(t.exports,t,t.exports,o),t.l=!0,t.exports}var r,s});